<?php

if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}

if ( class_exists( 'Redux' ) ) {

    if ( ! function_exists( 'styler_dynamic_section' ) ) {
        function styler_dynamic_section($sections)
        {
            global $styler_pre;

            $el_args = array(
                'post_type'      => 'elementor_library',
                'posts_per_page' => -1,
                'orderby'        => 'title',
                'order'          => 'ASC',
                'tax_query' => array(
                    array(
                        'taxonomy' => 'elementor_library_type',
                        'field'    => 'slug',
                        'terms'    => 'section'
                    )
                )
            );

            // create sections in the theme options
            $sections[] = array(
                'title' => esc_html__('Shop Page', 'styler'),
                'id' => 'shopsection',
                'icon' => 'el el-shopping-cart-sign',
            );
            // SHOP PAGE SECTION
            $sections[] = array(
                'title' => esc_html__( 'Shop Page Layout', 'styler' ),
                'id' => 'shoplayoutsection',
                'subsection'=> true,
                'icon' => 'el el-website',
                'fields' => array(
                    array(
                        'title' => esc_html__('Ajax Shop', 'styler'),
                        'subtitle' => esc_html__('You can enable or disable the site shop page hero section with switch option.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_ajax_filter',
                        'type' => 'switch',
                        'default' => 1
                    ),
                    array(
                        'title' => esc_html__('Ajax Login/Register', 'styler'),
                        'subtitle' => esc_html__('You can enable or disable the site shop page hero section with switch option.', 'styler'),
                        'customizer' => true,
                        'id' => 'wc_ajax_login_register',
                        'type' => 'switch',
                        'default' => 1
                    ),
                    array(
                        'id' =>'shop_layout',
                        'type' => 'button_set',
                        'title' => esc_html__( 'Shop Layouts', 'styler' ),
                        'subtitle' => esc_html__( 'Organize how you want the layout to appear on the theme shop page sidebar area.', 'styler' ),
                        'options' => array(
                            'top-sidebar' => esc_html__( 'Top Hidden Sidebar', 'styler' ),
                            'fixed-sidebar' => esc_html__( 'Left Fixed Sidebar', 'styler' ),
                            'left-sidebar' => esc_html__( 'Left Sidebar', 'styler' ),
                            'right-sidebar' => esc_html__( 'Right Sidebar', 'styler' ),
                            'no-sidebar' => esc_html__( 'No Sidebar', 'styler' )
                        ),
                        'default' => 'fixed-sidebar',
                    ),
                    array(
                        'title' => esc_html__('Choosen Filters', 'styler'),
                        'subtitle' => esc_html__('You can enable or disable the filters selected before the loop.', 'styler'),
                        'customizer' => true,
                        'id' => 'choosen_filters_before_loop',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array(
                            array( 'shop_layout', '!=', 'top-sidebar' ),
                            array( 'shop_layout', '!=', 'top-sidebar' ),
                            array( 'shop_layout', '!=', 'no-sidebar' )
                        )
                    ),
                    array(
                        'id' =>'shop_grid_type',
                        'type' => 'button_set',
                        'title' => esc_html__( 'Shop Grid Type', 'decoraty' ),
                        'options' => array(
                            'grid' => esc_html__( 'Default Grid', 'decoraty' ),
                            'masonry' => esc_html__( 'Masonry', 'decoraty' )
                        ),
                        'default' => 'grid',
                        'required' => array(
                            array( 'shop_layout', '!=', 'left-sidebar' ),
                            array( 'shop_layout', '!=', 'right-sidebar' )
                        )
                    ),
                    array(
                        'id' =>'shop_masonry_column',
                        'type' => 'button_set',
                        'title' => esc_html__( 'Shop Masonry Column Width', 'decoraty' ),
                        'subtitle' => esc_html__( 'Select your shop masonry type column width', 'decoraty' ),
                        'options' => array(
                            '3' => esc_html__( '3 Column', 'decoraty' ),
                            '4' => esc_html__( '4 Column', 'decoraty' ),
                            '5' => esc_html__( '5 Column', 'decoraty' ),
                            '6' => esc_html__( '6 Column', 'decoraty' ),
                        ),
                        'default' => '4',
                        'required' => array(
                            array( 'shop_layout', '!=', 'left-sidebar' ),
                            array( 'shop_layout', '!=', 'right-sidebar' ),
                            array( 'shop_grid_type', '=', 'masonry' )
                        )
                    ),
                    array(
                        'id' =>'shop_hidden_sidebar_column',
                        'type' => 'button_set',
                        'title' => esc_html__( 'Hidden Sidebar Widget Column Width', 'styler' ),
                        'subtitle' => esc_html__( 'Select your shop sidebar widget column width', 'styler' ),
                        'options' => array(
                            '1' => esc_html__( '1 Column', 'styler' ),
                            '2' => esc_html__( '2 Column', 'styler' ),
                            '3' => esc_html__( '3 Column', 'styler' ),
                            '4' => esc_html__( '4 Column', 'styler' ),
                            '5' => esc_html__( '5 Column', 'styler' ),
                        ),
                        'default' => '3',
                        'required' => array( 'shop_layout', '=', 'top-sidebar' )
                    ),
                    array(
                        'id' =>'shop_loop_filters_layouts',
                        'type' => 'sorter',
                        'title' => esc_html__( 'Shop Filter Area Layouts Manager', 'styler' ),
                        'subtitle' => esc_html__( 'Organize how you want the layout to appear on the theme shop page filter area.', 'styler' ),
                        'options' => array(
                            'left' => array(
                                'breadcrumbs' => esc_html__( 'Breadcrumbs', 'styler' ),
                            ),
                            'right' => array(
                                'sidebar-filter' => esc_html__( 'Sidebar Toggle', 'styler' ),
                                'per-page' => esc_html__( 'Perpage Selection', 'styler' ),
                                'column-select' => esc_html__( 'Column Selection', 'styler' ),
                                'ordering' => esc_html__( 'Ordering', 'styler' )
                            ),
                            'hide' => array(
                                'result-count' => esc_html__( 'Result Count', 'styler' ),
                                'search' => esc_html__( 'Search Popup', 'styler' ),
                            )
                        )
                    ),
                    array(
                        'title' => esc_html__('Per Page Select Options', 'styler'),
                        'subtitle' => esc_html__('Separate each number with a comma.For example: 12,24,36', 'styler'),
                        'customizer' => true,
                        'id' => 'per_page_select_options',
                        'type' => 'text',
                        'default' => '9,12,18,24'
                    ),
                    array(
                        'id' =>'shop_paginate_type',
                        'type' => 'button_set',
                        'title' => esc_html__('Pagination Type', 'styler'),
                        'subtitle' => esc_html__('Select your pagination type.', 'styler'),
                        'options' => array(
                            'pagination' => esc_html__('Default Pagination', 'styler'),
                            'ajax-pagination' => esc_html__('Ajax Pagination', 'styler'),
                            'loadmore' => esc_html__('Ajax Load More', 'styler'),
                            'infinite' => esc_html__('Ajax Infinite Scroll', 'styler')
                        ),
                        'default' => 'ajax-pagination',
                        'required' => array( 'shop_ajax_filter', '=', '1' )
                    ),
                    array(
                        'id' =>'shop_container_width',
                        'type' => 'select',
                        'title' => esc_html__( 'Container Width', 'styler' ),
                        'subtitle' => esc_html__( 'Select your header background type.', 'styler' ),
                        'customizer' => true,
                        'options' => array(
                            'default' => esc_html__( 'Deafult ( theme Content Width from Main settings )', 'styler' ),
                            'stretch' => esc_html__( 'Stretch', 'styler' ),
                        ),
                        'default' => 'default'
                    )
                )
            );
            // SINGLE HERO SUBSECTION
            $sections[] = array(
                'title' => esc_html__('Shop Page Header', 'styler'),
                'desc' => esc_html__('These are shop page header section settings', 'styler'),
                'id' => 'shopheadersubsection',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'title' => esc_html__('Use Different Header Layouts', 'styler'),
                        'subtitle' => esc_html__('You can use different header layouts type on shop pages.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_different_header_layouts',
                        'type' => 'switch',
                        'default' => 0
                    ),
                    array(
                        'id' =>'shop_header_layouts',
                        'type' => 'sorter',
                        'title' => esc_html__( 'Shop Header Layout Manager', 'styler' ),
                        'subtitle' => esc_html__( 'Organize how you want the layout to appear on the theme header', 'styler' ),
                        'options' => array(
                            'left' => array(
                                'sidemenu' => esc_html__( 'Sidemenu Toggle', 'styler' ),
                                'logo' => esc_html__( 'Logo', 'styler' )
                            ),
                            'center'=> array(
                                'menu' => esc_html__( 'Main Menu', 'styler' )
                            ),
                            'right'=> array(
                                'search' => esc_html__( 'Search', 'styler' ),
                                'buttons' => esc_html__( 'Buttons', 'styler' )
                            ),
                            'hide'  => array(
                                'center-logo' => esc_html__( 'Menu Logo Menu', 'styler' ),
                                'mini-menu' => esc_html__( 'Mini Menu', 'styler' ),
                                'double-menu' => esc_html__( 'Double Menu', 'styler' ),
                                'custom-html' => esc_html__( 'Phone Number', 'styler' )
                            )
                        ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_layouts', '=', '1' )
                        )
                    ),
                    array(
                        'id' =>'shop_header_buttons_layouts',
                        'type' => 'sorter',
                        'title' => esc_html__( 'Shop Header Buttons Manager', 'styler' ),
                        'subtitle' => esc_html__( 'Organize how you want the layout to appear on the theme header for buttons', 'styler' ),
                        'options' => array(
                            'show'  => array(
                                'cart' => esc_html__( 'Cart', 'styler' ),
                                'wishlist' => esc_html__( 'Wishlist', 'styler' ),
                                'compare' => esc_html__( 'Compare', 'styler' ),
                                'account' => esc_html__( 'Account', 'styler' )
                            ),
                            'hide'  => array(
                                'search' => esc_html__( 'Search', 'styler' )
                            )
                        ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_layouts', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Use Different Header Background Type', 'styler'),
                        'subtitle' => esc_html__('You can use different header background type on product page.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_different_header_bg_type',
                        'type' => 'switch',
                        'default' => 0
                    ),
                    array(
                        'id' => 'shop_header_menu_items_customize_start',
                        'type' => 'section',
                        'title' => esc_html__('Header Customize Options', 'styler'),
                        'customizer' => true,
                        'indent' => true,
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'id' =>'shop_header_bg_type',
                        'type' => 'button_set',
                        'title' => esc_html__( 'Header Background Type', 'styler' ),
                        'subtitle' => esc_html__( 'Select your header background type.', 'styler' ),
                        'customizer' => true,
                        'options' => array(
                            'default' => esc_html__( 'Deafult', 'styler' ),
                            'dark' => esc_html__( 'Dark', 'styler' ),
                            'trans-light' => esc_html__( 'Transparent Light', 'styler' ),
                            'trans-dark' => esc_html__( 'Transparent Dark', 'styler' )
                        ),
                        'default' => 'default',
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Header Background Color', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_header_bg',
                        'type' => 'color_rgba',
                        'mode' => 'background-color',
                        'output' => array( '.archive.post-type-archive-product header.styler-header-default,.archive.post-type-archive-product.has-default-header-type-trans:not(.scroll-start) header.styler-header-default' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Menu Item Color', 'styler' ),
                        'desc' => esc_html__( 'Set your own hover color for the navigation menu item.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_nav_a',
                        'type' => 'color',
                        'validate' => 'color',
                        'output' => array( '.archive.post-type-archive-product .styler-header-top-menu-area>ul>li.menu-item>a,.archive.post-type-archive-product.has-default-header-type-trans:not(.scroll-start) header.styler-header-default .styler-header-top-menu-area>ul>li.menu-item>a' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Menu Item Color ( Hover and Active )', 'styler' ),
                        'desc' => esc_html__( 'Set your own hover color for the navigation menu item.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_nav_hvr_a',
                        'type' => 'color',
                        'validate' => 'color',
                        'output' => array( '.archive.post-type-archive-product .current-menu-parent>a,.archive.post-type-archive-product .current-menu-item>a,.archive.post-type-archive-product .styler-header-top-menu-area>ul>li.menu-item>a:hover,.archive.post-type-archive-product .styler-header-top-menu-area ul li .submenu>li.menu-item>a:hover,.archive.post-type-archive-product.has-default-header-type-trans:not(.scroll-start) header.styler-header-default .current-menu-parent>a,.archive.post-type-archive-product.has-default-header-type-trans:not(.scroll-start) header.styler-header-default .current-menu-item>a,.archive.post-type-archive-product.has-default-header-type-trans:not(.scroll-start) header.styler-header-default .styler-header-top-menu-area>ul>li.menu-item>a:hover,.archive.post-type-archive-product.has-default-header-type-trans:not(.scroll-start) header.styler-header-default .styler-header-top-menu-area ul li .submenu>li.menu-item>a:hover'),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Sticky Header Background Color', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_nav_top_sticky_bg',
                        'type' => 'color_rgba',
                        'mode' => 'background-color',
                        'output' => array( '.archive.post-type-archive-product.has-sticky-header.scroll-start header.styler-header-default' ),
                        'required' => array( 'header_sticky_visibility', '=', '1' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Sticky Menu Item Color', 'styler' ),
                        'desc' => esc_html__( 'Set your own hover color for the sticky navigation menu item.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_sticky_nav_a',
                        'type' => 'color',
                        'validate' => 'color',
                        'output' => array( '.archive.post-type-archive-product.has-sticky-header.scroll-start .styler-header-top-menu-area>ul>li.menu-item>a' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Sticky Menu Item Color ( Hover and Active )', 'styler' ),
                        'desc' => esc_html__( 'Set your own hover color for the sticky navigation menu item.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_sticky_nav_hvr_a',
                        'type' => 'color',
                        'validate' => 'color',
                        'output' => array( '.archive.post-type-archive-product.has-sticky-header.scroll-start .current-menu-parent>a, .archive.post-type-archive-product.has-sticky-header.scroll-start .current-menu-item>a, .archive.post-type-archive-product.has-sticky-header.scroll-start .styler-header-top-menu-area>ul>li.menu-item>a:hover, .archive.post-type-archive-product.has-sticky-header.scroll-start .styler-header-top-menu-area ul li .submenu>li.menu-item>a:hover' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'id' => 'shop_header_menu_items_style_end',
                        'type' => 'section',
                        'customizer' => true,
                        'indent' => false,
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'id' => 'shop_header_submenu_items_style_start',
                        'type' => 'section',
                        'title' => esc_html__('Header Sub Menu Customize Options', 'styler'),
                        'customizer' => true,
                        'indent' => true,
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Sub Menu Background Color', 'styler' ),
                        'desc' => esc_html__( 'Set your own hover color for the sticky navigation sub menu item.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_nav_submenu_bg',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'validate' => 'color',
                        'output' => array( '.archive.post-type-archive-product .styler-header-top-menu-area ul li .submenu' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Menu Item Color', 'styler' ),
                        'desc' => esc_html__( 'Set your own hover color for the sticky navigation sub menu item.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_nav_submenu_a',
                        'type' => 'color',
                        'validate' => 'color',
                        'output' => array( '.archive.post-type-archive-product .styler-header-top-menu-area ul li .submenu>li.menu-item>a' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Menu Item Color ( Hover and Active )', 'styler' ),
                        'desc' => esc_html__( 'Set your own hover color for the sticky navigation sub menu item.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_nav_submenu_hvr_a',
                        'type' => 'color',
                        'validate' => 'color',
                        'output' => array( '.archive.post-type-archive-product .styler-header-top-menu-area ul li .submenu>li.menu-item>a:hover,.archive.post-type-archive-product .styler-header-top-menu-area ul li .submenu>li.menu-item.active>a' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'id' => 'shop_header_submenu_items_style_end',
                        'type' => 'section',
                        'customizer' => true,
                        'indent' => false,
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'id' => 'shop_header_svgbuttons_items_style_start',
                        'type' => 'section',
                        'title' => esc_html__('Header SVG Buttons Customize Options', 'styler'),
                        'customizer' => true,
                        'indent' => true,
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'SVG Icon Color', 'styler' ),
                        'desc' => esc_html__( 'Cart, Wishlist, Compare, Account, Search, Sidemenu bar', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_header_buttons_svg_color',
                        'type' => 'color',
                        'mode' => 'fill',
                        'validate' => 'color',
                        'output' => array( '.archive.post-type-archive-product .styler-header-default .header-top-buttons .top-action-btn,.archive.post-type-archive-product.has-default-header-type-trans:not(.scroll-start) header.styler-header-default .header-top-buttons .top-action-btn' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Button Counter Background Color', 'styler' ),
                        'desc' => esc_html__( 'Cart, Wishlist, Compare', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_header_buttons_counter_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'validate' => 'color',
                        'output' => array( '.archive.post-type-archive-product .styler-header-default .styler-wc-count,.archive.post-type-archive-product.has-default-header-type-trans:not(.scroll-start) header.styler-header-default .styler-wc-count' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Button Counter Color', 'styler' ),
                        'desc' => esc_html__( 'Cart, Wishlist, Compare', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_header_buttons_counter_color',
                        'type' => 'color',
                        'validate' => 'color',
                        'output' => array( '.archive.post-type-archive-product .styler-header-default .styler-wc-count,.archive.post-type-archive-product.has-default-header-type-trans:not(.scroll-start) header.styler-header-default .styler-wc-count' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Sticky Header SVG Icon Color', 'styler' ),
                        'desc' => esc_html__( 'Cart, Wishlist, Compare, Account, Search, Sidemenu bar', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_sticky_header_buttons_svg_color',
                        'type' => 'color',
                        'mode' => 'fill',
                        'validate' => 'color',
                        'output' => array( '.archive.post-type-archive-product.scroll-start .styler-header-default .header-top-buttons .top-action-btn,.archive.post-type-archive-product.has-default-header-type-trans.scroll-start header.styler-header-default .header-top-buttons .top-action-btn' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Sticky Header Button Counter Background Color', 'styler' ),
                        'desc' => esc_html__( 'Cart, Wishlist, Compare', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_sticky_header_buttons_counter_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'validate' => 'color',
                        'output' => array( '.archive.post-type-archive-product.scroll-start .styler-header-default .styler-wc-count,.archive.post-type-archive-product.has-default-header-type-trans.scroll-start header.styler-header-default .styler-wc-count' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Sticky Header Button Counter Color', 'styler' ),
                        'desc' => esc_html__( 'Cart, Wishlist, Compare', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_sticky_header_buttons_counter_color',
                        'type' => 'color',
                        'validate' => 'color',
                        'output' => array( '.archive.post-type-archive-product.scroll-start .styler-header-default .styler-wc-count,.archive.post-type-archive-product.has-default-header-type-trans.scroll-start header.styler-header-default .styler-wc-count' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'id' => 'shop_header_svgbuttons_items_style_end',
                        'type' => 'section',
                        'customizer' => true,
                        'indent' => false,
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'shop_different_header_bg_type', '=', '1' )
                        )
                    )
                )
            );
            // SINGLE HERO SUBSECTION
            $sections[] = array(
                'title' => esc_html__('Shop Page Hero', 'styler'),
                'desc' => esc_html__('These are shop page hero section settings', 'styler'),
                'id' => 'shopherosubsection',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'title' => esc_html__('Hero display', 'styler'),
                        'subtitle' => esc_html__('You can enable or disable the site shop page hero section with switch option.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_hero_visibility',
                        'type' => 'switch',
                        'default' => 1
                    ),
                    array(
                        'title' => esc_html__('Custom Page Title', 'styler'),
                        'subtitle' => esc_html__('Add your shop page custom title here.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_title',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'shop_hero_visibility', '=', '1' ),
                            array( 'shop_hero_type', '=', 'default' )
                        )
                    ),
                    array(
                        'id' =>'shop_hero_type',
                        'type' => 'button_set',
                        'title' => esc_html__('Shop Hero Type', 'styler'),
                        'subtitle' => esc_html__('Select your pagination type.', 'styler'),
                        'options' => array(
                            'default' => esc_html__('Default Hero', 'styler'),
                            'elementor' => esc_html__('Elementor Templates', 'styler'),
                        ),
                        'default' => 'default',
                        'required' => array( 'shop_hero_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__( 'Elementor Templates', 'styler' ),
                        'subtitle' => esc_html__( 'Select a template from elementor templates.If you want to show the theme default hero template please leave a blank.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_hero_elementor_templates',
                        'type' => 'select',
                        'customizer' => true,
                        'data' => 'posts',
                        'args' => $el_args,
                        'required' => array(
                            array( 'shop_hero_visibility', '=', '1' ),
                            array( 'shop_hero_type', '=', 'elementor' ),
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Category Pages Hero Elementor Templates', 'styler' ),
                        'subtitle' => esc_html__( 'Select a template from elementor templates.If you want to show the theme default hero template please leave a blank.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_cats_hero_elementor_templates',
                        'type' => 'select',
                        'customizer' => true,
                        'data' => 'posts',
                        'args' => $el_args,
                        'required' => array( 'shop_hero_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__( 'Tags Pages Elementor Templates', 'styler' ),
                        'subtitle' => esc_html__( 'Select a template from elementor templates.If you want to show the theme default hero template please leave a blank.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_tax_hero_elementor_templates',
                        'type' => 'select',
                        'customizer' => true,
                        'data' => 'posts',
                        'args' => $el_args,
                        'required' => array( 'shop_hero_visibility', '=', '1' )
                    ),
                    array(
                        'id' =>'shop_hero_layout_type',
                        'type' => 'button_set',
                        'title' => esc_html__( 'Default Hero Layouts', 'styler' ),
                        'subtitle' => esc_html__( 'Select how you want the layout to appear on the theme shop page sidebar area.', 'styler' ),
                        'options' => array(
                            'mini' => esc_html__( 'Title + Breadcrumbs', 'styler' ),
                            'small' => esc_html__( 'Title Center', 'styler' ),
                            'big' => esc_html__( 'Title + Categories', 'styler' ),
                            'cat-slider' => esc_html__( 'Title + Categories Slider', 'styler' ),
                        ),
                        'default' => 'mini',
                        'required' => array(
                            array( 'shop_hero_visibility', '=', '1' ),
                            array( 'shop_hero_type', '=', 'default' ),
                        )
                    ),
                    array(
                        'title' => esc_html__('Show Only Parent Categories', 'styler'),
                        'subtitle' => esc_html__('Enable this option if you want to show only parent categories.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_hero_only_cats_parents',
                        'type' => 'switch',
                        'default' => 0,
                        'required' => array(
                            array( 'shop_hero_visibility', '=', '1' ),
                            array( 'shop_hero_layout_type', '!=', 'mini' ),
                            array( 'shop_hero_layout_type', '!=', 'small' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Hero Customize Options', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_hero_customize_section_start',
                        'type' => 'section',
                        'indent' => true,
                        'required' => array(
                            array( 'shop_hero_visibility', '=', '1' ),
                            array( 'shop_hero_type', '=', 'default' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Hero Background', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_hero_bg',
                        'type' => 'background',
                        'output' => array( '#nt-shop-page .styler-page-hero' ),
                        'required' => array(
                            array( 'shop_hero_visibility', '=', '1' ),
                            array( 'shop_hero_type', '=', 'default' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Hero height', 'styler' ),
                        'subtitle' => esc_html__( 'Set the logo width and height of the image.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_hero_height',
                        'type' => 'dimensions',
                        'width' => false,
                        'output' => array( '#nt-shop-page .styler-page-hero' ),
                        'required' => array(
                            array( 'shop_hero_visibility', '=', '1' ),
                            array( 'shop_hero_type', '=', 'default' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Hero Background Image for Tablet', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_hero_tablet_bg',
                        'type' => 'media',
                        'url' => true,
                        'customizer' => true,
                        'required' => array(
                            array( 'shop_hero_visibility', '=', '1' ),
                            array( 'shop_hero_type', '=', 'default' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Hero height ( Tablet )', 'styler' ),
                        'subtitle' => esc_html__( 'Set the hero height for mobile device.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_hero_tablet_height',
                        'type' => 'dimensions',
                        'width' => false,
                        'required' => array(
                            array( 'shop_hero_visibility', '=', '1' ),
                            array( 'shop_hero_type', '=', 'default' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Hero Background Image for Phone', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_hero_mobile_bg',
                        'type' => 'media',
                        'url' => true,
                        'customizer' => true,
                        'required' => array(
                            array( 'shop_hero_visibility', '=', '1' ),
                            array( 'shop_hero_type', '=', 'default' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Hero height ( Phone )', 'styler' ),
                        'subtitle' => esc_html__( 'Set the hero height for mobile device.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_hero_mobile_height',
                        'type' => 'dimensions',
                        'width' => false,
                        'required' => array(
                            array( 'shop_hero_visibility', '=', '1' ),
                            array( 'shop_hero_type', '=', 'default' )
                        )
                    ),
                    array(
                        'customizer' => true,
                        'id' => 'shop_hero_customize_section_end',
                        'type' => 'section',
                        'indent' => false,
                        'required' => array(
                            array( 'shop_hero_visibility', '=', '1' ),
                            array( 'shop_hero_type', '=', 'default' )
                        )
                    )
                )
            );
            // SINGLE CONTENT SUBSECTION
            $sections[] = array(
                'title' => esc_html__('Shop Page Content', 'styler'),
                'id' => 'shopcontentsubsection',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'title' => esc_html__( 'Product Box Pre-layouts', 'styler' ),
                        'subtitle' => esc_html__( 'Choose the your product box type.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_product_type',
                        'type' => 'image_select',
                        'width' => '175',
                        'options' => array(
                            '1' => array(
                                'title' => 'Type 1',
                                'img' => get_template_directory_uri() . '/inc/core/theme-options/img/style-1.png',
                            ),
                            '2' => array(
                                'title' => 'Type 2',
                                'img' => get_template_directory_uri() . '/inc/core/theme-options/img/style-2.png',
                            ),
                            '3' => array(
                                'title' => 'Type 3',
                                'img' => get_template_directory_uri() . '/inc/core/theme-options/img/style-3.png',
                            ),
                            '4' => array(
                                'title' => 'Type 4',
                                'img' => get_template_directory_uri() . '/inc/core/theme-options/img/style-4.png',
                            ),
                            '5' => array(
                                'title' => 'Type 5',
                                'img' => get_template_directory_uri() . '/inc/core/theme-options/img/style-5.png',
                            ),
                            '6' => array(
                                'title' => 'Type 6',
                                'img' => get_template_directory_uri() . '/inc/core/theme-options/img/style-6.png',
                            ),
                            'custom' => array(
                                'title' => 'Custom',
                                'img' => get_template_directory_uri() . '/inc/core/theme-options/img/product1.png',
                            ),
                        ),
                        'default' => '1'
                    ),
                    array(
                        'id' =>'shop_loop_product_layouts',
                        'type' => 'sorter',
                        'title' => esc_html__( 'Custom Product Layouts', 'styler' ),
                        'subtitle' => esc_html__( 'Organize how you want the layout to appear on the shop loop product item.', 'styler' ),
                        'options' => array(
                            'show'  => array(
                                'thumb' => esc_html__( 'Image', 'styler' ),
                                'price-rating' => esc_html__( 'Price + Rating', 'styler' ),
                                'title-cart-hover' => esc_html__( 'Title + Add to Cart Hover', 'styler' ),
                                'buttons-hover' => esc_html__( 'Buttons Hover', 'styler' ),
                                'sale-discount' => esc_html__( 'Sale + Discount ( Top )', 'styler' ),
                                'stock' => esc_html__( 'Stock Status', 'styler' ),
                            ),
                            'hide'  => array(
                                'thumb-overlay' => esc_html__( 'Image + Image overlay', 'styler' ),
                                'gallery' => esc_html__( 'Slider Images', 'styler' ),
                                'title' => esc_html__( 'Title', 'styler' ),
                                'title-price' => esc_html__( 'Title + Price', 'styler' ),
                                'title-rating' => esc_html__( 'Title + Rating', 'styler' ),
                                'title-buttons-hover' => esc_html__( 'Title + Buttons Hover', 'styler' ),
                                'title-buttons-static' => esc_html__( 'Title + Buttons Static', 'styler' ),
                                'title-stock' => esc_html__( 'Title + Stock Status', 'styler' ),
                                'title-discount' => esc_html__( 'Title + Discount', 'styler' ),
                                'price' => esc_html__( 'Price', 'styler' ),
                                'price-text' => esc_html__( 'Price + Text', 'styler' ),
                                'price-stock' => esc_html__( 'Price + Stock', 'styler' ),
                                'price-buttons' => esc_html__( 'Price + Buttons', 'styler' ),
                                'price-cart-hover' => esc_html__( 'Price + Add to Cart Hover', 'styler' ),
                                'rating' => esc_html__( 'Rating Static', 'styler' ),
                                'rating-top' => esc_html__( 'Rating Top', 'styler' ),
                                'buttons-static' => esc_html__( 'Buttons Static', 'styler' ),
                                'cart' => esc_html__( 'Add to Cart Static', 'styler' ),
                                'cart-buttons' => esc_html__( 'Add to Cart + Buttons', 'styler' ),
                                'swatches' => esc_html__( 'Swatches Static', 'styler' ),
                                'swatches-hover' => esc_html__( 'Swatches Hover', 'styler' ),
                                'discount' => esc_html__( 'Discount', 'styler' ),
                                'sale' => esc_html__( 'Sale Label', 'styler' ),
                                'text' => esc_html__( 'Custom text', 'styler' ),
                            )
                        ),
                        'required' => array('shop_product_type', '=', 'custom' )
                    ),
                    array(
                        'id' =>'shop_loop_product_buttons_layouts',
                        'type' => 'sorter',
                        'title' => esc_html__( 'Custom Product Buttons Layouts', 'styler' ),
                        'subtitle' => esc_html__( 'Organize how you want the layout to appear on the shop loop product item buttons.', 'styler' ),
                        'options' => array(
                            'show'  => array(
                                'quickview' => esc_html__( 'Quick View', 'styler' ),
                                'compare' => esc_html__( 'Compare', 'styler' ),
                                'wishlist' => esc_html__( 'Wishlist', 'styler' ),
                            ),
                            'hide'  => array()
                        ),
                        'required' => array('shop_product_type', '=', 'custom' )
                    ),
                    array(
                        'title' => esc_html__('Post Column', 'styler'),
                        'subtitle' => esc_html__('You can control post column with this option.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_colxl',
                        'type' => 'slider',
                        'default' => 5,
                        'min' => 1,
                        'step' => 1,
                        'max' => 6,
                        'display_value' => 'text'
                    ),
                    array(
                        'title' => esc_html__('Post 992px Column ( Responsive: Desktop, Tablet )', 'styler'),
                        'subtitle' => esc_html__('You can control post column on max-device width 992px with this option.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_collg',
                        'type' => 'slider',
                        'default' =>3,
                        'min' => 1,
                        'step' => 1,
                        'max' => 4,
                        'display_value' => 'text'
                    ),
                    array(
                        'title' => esc_html__('Post 768px Column ( Responsive: Tablet, Phone )', 'styler'),
                        'subtitle' => esc_html__('You can control post column on max-device-width 768px with this option.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_colsm',
                        'type' => 'slider',
                        'default' =>2,
                        'min' => 1,
                        'step' => 1,
                        'max' => 3,
                        'display_value' => 'text'
                    ),
                    array(
                        'title' => esc_html__('Post 480px Column ( Responsive: Phone )', 'styler'),
                        'subtitle' => esc_html__('You can control post column on max-device-width 768px with this option.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_colxs',
                        'type' => 'slider',
                        'default' =>2,
                        'min' => 1,
                        'step' => 1,
                        'max' => 2,
                        'display_value' => 'text'
                    ),
                    array(
                        'title' => esc_html__('Post Count for Per Page', 'styler'),
                        'subtitle' => esc_html__('You can control show post count with this option.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_perpage',
                        'type' => 'slider',
                        'default' => 10,
                        'min' => 1,
                        'step' => 1,
                        'max' => 100,
                        'display_value' => 'text'
                    ),
                    array(
                        'title' => esc_html__('Use WooCommerce Product Images Customize Settings', 'styler'),
                        'subtitle' => esc_html__('if you want to set the product image size by WooCommerce Customize settings you can enable this option.', 'styler'),
                        'customizer' => true,
                        'id' => 'use_wc_image_sizes',
                        'type' => 'switch',
                        'default' => 0
                    ),
                    array(
                        'title' => esc_html__( 'Post Image Size', 'styler' ),
                        'customizer' => true,
                        'id' => 'product_imgsize',
                        'type' => 'select',
                        'data' => 'image_sizes',
                        'required' => array( 'use_wc_image_sizes', '!=', '1' ),
                    ),
                    array(
                        'title' => esc_html__('Custom Product Image Size', 'styler'),
                        'subtitle' => esc_html__('if you want to set the product image custom size you can enable this option.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_loop_custom_image_size',
                        'type' => 'switch',
                        'default' => 0,
                        'required' => array( 'use_wc_image_sizes', '!=', '1' ),
                    ),
                    array(
                        'title' => esc_html__('Dimensions', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_loop_custom_image_dimensions',
                        'type' => 'dimensions',
                        'units' => false,
                        'required' => array(
                            array( 'use_wc_image_sizes', '!=', '1' ),
                            array( 'shop_loop_custom_image_size', '=', '1' )
                        ),
                    ),
                    array(
                        'title' => esc_html__('Always keep this size', 'styler'),
                        'subtitle' => esc_html__('Preserves your image size while filtering your products by the number of columns on your store page', 'styler'),
                        'customizer' => true,
                        'id' => 'keep_image_size',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array( 'use_wc_image_sizes', '!=', '1' ),
                    ),
                    array(
                        'title' => esc_html__( 'Page Content Padding', 'styler' ),
                        'subtitle' => esc_html__( 'You can set the top spacing of the site shop page content.', 'styler' ),
                        'customizer' => true,
                        'id' =>'shop_content_pad',
                        'type' => 'spacing',
                        'output' => array('#nt-shop-page .nt-styler-inner-container'),
                        'mode' => 'padding',
                        'units' => array('em', 'px'),
                        'units_extended' => 'false'
                    ),
                    array(
                        'title' => esc_html__( 'Excerpt Size (for Shop page list type)', 'styler' ),
                        'subtitle' => esc_html__( 'You can control blog post excerpt size with this option.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_loop_excerpt_limit',
                        'type' => 'slider',
                        'default' => 17,
                        'min' => 0,
                        'step' => 1,
                        'max' => 300,
                        'display_value' => 'text'
                    ),
                    array(
                        'title' => esc_html__('Shop List Type Column for Per Row', 'styler'),
                        'subtitle' => esc_html__('You can control post column with this option for shop list type.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_list_type_colxl',
                        'type' => 'slider',
                        'default' => 2,
                        'min' => 1,
                        'step' => 1,
                        'max' => 3,
                        'display_value' => 'text'
                    ),
                )
            );
            // SINGLE CONTENT SUBSECTION
            $sections[] = array(
                'title' => esc_html__('Shop Elementor Template', 'styler'),
                'id' => 'shopaftercontentsubsection',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'title' => esc_html__( 'Before Shop Content Elementor Templates', 'styler' ),
                        'subtitle' => esc_html__( 'Select a template from elementor templates, If you want to show any content after hero section.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_before_content_templates',
                        'type' => 'select',
                        'data' => 'posts',
                        'args' => $el_args,
                        'required' => array(
                            array( 'shop_layout', '=', 'left-sidebar' ),
                            array( 'shop_layout', '=', 'right-sidebar' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Before Loop Elementor Templates', 'styler' ),
                        'subtitle' => esc_html__( 'Select a template from elementor templates, If you want to show any content before products loop.Note:This option is only compatible with shop left sidebar and right sidebar layouts.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_before_loop_templates',
                        'type' => 'select',
                        'data' => 'posts',
                        'args' => $el_args
                    ),
                    array(
                        'title' => esc_html__( 'After Loop Elementor Templates', 'styler' ),
                        'subtitle' => esc_html__( 'Select a template from elementor templates, If you want to show any content after products loop.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_after_loop_templates',
                        'type' => 'select',
                        'data' => 'posts',
                        'args' => $el_args,
                    ),
                    array(
                        'title' => esc_html__( 'After Shop Content Elementor Templates', 'styler' ),
                        'subtitle' => esc_html__( 'Select a template from elementor templates, If you want to show any content after products.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_after_content_templates',
                        'type' => 'select',
                        'data' => 'posts',
                        'args' => $el_args,
                        'required' => array(
                            array( 'shop_layout', '=', 'left-sidebar' ),
                            array( 'shop_layout', '=', 'right-sidebar' )
                        )
                    )
                )
            );
            $sections[] = array(
                'title' => esc_html__('Shop Page Post Style', 'styler'),
                'id' => 'shoppoststylesubsection',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'title' => esc_html__('Background Color', 'styler'),
                        'subtitle' => esc_html__('Change post background color.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_post_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'default' => '',
                        'output' => array('.woocommerce.styler-product')
                    ),
                    array(
                        'title' => esc_html__('Border', 'styler'),
                        'subtitle' => esc_html__('Set your custom border styles for the posts.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_post_brd',
                        'type' => 'border',
                        'all' => false,
                        'output' => array('.woocommerce.styler-product')
                    ),
                    array(
                        'title' => esc_html__('Padding', 'styler'),
                        'subtitle' => esc_html__('You can set the spacing of the site shop page post.', 'styler'),
                        'customizer' => true,
                        'id' =>'shop_post_pad',
                        'type' => 'spacing',
                        'output' => array('.woocommerce.styler-product'),
                        'mode' => 'padding',
                        'units' => array('em', 'px'),
                        'units_extended' => 'false',
                        'default' => array(
                            'units' => 'px'
                        )
                    ),
                    // post button ( Add to cart )
                    array(
                        'title' => esc_html__('Post title', 'styler'),
                        'subtitle' => esc_html__('Change theme main color.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_loop_post_title_color',
                        'type' => 'color',
                        'default' => '',
                        'output' => array('.styler-product .styler-product-name')
                    ),
                    array(
                        'title' => esc_html__('Price', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_loop_post_price_reg_color',
                        'type' => 'color',
                        'default' => '',
                        'output' => array('.woocommerce .styler-price')
                    ),
                    array(
                        'title' => esc_html__('Price Regular', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_loop_post_price_reg_color',
                        'type' => 'color',
                        'default' => '',
                        'output' => array('.woocommerce .styler-price del')
                    ),
                    array(
                        'title' => esc_html__('Price Sale', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_loop_post_price_sale_color',
                        'type' => 'color',
                        'default' => '',
                        'output' => array('.woocommerce .styler-price ins')
                    ),
                    array(
                        'title' => esc_html__('Discount Background', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_loop_post_discount_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'default' => '',
                        'output' => array('.woocommerce .styler-label')
                    ),
                    // post button ( Add to cart )
                    array(
                        'title' => esc_html__('Button Background ( Add to cart )', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_addtocartbtn_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'default' => '',
                        'output' => array('.woocommerce .styler-btn')
                    ),
                    array(
                        'title' => esc_html__('Hover Button Background ( Add to cart )', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_addtocartbtn_hvrbgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'default' => '',
                        'output' => array('.woocommerce .styler-btn:hover')
                    ),
                    array(
                        'title' => esc_html__('Button Title ( Add to cart )', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_addtocartbtn_color',
                        'type' => 'color',
                        'default' => '',
                        'output' => array('.woocommerce .styler-btn')
                    ),
                    array(
                        'title' => esc_html__('Hover Button Title ( Add to cart )', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_addtocartbtn_hvrcolor',
                        'type' => 'color',
                        'default' => '',
                        'output' => array('.woocommerce .styler-btn:hover')
                    ),
                    // post button ( view cart )
                    array(
                        'title' => esc_html__('Button Background ( View cart )', 'styler'),
                        'subtitle' => esc_html__('Change button background color.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_viewcartbtn_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'default' => '',
                        'output' => array('.woocommerce.styler-product a.added_to_cart')
                    ),
                    array(
                        'title' => esc_html__('Hover Button Background ( View cart )', 'styler'),
                        'subtitle' => esc_html__('Change button hover background color.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_viewcartbtn_hvrbgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'default' => '',
                        'output' => array('.woocommerce.styler-product a.added_to_cart:hover')
                    ),
                    array(
                        'title' => esc_html__('Button Title ( View cart )', 'styler'),
                        'subtitle' => esc_html__('Change button title color.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_viewcartbtn_color',
                        'type' => 'color',
                        'default' => '',
                        'output' => array('.woocommerce.styler-product a.added_to_cart')
                    ),
                    array(
                        'title' => esc_html__('Hover Button Title ( View cart )', 'styler'),
                        'subtitle' => esc_html__('Change button hover title color.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_viewcartbtn_hvrcolor',
                        'type' => 'color',
                        'default' => '',
                        'output' => array('.woocommerce.styler-product a.added_to_cart')
                    ),
                    array(
                        'title' => esc_html__('Button Border ( View cart )', 'styler'),
                        'subtitle' => esc_html__('Change hover button border style.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_viewcartbtn_brd',
                        'type' => 'border',
                        'output' => array('.woocommerce.styler-product a.added_to_cart')
                    ),
                    array(
                        'title' => esc_html__('Hover Button Border ( View cart )', 'styler'),
                        'subtitle' => esc_html__('Change hover button border style.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_viewcartbtn_hvrbrd',
                        'type' => 'border',
                        'output' => array('.woocommerce.styler-product a.added_to_cart:hover')
                    ),
                    array(
                        'title' => esc_html__('Pagination Background Color', 'styler'),
                        'subtitle' => esc_html__('Change shop page pagination background color.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_pagination_bgcolor',
                        'type' => 'color',
                        'mode' => 'background',
                        'default' => '',
                        'output' => array('.woocommerce nav.styler-woocommerce-pagination ul li a, .woocommerce nav.styler-woocommerce-pagination ul li span')
                    ),
                    array(
                        'title' => esc_html__('Active Pagination Background Color', 'styler'),
                        'subtitle' => esc_html__('Change shop page pagination hover and active item background color.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_pagination_hvrbgcolor',
                        'type' => 'color',
                        'mode' => 'background',
                        'default' => '',
                        'output' => array('.woocommerce nav.styler-woocommerce-pagination ul li a:focus, .woocommerce nav.styler-woocommerce-pagination ul li a:hover, .woocommerce nav.styler-woocommerce-pagination ul li span.current')
                    ),
                    array(
                        'title' => esc_html__('Pagination Text Color', 'styler'),
                        'subtitle' => esc_html__('Change shop page pagination text color.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_pagination_color',
                        'type' => 'color',
                        'default' => '',
                        'output' => array('.woocommerce nav.styler-woocommerce-pagination ul li a, .woocommerce nav.styler-woocommerce-pagination ul li span')
                    ),
                    array(
                        'title' => esc_html__('Active Pagination Text Color', 'styler'),
                        'subtitle' => esc_html__('Change shop page pagination hover and active item text color.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_pagination_hvrcolor',
                        'type' => 'color',
                        'default' => '',
                        'output' => array('.woocommerce nav.styler-woocommerce-pagination ul li a:focus, .woocommerce nav.styler-woocommerce-pagination ul li a:hover, .woocommerce nav.styler-woocommerce-pagination ul li span.current')
                    )
                )
            );
            $sections[] = array(
                'title' => esc_html__('Shop Pages', 'styler'),
                'id' => 'shoppagessubsection',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'id' =>'myaccount_page_type',
                        'type' => 'button_set',
                        'title' => esc_html__('My Account Page Type', 'styler'),
                        'subtitle' => esc_html__( 'Organize how you want the layout to appear on the theme shop account page.', 'styler' ),
                        'customizer' => true,
                        'options' => array(
                            'default' => esc_html__( 'Default', 'styler' ),
                            'multisteps' => esc_html__( 'Multi Steps', 'styler' ),
                        ),
                        'default' => 'default'
                    ),
                    array(
                        'id' =>'checkout_enable_multistep',
                        'type' => 'button_set',
                        'title' => esc_html__('Checkout Page Type', 'styler'),
                        'subtitle' => esc_html__( 'Organize how you want the layout to appear on the theme shop checkout page.', 'styler' ),
                        'customizer' => true,
                        'options' => array(
                            'default' => esc_html__( 'Default', 'styler' ),
                            'multisteps' => esc_html__( 'Multi Steps', 'styler' )
                        ),
                        'default' => 'default'
                    )
                )
            );
            // SHOP PAGE SECTION
            $sections[] = array(
                'title' => esc_html__('Cross-Sells Posts', 'styler'),
                'id' => 'singleshopcrosssells',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'title' => esc_html__('Cross-Sells Title', 'styler'),
                        'subtitle' => esc_html__('Add your cart page cross-sells section title here.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_cross_sells_title',
                        'type' => 'text',
                        'default' => ''
                    ),
                    array(
                        'id' =>'shop_cross_sells_type',
                        'type' => 'button_set',
                        'title' => esc_html__('Cross-Sells Layout Type', 'styler'),
                        'subtitle' => esc_html__( 'Organize how you want the layout to appear on the theme shop product page cross-sells.', 'styler' ),
                        'customizer' => true,
                        'options' => array(
                            'slider' => esc_html__( 'Slider', 'styler' ),
                            'grid' => esc_html__( 'Grid', 'styler' )
                        ),
                        'default' => 'slider'
                    ),
                    array(
                        'title' => esc_html__('Post Column', 'styler'),
                        'subtitle' => esc_html__('You can control cross-sells post column with this option.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_cross_sells_colxl',
                        'type' => 'slider',
                        'default' => 3,
                        'min' => 1,
                        'step' => 1,
                        'max' => 5,
                        'display_value' => 'text',
                        'required' => array( 'shop_cross_sells_type', '=', 'grid' )
                    ),
                    array(
                        'title' => esc_html__('Post Column ( Desktop/Tablet )', 'styler'),
                        'subtitle' => esc_html__('You can control cross-sells post column for tablet device with this option.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_cross_sells_collg',
                        'type' => 'slider',
                        'default' => 3,
                        'min' => 1,
                        'step' => 1,
                        'max' => 4,
                        'display_value' => 'text',
                        'required' => array( 'shop_cross_sells_type', '=', 'grid' )
                    ),
                    array(
                        'title' => esc_html__('Post Column ( Tablet )', 'styler'),
                        'subtitle' => esc_html__('You can control cross-sells post column for phone device with this option.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_cross_sells_colsm',
                        'type' => 'slider',
                        'default' => 2,
                        'min' => 1,
                        'step' => 1,
                        'max' => 3,
                        'display_value' => 'text',
                        'required' => array( 'shop_cross_sells_type', '=', 'grid' )
                    ),
                    array(
                        'title' => esc_html__('Post Column ( Phone )', 'styler'),
                        'subtitle' => esc_html__('You can control cross-sells post column for phone device with this option.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_cross_sells_colxs',
                        'type' => 'slider',
                        'default' => 2,
                        'min' => 1,
                        'step' => 1,
                        'max' => 2,
                        'display_value' => 'text',
                        'required' => array( 'shop_cross_sells_type', '=', 'grid' )
                    ),
                    array(
                        'id' => 'shop_cross_sells_section_slider_start',
                        'type' => 'section',
                        'title' => esc_html__('Cross-Sells Slider Options', 'styler'),
                        'customizer' => true,
                        'indent' => true,
                        'required' => array( 'shop_cross_sells_type', '=', 'slider' )
                    ),
                    array(
                        'title' => esc_html__( 'Perview ( Min 1024px )', 'styler' ),
                        'subtitle' => esc_html__( 'You can control cross-sells post slider item count for big device with this option.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_cross_sells_perview',
                        'type' => 'slider',
                        'default' => 5,
                        'min' => 1,
                        'step' => 1,
                        'max' => 10,
                        'display_value' => 'text',
                        'required' => array( 'shop_cross_sells_type', '=', 'slider' )
                    ),
                    array(
                        'title' => esc_html__( 'Perview ( Min 768px )', 'styler' ),
                        'subtitle' => esc_html__( 'You can control cross-sells post slider item count for big device with this option.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_cross_sells_mdperview',
                        'type' => 'slider',
                        'default' => 3,
                        'min' => 1,
                        'step' => 1,
                        'max' => 10,
                        'display_value' => 'text',
                        'required' => array( 'shop_cross_sells_type', '=', 'slider' )
                    ),
                    array(
                        'title' => esc_html__( 'Perview ( Min 480px )', 'styler' ),
                        'subtitle' => esc_html__( 'You can control cross-sells post slider item count for big device with this option.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_cross_sells_smperview',
                        'type' => 'slider',
                        'default' => 2,
                        'min' => 1,
                        'step' => 1,
                        'max' => 10,
                        'display_value' => 'text',
                        'required' => array( 'shop_cross_sells_type', '=', 'slider' )
                    ),
                    array(
                        'title' => esc_html__( 'Speed', 'styler' ),
                        'subtitle' => esc_html__( 'You can control cross-sells post slider item gap.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_cross_sells_speed',
                        'type' => 'slider',
                        'default' => 1000,
                        'min' => 100,
                        'step' => 1,
                        'max' => 10000,
                        'display_value' => 'text',
                        'required' => array( 'shop_cross_sells_type', '=', 'slider' )
                    ),
                    array(
                        'title' => esc_html__( 'Gap', 'styler' ),
                        'subtitle' => esc_html__( 'You can control cross-sells post slider item gap.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_cross_sells_gap',
                        'type' => 'slider',
                        'default' => 30,
                        'min' => 0,
                        'step' => 1,
                        'max' => 100,
                        'display_value' => 'text',
                        'required' => array( 'shop_cross_sells_type', '=', 'slider' )
                    ),
                    array(
                        'title' => esc_html__( 'Autoplay', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_cross_sells_autoplay',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array( 'shop_cross_sells_type', '=', 'slider' )
                    ),
                    array(
                        'title' => esc_html__( 'Loop', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_cross_sells_loop',
                        'type' => 'switch',
                        'default' => 0,
                        'required' => array( 'shop_cross_sells_type', '=', 'slider' )
                    ),
                    array(
                        'title' => esc_html__( 'Mousewheel', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_cross_sells_mousewheel',
                        'type' => 'switch',
                        'default' => 0,
                        'required' => array( 'shop_cross_sells_type', '=', 'slider' )
                    ),
                    array(
                        'title' => esc_html__( 'Free Mode', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_cross_sells_freemode',
                        'type' => 'switch',
                        'default' => 0,
                        'required' => array( 'shop_cross_sells_type', '=', 'slider' )
                    ),
                    array(
                        'id' => 'shop_cross_sells_section_slider_end',
                        'type' => 'section',
                        'customizer' => true,
                        'indent' => false,
                        'required' => array( 'shop_cross_sells_type', '=', 'slider' )
                    )
                )
            );
            // Quick View SUBSECTION
            $sections[] = array(
                'title' => esc_html__('Quick View', 'styler'),
                'id' => 'shopquickviewsubsection',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'title' => esc_html__('Quick View Display', 'styler'),
                        'customizer' => true,
                        'id' => 'quick_view_visibility',
                        'type' => 'switch',
                        'default' => 1
                    ),
                    array(
                        'title' => esc_html__('Overlay Color', 'styler'),
                        'subtitle' => esc_html__('Change quick view overlay color.', 'styler'),
                        'customizer' => true,
                        'id' => 'quick_view_overlaycolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'default' => '',
                        'output' => array('.mfp-bg.mfp-styler-quickview'),
                        'required' => array( 'quick_view_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Content Background Color', 'styler'),
                        'subtitle' => esc_html__('Change quick view background color.', 'styler'),
                        'customizer' => true,
                        'id' => 'quick_view_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'default' => '',
                        'output' => array('.styler-quickview-wrapper'),
                        'required' => array( 'quick_view_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Content Border', 'styler'),
                        'subtitle' => esc_html__('Set your custom border styles for the posts.', 'styler'),
                        'customizer' => true,
                        'id' => 'quick_view_brd',
                        'type' => 'border',
                        'all' => false,
                        'output' => array('.styler-quickview-wrapper'),
                        'required' => array( 'quick_view_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Content Padding', 'styler'),
                        'subtitle' => esc_html__('You can set the spacing of the site shop page post.', 'styler'),
                        'customizer' => true,
                        'id' =>'quick_view_pad',
                        'type' => 'spacing',
                        'output' => array('.styler-quickview-wrapper'),
                        'mode' => 'padding',
                        'units' => array('em', 'px'),
                        'units_extended' => 'false',
                        'default' => array(
                            'units' => 'px'
                        ),
                        'required' => array( 'quick_view_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__( 'Content Width', 'styler' ),
                        'subtitle' => esc_html__( 'You can use this option to control the theme content width.', 'styler' ),
                        'customizer' => true,
                        'id' => 'quick_view_width',
                        'type' => 'slider',
                        'default' => '',
                        'min' => 0,
                        'step' => 1,
                        'max' => 4000,
                        'display_value' => 'text',
                        'required' => array( 'quick_view_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__( 'Content Width Responsive ( min-width 768px )', 'styler' ),
                        'subtitle' => esc_html__( 'You can use this option to control the theme content width.', 'styler' ),
                        'customizer' => true,
                        'id' => 'quick_view_width_sm',
                        'type' => 'slider',
                        'default' => '',
                        'min' => 0,
                        'step' => 1,
                        'max' => 1200,
                        'display_value' => 'text',
                        'required' => array( 'quick_view_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Close Button Background Color', 'styler'),
                        'customizer' => true,
                        'id' => 'quick_view_close_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'default' => '',
                        'output' => array('.mfp-styler-quickview .styler-panel-close-button'),
                        'required' => array( 'quick_view_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Close Button Color', 'styler'),
                        'customizer' => true,
                        'id' => 'quick_view_close_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'default' => '',
                        'output' => array('.styler-quickview-wrapper .mfp-close.styler-panel-close-button:before,.styler-quickview-wrapper .mfp-close.styler-panel-close-button:after'),
                        'required' => array( 'quick_view_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Product Title Color', 'styler'),
                        'customizer' => true,
                        'id' => 'quick_view_title_color',
                        'type' => 'color',
                        'mode' => 'color',
                        'default' => '',
                        'output' => array('.styler-quickview-wrapper .styler-product-title'),
                        'required' => array( 'quick_view_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Product Price Color', 'styler'),
                        'customizer' => true,
                        'id' => 'quick_view_price_color',
                        'type' => 'color',
                        'mode' => 'color',
                        'default' => '',
                        'output' => array('.styler-quickview-wrapper .styler-price'),
                        'required' => array( 'quick_view_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Product Description Color', 'styler'),
                        'customizer' => true,
                        'id' => 'quick_view_desc_color',
                        'type' => 'color',
                        'mode' => 'color',
                        'default' => '',
                        'output' => array('.styler-quickview-wrapper .styler-product-summary .styler-summary-item p'),
                        'required' => array( 'quick_view_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Add to Cart Background Color', 'styler'),
                        'customizer' => true,
                        'id' => 'quick_view_btn_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'default' => '',
                        'output' => array('.styler-quickview-wrapper .styler-btn-small'),
                        'required' => array( 'quick_view_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Add to Cart Background Color ( Hover )', 'styler'),
                        'customizer' => true,
                        'id' => 'quick_view_btn_hvrbgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'default' => '',
                        'output' => array('.styler-quickview-wrapper .styler-btn-small:hover'),
                        'required' => array( 'quick_view_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Add to Cart Color', 'styler'),
                        'customizer' => true,
                        'id' => 'quick_view_btn_color',
                        'type' => 'color',
                        'mode' => 'color',
                        'default' => '',
                        'output' => array('.styler-quickview-wrapper .styler-btn-small'),
                        'required' => array( 'quick_view_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Add to Cart Color ( Hover )', 'styler'),
                        'customizer' => true,
                        'id' => 'quick_view_btn_hvrcolor',
                        'type' => 'color',
                        'mode' => 'color',
                        'default' => '',
                        'output' => array('.styler-quickview-wrapper .styler-btn-small:hover'),
                        'required' => array( 'quick_view_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Meta Label Color ( Hover )', 'styler'),
                        'customizer' => true,
                        'id' => 'quick_view_meta_label_color',
                        'type' => 'color',
                        'mode' => 'color',
                        'default' => '',
                        'output' => array('.styler-quickview-wrapper .styler-attr-label'),
                        'required' => array( 'quick_view_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Meta Label Color ( Hover )', 'styler'),
                        'customizer' => true,
                        'id' => 'quick_view_meta_value_color',
                        'type' => 'color',
                        'mode' => 'color',
                        'default' => '',
                        'output' => array('.styler-quickview-wrapper .product_meta>span a, .styler-quickview-wrapper .styler-attr-value, .styler-quickview-wrapper .styler-attr-value a'),
                        'required' => array( 'quick_view_visibility', '=', '1' )
                    )
                )
            );
            // Quick Shop SUBSECTION
            $sections[] = array(
                'title' => esc_html__('Quick Shop View', 'styler'),
                'id' => 'shopquickshopsubsection',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'title' => esc_html__('Ajax Quick Shop Display', 'styler'),
                        'customizer' => true,
                        'id' => 'quick_shop_visibility',
                        'type' => 'switch',
                        'default' => 1
                    ),
                    array(
                        'title' => esc_html__('Popup Overlay Color', 'styler'),
                        'subtitle' => esc_html__('Change quick view overlay color.', 'styler'),
                        'customizer' => true,
                        'id' => 'quick_shop_overlaycolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'default' => '',
                        'output' => array('.mfp-bg.mfp-styler-quickshop'),
                        'required' => array( 'quick_shop_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Content Background Color', 'styler'),
                        'subtitle' => esc_html__('Change quick view background color.', 'styler'),
                        'customizer' => true,
                        'id' => 'quick_shop_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'default' => '',
                        'output' => array('.styler-quickshop-wrapper'),
                        'required' => array( 'quick_shop_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Content Border', 'styler'),
                        'subtitle' => esc_html__('Set your custom border styles for the posts.', 'styler'),
                        'customizer' => true,
                        'id' => 'quick_shop_brd',
                        'type' => 'border',
                        'all' => false,
                        'output' => array('.styler-quickshop-wrapper'),
                        'required' => array( 'quick_shop_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Content Padding', 'styler'),
                        'subtitle' => esc_html__('You can set the spacing of the site shop page post.', 'styler'),
                        'customizer' => true,
                        'id' =>'quick_shop_pad',
                        'type' => 'spacing',
                        'output' => array('.styler-quickshop-wrapper'),
                        'mode' => 'padding',
                        'units' => array('em', 'px'),
                        'units_extended' => 'false',
                        'default' => array(
                            'units' => 'px'
                        ),
                        'required' => array( 'quick_shop_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__( 'Max Width', 'styler' ),
                        'subtitle' => esc_html__( 'You can use this option to control the theme content width.', 'styler' ),
                        'customizer' => true,
                        'id' => 'quick_shop_width',
                        'type' => 'slider',
                        'default' => '',
                        'min' => 0,
                        'step' => 1,
                        'max' => 4000,
                        'display_value' => 'text',
                        'required' => array( 'quick_view_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__( 'Max Width Responsive ( min-width 768px )', 'styler' ),
                        'subtitle' => esc_html__( 'You can use this option to control the theme content width.', 'styler' ),
                        'customizer' => true,
                        'id' => 'quick_shop_width_sm',
                        'type' => 'slider',
                        'default' => '',
                        'min' => 0,
                        'step' => 1,
                        'max' => 1200,
                        'display_value' => 'text',
                        'required' => array( 'quick_shop_visibility', '=', '1' )
                    )
                )
            );
            // Popup Notices SUBSECTION
            $sections[] = array(
                'title' => esc_html__('Popup Notices', 'styler'),
                'id' => 'shopquickshopsubsection',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'title' => esc_html__('Ajax Add to Cart Notices Display', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_cart_popup_notices_visibility',
                        'type' => 'switch',
                        'default' => 1
                    ),
                    array(
                        'title' => esc_html__( 'Notices Duration ( ms )', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_cart_popup_notices_duration',
                        'type' => 'slider',
                        'default' => 3500,
                        'min' => 0,
                        'step' => 100,
                        'max' => 20000,
                        'display_value' => 'text',
                        'required' => array( 'shop_cart_popup_notices_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Background Color', 'styler'),
                        'subtitle' => esc_html__('Change popup notices background color.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_cart_popup_notices_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'default' => '',
                        'output' => array('.styler-shop-popup-notices'),
                        'required' => array( 'shop_cart_popup_notices_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Text Color', 'styler'),
                        'subtitle' => esc_html__('Change popup notices text color.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_cart_popup_notices_color',
                        'type' => 'color',
                        'mode' => 'color',
                        'default' => '',
                        'output' => array('.styler-shop-popup-notices .styler-shop-popup-notices-wrapper'),
                        'required' => array( 'shop_cart_popup_notices_visibility', '=', '1' )
                    )
                )
            );
            // Popup Notices SUBSECTION
            $sections[] = array(
                'title' => esc_html__('Sticky Fly Cart', 'styler'),
                'id' => 'shopflycartsubsection',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'title' => esc_html__('Sticky Fly Cart Display', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_fly_cart_visibility',
                        'type' => 'switch',
                        'default' => 0
                    ),
                    array(
                        'title' => esc_html__( 'Animation Duration ( ms )', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_fly_cart_duration',
                        'type' => 'slider',
                        'default' => 1500,
                        'min' => 0,
                        'step' => 100,
                        'max' => 5000,
                        'display_value' => 'text',
                        'required' => array( 'shop_fly_cart_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Background Color', 'styler'),
                        'subtitle' => esc_html__('Change Fly Cart background color.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_fly_cart_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'default' => '',
                        'output' => array('.styler-sticky-cart-toggle'),
                        'required' => array( 'shop_fly_cart_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Background Color ( Active )', 'styler'),
                        'subtitle' => esc_html__('Change Fly Cart background color.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_fly_cart_actbgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'default' => '',
                        'output' => array('.styler-sticky-cart-toggle.active'),
                        'required' => array( 'shop_fly_cart_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Icon Color', 'styler'),
                        'subtitle' => esc_html__('Change fly cart icon color.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_fly_cart_svgcolor',
                        'type' => 'color',
                        'mode' => 'fill',
                        'default' => '',
                        'output' => array('.styler-sticky-cart-toggle svg'),
                        'required' => array( 'shop_fly_cart_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Icon Color', 'styler'),
                        'subtitle' => esc_html__('Change fly cart icon color.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_fly_cart_actsvgcolor',
                        'type' => 'color',
                        'mode' => 'fill',
                        'default' => '',
                        'output' => array('.styler-sticky-cart-toggle.active svg'),
                        'required' => array( 'shop_fly_cart_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Counter Background Color', 'styler'),
                        'subtitle' => esc_html__('Change fly cart background color.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_fly_cart_counter_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'default' => '',
                        'output' => array('.styler-sticky-cart-toggle .styler-wc-count'),
                        'required' => array( 'shop_fly_cart_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Counter Number Color', 'styler'),
                        'subtitle' => esc_html__('Change fly cart icon color.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_fly_cart_counter_color',
                        'type' => 'color',
                        'default' => '',
                        'output' => array('.styler-sticky-cart-toggle .styler-wc-count'),
                        'required' => array( 'shop_fly_cart_visibility', '=', '1' )
                    ),
                )
            );
            /*************************************************
            ## SINGLE PAGE SECTION
            *************************************************/
            // create sections in the theme options
            $sections[] = array(
                'title' => esc_html__('Shop Single Page', 'styler'),
                'id' => 'singleshopsection',
                'icon' => 'el el-shopping-cart-sign'
            );
            $sections[] = array(
                'title' => esc_html__('Layout', 'styler'),
                'id' => 'singleshopgeneral',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'id' =>'single_shop_layout',
                        'type' => 'button_set',
                        'title' => esc_html__( 'Page Sidebar Layouts', 'styler' ),
                        'subtitle' => esc_html__( 'Organize how you want the layout to appear on the theme shop page sidebar area.', 'styler' ),
                        'options' => array(
                            'left-sidebar' => esc_html__( 'Left Sidebar', 'styler' ),
                            'right-sidebar' => esc_html__( 'Right Sidebar', 'styler' ),
                            'full-width' => esc_html__( 'Full width ( no-sidebar )', 'styler' ),
                            'stretch' => esc_html__( 'Full width ( stretch )', 'styler' ),
                            'showcase' => esc_html__( 'Showcase Style', 'styler' )
                        ),
                        'default' => 'full-width'
                    ),
                    array(
                        'title' => esc_html__('Scroll to Top Behavior', 'styler'),
                        'subtitle' => esc_html__( 'You can use this option if you do not want the scroll to top when the variation is selected on the product page.', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_scrolltop',
                        'type' => 'switch',
                        'default' => 1
                    ),
                    array(
                        'title' => esc_html__( 'After Tabs Elementor Templates', 'styler' ),
                        'subtitle' => esc_html__( 'Select a template from elementor templates, If you want to show any content after product page tabs section.', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_stretch_elementor_template',
                        'type' => 'select',
                        'data' => 'posts',
                        'args' => $el_args,
                        'required' => array( 'single_shop_layout', '=', 'stretch' )
                    ),
                    array(
                        'id' =>'product_thumbs_layout',
                        'type' => 'button_set',
                        'title' => esc_html__('Thumbs Layout Type', 'styler'),
                        'subtitle' => esc_html__( 'Organize how you want the layout to appear on the theme shop product page tumbs.', 'styler' ),
                        'customizer' => true,
                        'options' => array(
                            'grid' => esc_html__( 'Grid', 'styler' ),
                            'slider' => esc_html__( 'Slider', 'styler' ),
                            'wc' => esc_html__( 'WooCommerce Default', 'styler' ),
                        ),
                        'default' => 'slider',
                        'required' => array( 'single_shop_layout', '!=', 'showcase' )
                    ),
                    array(
                        'title' => esc_html__('Carousel Slider', 'styler'),
                        'subtitle' => esc_html__( 'If you have problems with 3rd party plugins, disable this option.', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_gallery_owl_carousel',
                        'type' => 'switch',
                        'default' => 0,
                        'required' => array( 'product_thumbs_layout', '=', 'wc' )
                    ),
                    array(
                        'id' =>'product_gallery_slider_effect',
                        'type' => 'button_set',
                        'title' => esc_html__('Slider Effect', 'styler'),
                        'customizer' => true,
                        'options' => array(
                            'creative' => esc_html__( 'Creative', 'styler' ),
                            'slide' => esc_html__( 'Slide', 'styler' ),
                        ),
                        'default' => 'slide',
                        'required' => array( 'product_thumbs_layout', '=', 'slider' )
                    ),
                    array(
                        'title' => esc_html__('Thumbs Column Width', 'styler'),
                        'customizer' => true,
                        'id' => 'product_thumbs_column_width',
                        'type' => 'spinner',
                        'default' => '7',
                        'min' => '1',
                        'step' => '1',
                        'max' => '12'
                    ),
                    array(
                        'id' =>'styler_product_gallery_grid_column',
                        'type' => 'button_set',
                        'title' => esc_html__('Grid Column', 'styler'),
                        'subtitle' => esc_html__( 'Organize how you want the layout to appear on the theme shop product page tumbs.', 'styler' ),
                        'customizer' => true,
                        'options' => array(
                            '1' => esc_html__( '1 Column', 'styler' ),
                            '2' => esc_html__( '2 Column', 'styler' ),
                            '3' => esc_html__( '3 Column', 'styler' ),
                            '4' => esc_html__( '4 Column', 'styler' ),
                        ),
                        'default' => '2',
                        'required' => array(
                            array( 'single_shop_layout', '!=', 'showcase' ),
                            array( 'product_thumbs_layout', '=', 'grid' )
                        )
                    ),
                    array(
                        'id' =>'product_gallery_slider_layout',
                        'type' => 'button_set',
                        'title' => esc_html__('Slider Thumbs Type', 'styler'),
                        'subtitle' => esc_html__( 'Organize how you want the layout to appear on the theme shop product page tumbs.', 'styler' ),
                        'customizer' => true,
                        'options' => array(
                            'top' => esc_html__( 'Horizontal Top', 'styler' ),
                            'bottom' => esc_html__( 'Horizontal Bottom', 'styler' ),
                            'left' => esc_html__( 'Vertical Left', 'styler' ),
                            'right' => esc_html__( 'Vertical Right', 'styler' ),
                        ),
                        'default' => 'bottom',
                        'required' => array(
                            array( 'single_shop_layout', '!=', 'showcase' ),
                            array( 'product_thumbs_layout', '=', 'slider' )
                        )
                    ),
                    array(
                        'id' =>'single_shop_showcase_type',
                        'type' => 'button_set',
                        'title' => esc_html__( 'Showcase Slider Type', 'styler' ),
                        'subtitle' => esc_html__( 'Select theme shop page showcase type.', 'styler' ),
                        'options' => array(
                            'carousel' => esc_html__( 'Carousel', 'styler' ),
                            'full' => esc_html__( 'Full', 'styler' ),
                        ),
                        'default' => 'carousel',
                        'required' => array( 'single_shop_layout', '=', 'showcase' )
                    ),
                    array(
                        'id' =>'single_shop_showcase_full_effect_type',
                        'type' => 'button_set',
                        'title' => esc_html__( 'Showcase Full Effect Type', 'styler' ),
                        'subtitle' => esc_html__( 'Select theme shop page showcase full type effect.', 'styler' ),
                        'options' => array(
                            'slide' => esc_html__( 'Slide', 'styler' ),
                            'flip' => esc_html__( 'flip', 'styler' ),
                            'fade' => esc_html__( 'fade', 'styler' ),
                            'creative' => esc_html__( 'creative', 'styler' ),
                        ),
                        'default' => 'slide',
                        'required' => array(
                            array( 'single_shop_layout', '=', 'showcase' ),
                            array( 'single_shop_showcase_type', '=', 'full' ),
                        )
                    ),
                    array(
                        'id' =>'single_shop_showcase_carousel_effect_type',
                        'type' => 'button_set',
                        'title' => esc_html__( 'Showcase Carousel Effect Type', 'styler' ),
                        'subtitle' => esc_html__( 'Select theme shop page showcase carousel type effect.', 'styler' ),
                        'options' => array(
                            '' => esc_html__( 'Carousel', 'styler' ),
                            'coverflow' => esc_html__( 'Coverflow', 'styler' ),
                        ),
                        'default' => 'slide',
                        'required' => array(
                            array( 'single_shop_layout', '=', 'showcase' ),
                            array( 'single_shop_showcase_type', '=', 'carousel' ),
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Coverflow Rotate', 'styler' ),
                        'subtitle' => esc_html__( 'Set the rotate of the coverflow effect.', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_showcase_carousel_coverflow_rotate',
                        'type' => 'slider',
                        'default' => 30,
                        'min' => -90,
                        'step' => 1,
                        'max' => 90,
                        'required' => array(
                            array( 'single_shop_layout', '=', 'showcase' ),
                            array( 'single_shop_showcase_type', '=', 'carousel' ),
                            array( 'single_shop_showcase_carousel_effect_type', '=', 'coverflow' ),
                        )
                    ),
                    array(
                        'title' => esc_html__('Slider Loop', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_showcase_carousel_loop',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array(
                            array( 'single_shop_layout', '=', 'showcase' ),
                            array( 'single_shop_showcase_type', '=', 'carousel' ),
                        )
                    ),
                    array(
                        'id' =>'single_shop_showcase_bg_type',
                        'type' => 'button_set',
                        'title' => esc_html__( 'Showcase BG Style', 'styler' ),
                        'subtitle' => esc_html__( 'Select theme shop page showcase background style.', 'styler' ),
                        'options' => array(
                            'light' => esc_html__( 'Light', 'styler' ),
                            'dark' => esc_html__( 'Dark', 'styler' ),
                            'custom' => esc_html__( 'Custom Color', 'styler' ),
                        ),
                        'default' => 'light',
                        'required' => array( 'single_shop_layout', '=', 'showcase' )
                    ),
                    array(
                        'title' => esc_html__('Showcase Background', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_showcase_custom_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'output' => array( '.styler-product-showcase.styler-bg-custom' ),
                        'required' => array(
                            array( 'single_shop_layout', '=', 'showcase' ),
                            array( 'single_shop_showcase_bg_type', '=', 'custom' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Showcase Text Color', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_showcase_custom_textcolor',
                        'type' => 'color',
                        'output' => array( '.styler-product-showcase.styler-bg-custom' ),
                        'required' => array(
                            array( 'single_shop_layout', '=', 'showcase' ),
                            array( 'single_shop_showcase_bg_type', '=', 'custom' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Showcase Content Padding', 'styler'),
                        'subtitle' => esc_html__('You can set the spacing of the site single page showcase content.', 'styler'),
                        'customizer' => true,
                        'id' =>'single_shop_showcase_content_pad',
                        'type' => 'spacing',
                        'output' => array('.product .styler-product-showcase.styler-bg-custom'),
                        'mode' => 'padding',
                        'units' => array('em', 'px'),
                        'units_extended' => 'false',
                        'required' => array( 'single_shop_layout', '=', 'showcase' )
                    ),
                    array(
                        'title' => esc_html__( 'Sticky Sidebar', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_sticky_sidebar',
                        'type' => 'switch',
                        'default' => 0,
                        'required' => array(
                            array( 'single_shop_layout', '!=', 'full-width' ),
                            array( 'single_shop_layout', '!=', 'showcase' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Gallery Zoom Effect', 'styler'),
                        'subtitle' => esc_html__('You can enable or disable the site product image zoom option.', 'styler'),
                        'customizer' => true,
                        'id' => 'styler_product_zoom',
                        'type' => 'switch',
                        'default' => 1
                    ),
                    array(
                        'id' =>'product_gallery_lightbox',
                        'type' => 'button_set',
                        'title' => esc_html__('Lightbox Gallery', 'styler'),
                        'customizer' => true,
                        'options' => array(
                            'fancybox' => esc_html__( 'Fancybox', 'styler' ),
                            'magnific' => esc_html__( 'Magnific', 'styler' ),
                        ),
                        'default' => 'fancybox',
                        'required' => array( 'product_thumbs_layout', '=', 'slider' )
                    ),
                    array(
                        'title' => esc_html__('Reviews Section', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_review_visibility',
                        'type' => 'switch',
                        'default' => 1
                    ),
                    array(
                        'title' => esc_html__('Bottom Popup Cart on Scroll', 'styler'),
                        'customizer' => true,
                        'id' => 'styler_product_bottom_popup_cart',
                        'type' => 'switch',
                        'default' => 1
                    ),
                )
            );
            // SINGLE HERO SUBSECTION
            $sections[] = array(
                'title' => esc_html__('Product Header', 'styler'),
                'desc' => esc_html__('These are shop product page header section settings', 'styler'),
                'id' => 'singleshopheadersubsection',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'title' => esc_html__('Use Different Header Layouts', 'styler'),
                        'subtitle' => esc_html__('You can use different header layouts type on shop product pages.', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_different_header_layouts',
                        'type' => 'switch',
                        'default' => 1
                    ),
                    array(
                        'id' =>'single_shop_header_layouts',
                        'type' => 'sorter',
                        'title' => esc_html__( 'Shop Header Layout Manager', 'styler' ),
                        'subtitle' => esc_html__( 'Organize how you want the layout to appear on the theme header', 'styler' ),
                        'options' => array(
                            'left' => array(
                                'sidemenu' => esc_html__( 'Sidemenu Toggle', 'styler' ),
                                'logo' => esc_html__( 'Logo', 'styler' )
                            ),
                            'center'=> array(
                                'menu' => esc_html__( 'Main Menu', 'styler' )
                            ),
                            'right'=> array(
                                'search' => esc_html__( 'Search', 'styler' ),
                                'buttons' => esc_html__( 'Buttons', 'styler' )
                            ),
                            'hide'  => array(
                                'center-logo' => esc_html__( 'Menu Logo Menu', 'styler' ),
                                'mini-menu' => esc_html__( 'Mini Menu', 'styler' ),
                                'double-menu' => esc_html__( 'Double Menu', 'styler' ),
                                'custom-html' => esc_html__( 'Phone Number', 'styler' )
                            )
                        ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_layouts', '=', '1' )
                        )
                    ),
                    array(
                        'id' =>'single_shop_header_buttons_layouts',
                        'type' => 'sorter',
                        'title' => esc_html__( 'Shop Header Buttons Manager', 'styler' ),
                        'subtitle' => esc_html__( 'Organize how you want the layout to appear on the theme header for buttons', 'styler' ),
                        'options' => array(
                            'show'  => array(
                                'cart' => esc_html__( 'Cart', 'styler' ),
                                'wishlist' => esc_html__( 'Wishlist', 'styler' ),
                                'compare' => esc_html__( 'Compare', 'styler' ),
                                'account' => esc_html__( 'Account', 'styler' )
                            ),
                            'hide'  => array(
                                'search' => esc_html__( 'Search', 'styler' )
                            )
                        ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_layouts', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Use Different Header Background Type', 'styler'),
                        'subtitle' => esc_html__('You can use different header background type on product page.', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_different_header_bg_type',
                        'type' => 'switch',
                        'default' => 0
                    ),
                    array(
                        'id' => 'single_shop_header_menu_items_customize_start',
                        'type' => 'section',
                        'title' => esc_html__('Header Customize Options', 'styler'),
                        'customizer' => true,
                        'indent' => true,
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'id' =>'single_shop_header_bg_type',
                        'type' => 'button_set',
                        'title' => esc_html__( 'Header Background Type', 'styler' ),
                        'subtitle' => esc_html__( 'Select your header background type.', 'styler' ),
                        'customizer' => true,
                        'options' => array(
                            'default' => esc_html__( 'Deafult', 'styler' ),
                            'dark' => esc_html__( 'Dark', 'styler' ),
                            'trans-light' => esc_html__( 'Transparent Light', 'styler' ),
                            'trans-dark' => esc_html__( 'Transparent Dark', 'styler' )
                        ),
                        'default' => 'default',
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Header Background Color', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_header_bg',
                        'type' => 'color_rgba',
                        'mode' => 'background-color',
                        'output' => array( '.single.single-product header.styler-header-default,.single.single-product.has-default-header-type-trans:not(.scroll-start) header.styler-header-default' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Menu Item Color', 'styler' ),
                        'desc' => esc_html__( 'Set your own hover color for the navigation menu item.', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_nav_a',
                        'type' => 'color',
                        'validate' => 'color',
                        'output' => array( '.single.single-product .styler-header-top-menu-area>ul>li.menu-item>a,.single.single-product.has-default-header-type-trans:not(.scroll-start) header.styler-header-default .styler-header-top-menu-area>ul>li.menu-item>a' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Menu Item Color ( Hover and Active )', 'styler' ),
                        'desc' => esc_html__( 'Set your own hover color for the navigation menu item.', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_nav_hvr_a',
                        'type' => 'color',
                        'validate' => 'color',
                        'output' => array( '.single.single-product .current-menu-parent>a,.single.single-product .current-menu-item>a,.single.single-product .styler-header-top-menu-area>ul>li.menu-item>a:hover,.single.single-product .styler-header-top-menu-area ul li .submenu>li.menu-item>a:hover,.single.single-product.has-default-header-type-trans:not(.scroll-start) header.styler-header-default .current-menu-parent>a,.single.single-product.has-default-header-type-trans:not(.scroll-start) header.styler-header-default .current-menu-item>a,.single.single-product.has-default-header-type-trans:not(.scroll-start) header.styler-header-default .styler-header-top-menu-area>ul>li.menu-item>a:hover,.single.single-product.has-default-header-type-trans:not(.scroll-start) header.styler-header-default .styler-header-top-menu-area ul li .submenu>li.menu-item>a:hover'),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Sticky Header Background Color', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_nav_top_sticky_bg',
                        'type' => 'color_rgba',
                        'mode' => 'background-color',
                        'output' => array( '.single.single-product.has-sticky-header.scroll-start header.styler-header-default' ),
                        'required' => array( 'header_sticky_visibility', '=', '1' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Sticky Menu Item Color', 'styler' ),
                        'desc' => esc_html__( 'Set your own hover color for the sticky navigation menu item.', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_sticky_nav_a',
                        'type' => 'color',
                        'validate' => 'color',
                        'output' => array( '.single.single-product.has-sticky-header.scroll-start .styler-header-top-menu-area>ul>li.menu-item>a' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Sticky Menu Item Color ( Hover and Active )', 'styler' ),
                        'desc' => esc_html__( 'Set your own hover color for the sticky navigation menu item.', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_sticky_nav_hvr_a',
                        'type' => 'color',
                        'validate' => 'color',
                        'output' => array( '.single.single-product.has-sticky-header.scroll-start .current-menu-parent>a, .single.single-product.has-sticky-header.scroll-start .current-menu-item>a, .single.single-product.has-sticky-header.scroll-start .styler-header-top-menu-area>ul>li.menu-item>a:hover, .single.single-product.has-sticky-header.scroll-start .styler-header-top-menu-area ul li .submenu>li.menu-item>a:hover' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'id' => 'single_shop_header_menu_items_style_end',
                        'type' => 'section',
                        'customizer' => true,
                        'indent' => false,
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'id' => 'single_shop_header_submenu_items_style_start',
                        'type' => 'section',
                        'title' => esc_html__('Header Sub Menu Customize Options', 'styler'),
                        'customizer' => true,
                        'indent' => true,
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Sub Menu Background Color', 'styler' ),
                        'desc' => esc_html__( 'Set your own hover color for the sticky navigation sub menu item.', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_nav_submenu_bg',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'validate' => 'color',
                        'output' => array( '.single.single-product .styler-header-top-menu-area ul li .submenu' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Menu Item Color', 'styler' ),
                        'desc' => esc_html__( 'Set your own hover color for the sticky navigation sub menu item.', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_nav_submenu_a',
                        'type' => 'color',
                        'validate' => 'color',
                        'output' => array( '.single.single-product .styler-header-top-menu-area ul li .submenu>li.menu-item>a' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Menu Item Color ( Hover and Active )', 'styler' ),
                        'desc' => esc_html__( 'Set your own hover color for the sticky navigation sub menu item.', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_nav_submenu_hvr_a',
                        'type' => 'color',
                        'validate' => 'color',
                        'output' => array( '.single.single-product .styler-header-top-menu-area ul li .submenu>li.menu-item>a:hover,.single.single-product .styler-header-top-menu-area ul li .submenu>li.menu-item.active>a' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'id' => 'single_shop_header_submenu_items_style_end',
                        'type' => 'section',
                        'customizer' => true,
                        'indent' => false,
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'id' => 'single_shop_header_svgbuttons_items_style_start',
                        'type' => 'section',
                        'title' => esc_html__('Header SVG Buttons Customize Options', 'styler'),
                        'customizer' => true,
                        'indent' => true,
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'SVG Icon Color', 'styler' ),
                        'desc' => esc_html__( 'Cart, Wishlist, Compare, Account, Search, Sidemenu bar', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_header_buttons_svg_color',
                        'type' => 'color',
                        'mode' => 'fill',
                        'validate' => 'color',
                        'output' => array( '.single.single-product .styler-header-default .header-top-buttons .top-action-btn,.single.single-product.has-default-header-type-trans:not(.scroll-start) header.styler-header-default .header-top-buttons .top-action-btn' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Button Counter Background Color', 'styler' ),
                        'desc' => esc_html__( 'Cart, Wishlist, Compare', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_header_buttons_counter_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'validate' => 'color',
                        'output' => array( '.single.single-product .styler-header-default .styler-wc-count,.single.single-product.has-default-header-type-trans:not(.scroll-start) header.styler-header-default .styler-wc-count' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Button Counter Color', 'styler' ),
                        'desc' => esc_html__( 'Cart, Wishlist, Compare', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_header_buttons_counter_color',
                        'type' => 'color',
                        'validate' => 'color',
                        'output' => array( '.single.single-product .styler-header-default .styler-wc-count,.single.single-product.has-default-header-type-trans:not(.scroll-start) header.styler-header-default .styler-wc-count' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Sticky Header SVG Icon Color', 'styler' ),
                        'desc' => esc_html__( 'Cart, Wishlist, Compare, Account, Search, Sidemenu bar', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_sticky_header_buttons_svg_color',
                        'type' => 'color',
                        'mode' => 'fill',
                        'validate' => 'color',
                        'output' => array( '.single.single-product.scroll-start .styler-header-default .header-top-buttons .top-action-btn,.single.single-product.has-default-header-type-trans.scroll-start header.styler-header-default .header-top-buttons .top-action-btn' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Sticky Header Button Counter Background Color', 'styler' ),
                        'desc' => esc_html__( 'Cart, Wishlist, Compare', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_sticky_header_buttons_counter_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'validate' => 'color',
                        'output' => array( '.single.single-product.scroll-start .styler-header-default .styler-wc-count,.single.single-product.has-default-header-type-trans.scroll-start header.styler-header-default .styler-wc-count' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__( 'Sticky Header Button Counter Color', 'styler' ),
                        'desc' => esc_html__( 'Cart, Wishlist, Compare', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_sticky_header_buttons_counter_color',
                        'type' => 'color',
                        'validate' => 'color',
                        'output' => array( '.single.single-product.scroll-start .styler-header-default .styler-wc-count,.single.single-product.has-default-header-type-trans.scroll-start header.styler-header-default .styler-wc-count' ),
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    ),
                    array(
                        'id' => 'single_shop_header_svgbuttons_items_style_end',
                        'type' => 'section',
                        'customizer' => true,
                        'indent' => false,
                        'required' => array(
                            array( 'header_visibility', '=', '1' ),
                            array( 'header_template', '!=', 'elementor' ),
                            array( 'single_shop_different_header_bg_type', '=', '1' )
                        )
                    )
                )
            );
            // SHOP PAGE SECTION
            $sections[] = array(
                'title' => esc_html__('Products Navigation', 'styler'),
                'id' => 'singleshophero',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'title' => esc_html__('Product navigation', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_nav_visibility',
                        'type' => 'switch',
                        'default' => 1
                    )
                )
            );
            // SHOP PAGE SECTION
            $sections[] = array(
                'title' => esc_html__('Variable Products Terms', 'styler'),
                'id' => 'singleshopvariations',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'title' => esc_html__('Show Selected Variations', 'styler'),
                        'customizer' => true,
                        'id' => 'selected_variations_terms_visibility',
                        'type' => 'switch',
                        'default' => 1
                    ),
                    array(
                        'title' => esc_html__('Show Hints', 'styler'),
                        'customizer' => true,
                        'id' => 'variations_terms_hints_visibility',
                        'type' => 'switch',
                        'default' => 0,
                        'required' => array( 'selected_variations_terms_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Selected Terms Title', 'styler'),
                        'customizer' => true,
                        'id' => 'selected_variations_terms_title',
                        'type' => 'text',
                        'default' => '',
                        'required' => array( 'selected_variations_terms_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__( 'Selected Terms Title Typography', 'styler' ),
                        'id' => 'selected_variations_terms_title_typo',
                        'type' => 'typography',
                        'font-backup' => false,
                        'letter-spacing' => true,
                        'text-transform' => true,
                        'all_styles' => true,
                        'output' => array( '.styler-selected-variations-terms-wrapper .styler-selected-variations-terms-title' ),
                        'required' => array( 'selected_variations_terms_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Title Color', 'styler'),
                        'customizer' => true,
                        'id' => 'selected_variations_terms_titlecolor',
                        'type' => 'color',
                        'output' => array( '.styler-selected-variations-terms-wrapper .styler-selected-variations-terms-title' ),
                        'required' => array( 'selected_variations_terms_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Background Color', 'styler'),
                        'customizer' => true,
                        'id' => 'selected_variations_terms_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'output' => array( '.styler-selected-variations-terms-wrapper .styler-selected-variations-terms' ),
                        'required' => array( 'selected_variations_terms_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Border', 'styler'),
                        'customizer' => true,
                        'id' => 'selected_variations_terms_brd',
                        'type' => 'border',
                        'all' => false,
                        'output' => array('.styler-selected-variations-terms-wrapper .styler-selected-variations-terms'),
                        'required' => array( 'selected_variations_terms_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Border Radius', 'styler'),
                        'customizer' => true,
                        'id' => 'selected_variations_terms_brd_radius',
                        'type' => 'slider',
                        'default' => 4,
                        'min' => 0,
                        'step' => 1,
                        'max' => 100,
                        'display_value' => 'text',
                        'required' => array( 'selected_variations_terms_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Padding', 'styler'),
                        'customizer' => true,
                        'id' =>'selected_variations_terms_pad',
                        'type' => 'spacing',
                        'output' => array('.styler-selected-variations-terms-wrapper .styler-selected-variations-terms'),
                        'mode' => 'padding',
                        'units' => array('em', 'px'),
                        'units_extended' => 'false',
                        'default' => array(
                            'units' => 'px'
                        ),
                        'required' => array( 'selected_variations_terms_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Terms Color', 'styler'),
                        'customizer' => true,
                        'id' => 'selected_variations_terms_value_color',
                        'type' => 'color',
                        'output' => array( '.styler-selected-variations-terms-wrapper .selected-features' ),
                        'required' => array( 'selected_variations_terms_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__( 'Selected Terms Typography', 'styler' ),
                        'id' => 'selected_variations_terms_value_typo',
                        'type' => 'typography',
                        'font-backup' => false,
                        'letter-spacing' => true,
                        'text-transform' => true,
                        'all_styles' => true,
                        'output' => array( '.styler-selected-variations-terms-wrapper .selected-features' ),
                        'required' => array( 'selected_variations_terms_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Hints Background Color', 'styler'),
                        'customizer' => true,
                        'id' => 'selected_variations_hints_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'output' => array( '.show-hints .styler-terms .styler-term:not(.styler-disabled):after' ),
                        'required' => array(
                            array( 'selected_variations_terms_visibility', '=', '1' ),
                            array( 'variations_terms_hints_visibility', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Hints Arrow Color', 'styler'),
                        'customizer' => true,
                        'id' => 'selected_variations_hints_bgcolor2',
                        'type' => 'color',
                        'mode' => 'border-top-color',
                        'output' => array( '.show-hints .styler-terms .styler-term:not(.styler-disabled):before' ),
                        'required' => array(
                            array( 'selected_variations_terms_visibility', '=', '1' ),
                            array( 'variations_terms_hints_visibility', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Hints Text Color', 'styler'),
                        'customizer' => true,
                        'id' => 'selected_variations_hints_titlecolor',
                        'type' => 'color',
                        'output' => array( '.show-hints .styler-terms .styler-term:not(.styler-disabled):after' ),
                        'required' => array(
                            array( 'selected_variations_terms_visibility', '=', '1' ),
                            array( 'variations_terms_hints_visibility', '=', '1' )
                        )
                    )
                )
            );
            // SHOP PAGE SECTION
            $sections[] = array(
                'title' => esc_html__('Summary', 'styler'),
                'id' => 'singleshoptumbssection',
                'subsection' => true,
                'icon' => 'fa fa-cog',
                'fields' => array(
                    array(
                        'id' => 'styler_product_summary_start',
                        'type' => 'section',
                        'title' => esc_html__('Summary Elements Options', 'styler'),
                        'customizer' => true,
                        'indent' => true
                    ),
                    array(
                        'id' =>'single_shop_summary_layout_type',
                        'type' => 'button_set',
                        'title' => esc_html__( 'Product Summary Layouts', 'styler' ),
                        'customizer' => true,
                        'options' => array(
                            'default' => esc_html__( 'Default', 'styler' ),
                            'custom' => esc_html__( 'Custom Layout', 'styler' )
                        ),
                        'default' => 'default'
                    ),
                    array(
                        'id' =>'single_shop_summary_layouts',
                        'type' => 'sorter',
                        'title' => esc_html__( 'Product Summary Layouts Manager', 'styler' ),
                        'subtitle' => esc_html__( 'Organize how you want the layout to appear on the theme product page summary area.', 'styler' ),
                        'options' => array(
                            'show' => array(
                                'bread' => esc_html__( 'Breadcrumbs', 'styler' ),
                                'title' => esc_html__( 'Title', 'styler' ),
                                'rating' => esc_html__( 'Rating', 'styler' ),
                                'price' => esc_html__( 'Price', 'styler' ),
                                'excerpt' => esc_html__( 'Excerpt', 'styler' ),
                                'cart' => esc_html__( 'Cart', 'styler' ),
                                'meta' => esc_html__( 'Meta', 'styler' ),
                            ),
                            'hide' => array()
                        ),
                        'required' => array( 'single_shop_summary_layout_type', '=', 'custom' )
                    ),
                    array(
                        'title' => esc_html__( 'Sticky Summary', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_sticky_summary',
                        'type' => 'switch',
                        'default' => 0
                    ),
                    array(
                        'title' => esc_html__('Products All Labels', 'styler'),
                        'subtitle' => esc_html__('Sale, Stock, Discount', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_top_labels_visibility',
                        'type' => 'switch',
                        'default' => 1
                    ),
                    array(
                        'title' => esc_html__( 'Delivery & Return', 'styler' ),
                        'subtitle' => esc_html__( 'Select an elementor template from list', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_delivery_template',
                        'type' => 'select',
                        'data' => 'posts',
                        'args' => $el_args
                    ),
                    array(
                        'title' => esc_html__('Title for Delivery & Return', 'styler'),
                        'subtitle' => esc_html__('Default: Delivery & Return', 'styler'),
                        'customizer' => true,
                        'id' => 'product_delivery_return_title',
                        'type' => 'text',
                        'default' => ''
                    ),
                    array(
                        'title' => esc_html__( 'Category(s) Exclude ( Delivery & Return )', 'styler' ),
                        'subtitle' => esc_html__( 'Select category(s) from the list.', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_delivery_template_category_exclude',
                        'type' => 'select',
                        'data' => 'terms',
                        'multi' => true,
                        'args'  => [
                            'taxonomies' => array( 'product_cat' ),
                        ],
                        'required' => array( 'single_shop_delivery_template', '!=', '' )
                    ),
                    array(
                        'title' => esc_html__( 'Size Guide', 'styler' ),
                        'subtitle' => esc_html__( 'Select an elementor template from list', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_question_form_template',
                        'type' => 'select',
                        'data' => 'posts',
                        'args' => $el_args
                    ),
                    array(
                        'title' => esc_html__('Title for Size Guide', 'styler'),
                        'subtitle' => esc_html__('Default: Size Guide', 'styler'),
                        'customizer' => true,
                        'id' => 'product_shop_question_title',
                        'type' => 'text',
                        'default' => ''
                    ),
                    array(
                        'title' => esc_html__( 'Category(s) Exclude ( Size Guide )', 'styler' ),
                        'subtitle' => esc_html__( 'Select category(s) from the list.', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_question_template_category_exclude',
                        'type' => 'select',
                        'data' => 'terms',
                        'multi' => true,
                        'args'  => [
                            'taxonomies' => array( 'product_cat' ),
                        ],
                        'required' => array( 'single_shop_question_form_template', '!=', '' )
                    ),
                    array(
                        'title' => esc_html__('Meta', 'styler'),
                        'subtitle' => esc_html__('SKU, Categories, Tags', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_meta_visibility',
                        'type' => 'switch',
                        'default' => 1
                    ),
                    array(
                        'title' => esc_html__('Stock progress bar', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_progressbar_visibility',
                        'type' => 'switch',
                        'default' => 1
                    ),
                    array(
                        'title' => esc_html__('Countdown', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_countdown_visibility',
                        'type' => 'switch',
                        'default' => 1
                    ),
                    array(
                        'title' => esc_html__('Estimated Delivery', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_estimated_delivery_visibility',
                        'type' => 'switch',
                        'default' => 0
                    ),
                    array(
                        'title' => esc_html__('Title for Estimated Delivery', 'styler'),
                        'subtitle' => esc_html__('Default: Estimated Delivery', 'styler'),
                        'customizer' => true,
                        'id' => 'product_estimated_delivery_title',
                        'type' => 'text',
                        'default' => '',
                        'required' => array( 'single_shop_estimated_delivery_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Estimated Delivery ( Min )', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_min_estimated_delivery',
                        'type' => 'spinner',
                        'default' => '3',
                        'min' => '1',
                        'step' => '1',
                        'max' => '31',
                        'required' => array( 'single_shop_estimated_delivery_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Estimated Delivery ( Max )', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_max_estimated_delivery',
                        'type' => 'spinner',
                        'default' => '7',
                        'min' => '1',
                        'step' => '1',
                        'max' => '31',
                        'required' => array( 'single_shop_estimated_delivery_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Fake Visitor Count', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_visit_count_visibility',
                        'type' => 'switch',
                        'default' => 0
                    ),
                    array(
                        'title' => esc_html__('Fake Visitor Count ( Min )', 'styler'),
                        'customizer' => true,
                        'id' => 'visit_count_min',
                        'type' => 'spinner',
                        'default' => '10',
                        'min' => '1',
                        'step' => '1',
                        'max' => '100',
                        'required' => array( 'single_shop_visit_count_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Fake Visitor Count ( Max )', 'styler'),
                        'customizer' => true,
                        'id' => 'visit_count_max',
                        'type' => 'spinner',
                        'default' => '50',
                        'min' => '1',
                        'step' => '1',
                        'max' => '100',
                        'required' => array( 'single_shop_visit_count_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Fake Visitor Count ( Delay )', 'styler'),
                        'customizer' => true,
                        'id' => 'visit_count_delay',
                        'type' => 'spinner',
                        'default' => '30000',
                        'min' => '1000',
                        'step' => '100',
                        'max' => '100000',
                        'required' => array( 'single_shop_visit_count_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Fake Visitor Count ( Change )', 'styler'),
                        'customizer' => true,
                        'id' => 'visit_count_change',
                        'type' => 'spinner',
                        'default' => '5',
                        'min' => '1',
                        'step' => '1',
                        'max' => '50',
                        'required' => array( 'single_shop_visit_count_visibility', '=', '1' )
                    ),
                    array(
                        'id' => 'styler_product_summary_end',
                        'type' => 'section',
                        'customizer' => true,
                        'indent' => false
                    )
                )
            );
            $sections[] = array(
                'title' => esc_html__('Summary Customize', 'styler'),
                'id' => 'singleshopsummarycolors',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'title' => esc_html__( 'Title Typography', 'personx' ),
                        'id' => 'single_shop_product_title_typo',
                        'type' => 'typography',
                        'font-backup' => false,
                        'letter-spacing' => true,
                        'text-transform' => true,
                        'all_styles' => true,
                        'output' => array( '.nt-woo-single .styler-summary-item.styler-product-title' ),
                    ),
                    array(
                        'id' =>'single_shop_product_title_tag',
                        'type' => 'select',
                        'multiple' => false,
                        'title' => esc_html__( 'Product Title Tag', 'styler' ),
                        'options' => array(
                            'h1' => esc_html__( 'H1', 'styler' ),
                            'h2' => esc_html__( 'H2', 'styler' ),
                            'h3' => esc_html__( 'H3', 'styler' ),
                            'h4' => esc_html__( 'H4', 'styler' ),
                            'h5' => esc_html__( 'H5', 'styler' ),
                            'h6' => esc_html__( 'H6', 'styler' ),
                            'div' => esc_html__( 'Div', 'styler' )
                        ),
                        'default' => 'h2'
                    ),
                    array(
                        'title' => esc_html__( 'Price Typography', 'personx' ),
                        'id' => 'single_shop_product_price_typo',
                        'type' => 'typography',
                        'font-backup' => false,
                        'letter-spacing' => true,
                        'text-transform' => true,
                        'all_styles' => true,
                        'output' => array( '.nt-woo-single .styler-product-summary .styler-summary-item.styler-price.price span' ),
                    ),
                    array(
                        'title' => esc_html__( 'Excerpt Typography', 'personx' ),
                        'id' => 'single_shop_product_excerpt_typo',
                        'type' => 'typography',
                        'font-backup' => false,
                        'letter-spacing' => true,
                        'text-transform' => true,
                        'all_styles' => true,
                        'output' => array( '.nt-woo-single .woocommerce-product-details__short-description' ),
                    ),
                    array(
                        'title' => esc_html__( 'Meta && Extra Typography', 'personx' ),
                        'id' => 'single_shop_product_meta_typo',
                        'type' => 'typography',
                        'font-backup' => false,
                        'letter-spacing' => true,
                        'text-transform' => true,
                        'all_styles' => true,
                        'output' => array( '.styler-product-view span, .styler-estimated-delivery span, a.styler-open-popup, .styler-product-summary .styler-product-meta .styler-brands, .styler-product-summary .styler-product-meta .posted_in, .styler-product-summary .styler-product-meta .tagged_as, .styler-product-summary .styler-product-meta .styler-sku-wrapper' ),
                    ),
                    array(
                        'title' => esc_html__( 'Stock Status Typography', 'personx' ),
                        'id' => 'single_shop_product_stock_status_typo',
                        'type' => 'typography',
                        'font-backup' => false,
                        'letter-spacing' => true,
                        'text-transform' => true,
                        'all_styles' => true,
                        'output' => array( '.nt-woo-single .styler-summary-item.styler-price p.stock.styler-stock-status' )
                    ),
                    array(
                        'title' => esc_html__('Stock Status Background Color', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_stock_status_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'output' => array( '.nt-woo-single .styler-summary-item.styler-price p.stock.styler-stock-status' )
                    ),
                    array(
                        'title' => esc_html__('Stock Status Text Color', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_stock_status_color',
                        'type' => 'color',
                        'output' => array( '.nt-woo-single .styler-summary-item.styler-price p.stock.styler-stock-status' )
                    ),
                    array(
                        'title' => esc_html__('Out of Stock Background Color', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_outofstock_status_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'output' => array( '.nt-woo-single .styler-summary-item.styler-price p.stock.styler-stock-status.out-of-stock' )
                    ),
                    array(
                        'title' => esc_html__('Stock Status Text Color', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_outofstock_status_color',
                        'type' => 'color',
                        'output' => array( '.nt-woo-single .styler-summary-item.styler-price p.stock.styler-stock-status.out-of-stock' )
                    ),
                    array(
                        'title' => esc_html__( 'Progressbar Typography', 'personx' ),
                        'id' => 'single_shop_product_progressbar_typo',
                        'type' => 'typography',
                        'font-backup' => false,
                        'letter-spacing' => true,
                        'text-transform' => true,
                        'all_styles' => true,
                        'output' => array( '.nt-woo-single .styler-single-product-stock .stock-sold, .nt-woo-single .styler-single-product-stock .current-stock' )
                    ),
                    array(
                        'title' => esc_html__('Progressbar Color', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_progressbar_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'output' => array( '.styler-single-product-stock .styler-product-stock-progress' )
                    ),
                    array(
                        'title' => esc_html__('Progressbar Color 2', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_progressbar_bgcolor2',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'output' => array( '.styler-single-product-stock .styler-product-stock-progressbar' )
                    ),
                    array(
                        'id' => 'styler_product_addtocart_start',
                        'type' => 'section',
                        'title' => esc_html__('Add to Cart Color Options', 'styler'),
                        'customizer' => true,
                        'indent' => true
                    ),
                    array(
                        'title' => esc_html__('Variable Background Color', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_addtocart_container_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'output' => array( '.nt-woo-single .product .single-product-add-to-cart-type-black .woocommerce-variation-add-to-cart, .nt-woo-single .product .single-product-add-to-cart-type-gray .woocommerce-variation-add-to-cart' )
                    ),
                    array(
                        'title' => esc_html__('Background Color', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_addtocart_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'output' => array( '.styler-product-summary .styler-btn' )
                    ),
                    array(
                        'title' => esc_html__('Background Color ( Hover )', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_addtocart_hvrbgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'output' => array( '.styler-product-summary .styler-btn:hover' )
                    ),
                    array(
                        'title' => esc_html__('Title Color', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_addtocart_color',
                        'type' => 'color',
                        'output' => array( '.styler-product-summary .styler-btn' )
                    ),
                    array(
                        'title' => esc_html__('Title Color ( Hover )', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_addtocart_hvrcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'output' => array( '.styler-product-summary .styler-btn:hover' )
                    ),
                    array(
                        'title' => esc_html__('Wishlist && Compare Background Color', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_buttons_svg_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'output' => array( '.styler-product-summary .styler-product-button' )
                    ),
                    array(
                        'title' => esc_html__('Wishlist && Compare Background Color ( Hover )', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_buttons_svg_hvrbgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'output' => array( '.styler-product-summary .styler-product-button:hover' )
                    ),
                    array(
                        'title' => esc_html__('Wishlist && Compare Color ( Hover )', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_buttons_svg_color',
                        'type' => 'color',
                        'mode' => 'fill',
                        'output' => array( '.styler-product-summary .styler-product-button svg' )
                    ),
                    array(
                        'title' => esc_html__('Wishlist && Compare Color ( Hover )', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_buttons_svg_hvrcolor',
                        'type' => 'color',
                        'mode' => 'fill',
                        'output' => array( '.styler-product-summary .styler-product-button:hover svg' )
                    ),
                    array(
                        'id' => 'styler_product_addtocart_end',
                        'type' => 'section',
                        'customizer' => true,
                        'indent' => false,
                        'required' => array( 'product_tabs_type', '=', 'tabs' )
                    )
                )
            );
            $sections[] = array(
                'title' => esc_html__('Tabs', 'styler'),
                'id' => 'singleshoptabs',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'id' =>'product_tabs_type',
                        'type' => 'button_set',
                        'title' => esc_html__( 'Tabs Type', 'styler' ),
                        'options' => array(
                            'tabs' => esc_html__( 'Default Tabs', 'styler' ),
                            'accordion' => esc_html__( 'Accordion In Summary', 'styler' ),
                            'accordion-2' => esc_html__( 'Accordion After Summary', 'styler' )
                        ),
                        'default' => 'tabs'
                    ),
                    array(
                        'title' => esc_html__('Description Tab Title', 'styler'),
                        'customizer' => true,
                        'id' => 'product_description_tab_title_visibility',
                        'type' => 'switch',
                        'default' => 1
                    ),
                    array(
                        'title' => esc_html__('Description Tab Title', 'styler'),
                        'customizer' => true,
                        'id' => 'product_description_tab_title',
                        'type' => 'text',
                        'default' => '',
                        'required' => array( 'product_description_tab_title_visibility', '=', '1' )
                    ),
                    array(
                        'id' => 'styler_product_accordion_start',
                        'type' => 'section',
                        'title' => esc_html__('Accordion Color Options', 'styler'),
                        'customizer' => true,
                        'indent' => true,
                        'required' => array( 'product_tabs_type', '!=', 'tabs' )
                    ),
                    array(
                        'title' => esc_html__('Title Color', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_accordion_titlecolor',
                        'type' => 'color',
                        'output' => array( '.styler-accordion-header' ),
                        'required' => array( 'product_tabs_type', '!=', 'tabs' )
                    ),
                    array(
                        'title' => esc_html__('Title Color ( Active )', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_accordion_active_titlecolor',
                        'type' => 'color',
                        'output' => array( '.styler-accordion-item.active .styler-accordion-header' ),
                        'required' => array( 'product_tabs_type', '!=', 'tabs' )
                    ),
                    array(
                        'title' => esc_html__('Title Background Color', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_accordion_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'output' => array( '.styler-accordion-item' ),
                        'required' => array( 'product_tabs_type', '!=', 'tabs' )
                    ),
                    array(
                        'title' => esc_html__('Title Background Color ( Active )', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_accordion_active_bgcolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'output' => array( '.styler-accordion-item.active .styler-accordion-header' ),
                        'required' => array( 'product_tabs_type', '!=', 'tabs' )
                    ),
                    array(
                        'title' => esc_html__('Content Text Color', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_accordion_textcolor',
                        'type' => 'color',
                        'output' => array( '.styler-accordion-body,.styler-product-showcase.styler-bg-custom .product-desc-content h4,.styler-product-showcase.styler-bg-custom .product-desc-content .title' ),
                        'required' => array( 'product_tabs_type', '!=', 'tabs' )
                    ),
                    array(
                        'title' => esc_html__('Border Color', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_accordion_bordercolor',
                        'type' => 'color',
                        'mode' => 'border-color',
                        'output' => array( '.styler-accordion-item' ),
                        'required' => array( 'product_tabs_type', '!=', 'tabs' )
                    ),
                    array(
                        'id' => 'styler_product_accordion_end',
                        'type' => 'section',
                        'customizer' => true,
                        'indent' => false,
                        'required' => array( 'product_tabs_type', '!=', 'tabs' )
                    ),
                    array(
                        'id' => 'styler_product_tabs_start',
                        'type' => 'section',
                        'title' => esc_html__('Tabs Color Options', 'styler'),
                        'customizer' => true,
                        'indent' => true,
                        'required' => array( 'product_tabs_type', '=', 'tabs' )
                    ),
                    array(
                        'title' => esc_html__('Title Color', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_tabs_titlecolor',
                        'type' => 'color',
                        'output' => array( '.styler-product-tab-title-item' ),
                        'required' => array( 'product_tabs_type', '=', 'tabs' )
                    ),
                    array(
                        'title' => esc_html__('Title Color ( Active )', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_tabs_active_titlecolor',
                        'type' => 'color',
                        'output' => array( '.styler-product-tab-title-item.active' ),
                        'required' => array( 'product_tabs_type', '=', 'tabs' )
                    ),
                    array(
                        'title' => esc_html__('Title Border Color ( Active )', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_tabs_active_bordercolor',
                        'type' => 'color',
                        'mode' => 'background-color',
                        'output' => array( '.styler-product-tab-title-item::after' ),
                        'required' => array( 'product_tabs_type', '=', 'tabs' )
                    ),
                    array(
                        'title' => esc_html__('Tabs Border Bottom Color', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_tabs_bordercolor',
                        'type' => 'color',
                        'mode' => 'border-bottom-color',
                        'output' => array( '.styler-product-tab-title' ),
                        'required' => array( 'product_tabs_type', '=', 'tabs' )
                    ),
                    array(
                        'id' => 'styler_product_tabs_end',
                        'type' => 'section',
                        'customizer' => true,
                        'indent' => false,
                        'required' => array( 'product_tabs_type', '=', 'tabs' )
                    )
                )
            );
            // SHOP PAGE SECTION
            $sections[] = array(
                'title' => esc_html__('Related Posts', 'styler'),
                'id' => 'singleshoprelated',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'title' => esc_html__('Related Section', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_ralated_visibility',
                        'type' => 'switch',
                        'default' => 1
                    ),
                    array(
                        'title' => esc_html__('Related Title', 'styler'),
                        'subtitle' => esc_html__('Add your single shop page related section title here.', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_related_title',
                        'type' => 'text',
                        'default' => '',
                        'required' => array( 'single_shop_ralated_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Post Count ( Per Page )', 'styler'),
                        'subtitle' => esc_html__('You can control show related post count with this option.', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_related_count',
                        'type' => 'slider',
                        'default' => 10,
                        'min' => 1,
                        'step' => 1,
                        'max' => 24,
                        'display_value' => 'text',
                        'required' => array( 'single_shop_ralated_visibility', '=', '1' )
                    ),
                    array(
                        'id' => 'shop_related_section_slider_start',
                        'type' => 'section',
                        'title' => esc_html__('Related Slider Options', 'styler'),
                        'customizer' => true,
                        'indent' => true,
                        'required' => array( 'single_shop_ralated_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__( 'Perview ( Min 1024px )', 'styler' ),
                        'subtitle' => esc_html__( 'You can control related post slider item count for big device with this option.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_related_perview',
                        'type' => 'slider',
                        'default' => 4,
                        'min' => 1,
                        'step' => 1,
                        'max' => 10,
                        'display_value' => 'text',
                        'required' => array( 'single_shop_ralated_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__( 'Perview ( Min 768px )', 'styler' ),
                        'subtitle' => esc_html__( 'You can control related post slider item count for big device with this option.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_related_mdperview',
                        'type' => 'slider',
                        'default' => 3,
                        'min' => 1,
                        'step' => 1,
                        'max' => 10,
                        'display_value' => 'text',
                        'required' => array( 'single_shop_ralated_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__( 'Perview ( Min 480px )', 'styler' ),
                        'subtitle' => esc_html__( 'You can control related post slider item count for big device with this option.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_related_smperview',
                        'type' => 'slider',
                        'default' => 2,
                        'min' => 1,
                        'step' => 1,
                        'max' => 10,
                        'display_value' => 'text',
                        'required' => array( 'single_shop_ralated_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__( 'Speed', 'styler' ),
                        'subtitle' => esc_html__( 'You can control related post slider item gap.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_related_speed',
                        'type' => 'slider',
                        'default' => 1000,
                        'min' => 100,
                        'step' => 1,
                        'max' => 10000,
                        'display_value' => 'text',
                        'required' => array( 'single_shop_ralated_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__( 'Gap', 'styler' ),
                        'subtitle' => esc_html__( 'You can control related post slider item gap.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_related_gap',
                        'type' => 'slider',
                        'default' => 30,
                        'min' => 0,
                        'step' => 1,
                        'max' => 100,
                        'display_value' => 'text',
                        'required' => array( 'single_shop_ralated_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__( 'Autoplay', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_related_autoplay',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array( 'single_shop_ralated_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__( 'Loop', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_related_loop',
                        'type' => 'switch',
                        'default' => 0,
                        'required' => array( 'single_shop_ralated_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__( 'Mousewheel', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_related_mousewheel',
                        'type' => 'switch',
                        'default' => 0,
                        'required' => array( 'single_shop_ralated_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__( 'Free Mode', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_related_freemode',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array( 'single_shop_ralated_visibility', '=', '1' )
                    ),
                    array(
                        'id' => 'shop_related_section_slider_end',
                        'type' => 'section',
                        'customizer' => true,
                        'indent' => false,
                        'required' => array( 'single_shop_ralated_visibility', '=', '1' )
                    )
                )
            );
            // SHOP PAGE SECTION
            $sections[] = array(
                'title' => esc_html__('Upsells Posts', 'styler'),
                'id' => 'singleshopupsells',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'title' => esc_html__('Upsells Title', 'styler'),
                        'subtitle' => esc_html__('Add your single shop page upsells section title here.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_upsells_title',
                        'type' => 'text',
                        'default' => ''
                    ),
                    array(
                        'id' =>'shop_upsells_type',
                        'type' => 'button_set',
                        'title' => esc_html__('Upsells Layout Type', 'styler'),
                        'subtitle' => esc_html__( 'Organize how you want the layout to appear on the theme shop product page upsells.', 'styler' ),
                        'customizer' => true,
                        'options' => array(
                            'slider' => esc_html__( 'Slider', 'styler' ),
                            'grid' => esc_html__( 'Grid', 'styler' )
                        ),
                        'default' => 'slider'
                    ),
                    array(
                        'title' => esc_html__('Post Column', 'styler'),
                        'subtitle' => esc_html__('You can control upsells post column with this option.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_upsells_colxl',
                        'type' => 'slider',
                        'default' => 4,
                        'min' => 1,
                        'step' => 1,
                        'max' => 6,
                        'display_value' => 'text',
                        'required' => array( 'shop_upsells_type', '=', 'grid' )
                    ),
                    array(
                        'title' => esc_html__('Post Column ( Desktop/Tablet )', 'styler'),
                        'subtitle' => esc_html__('You can control upsells post column for tablet device with this option.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_upsells_collg',
                        'type' => 'slider',
                        'default' => 3,
                        'min' => 1,
                        'step' => 1,
                        'max' => 4,
                        'display_value' => 'text',
                        'required' => array( 'shop_upsells_type', '=', 'grid' )
                    ),
                    array(
                        'title' => esc_html__('Post Column ( Tablet )', 'styler'),
                        'subtitle' => esc_html__('You can control upsells post column for phone device with this option.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_upsells_colsm',
                        'type' => 'slider',
                        'default' => 1,
                        'min' => 1,
                        'step' => 1,
                        'max' => 3,
                        'display_value' => 'text',
                        'required' => array( 'shop_upsells_type', '=', 'grid' )
                    ),
                    array(
                        'title' => esc_html__('Post Column ( Phone )', 'styler'),
                        'subtitle' => esc_html__('You can control upsells post column for phone device with this option.', 'styler'),
                        'customizer' => true,
                        'id' => 'shop_upsells_colxs',
                        'type' => 'slider',
                        'default' => 1,
                        'min' => 1,
                        'step' => 1,
                        'max' => 3,
                        'display_value' => 'text',
                        'required' => array( 'shop_upsells_type', '=', 'grid' )
                    ),
                    array(
                        'id' => 'shop_upsells_section_slider_start',
                        'type' => 'section',
                        'title' => esc_html__('Related Slider Options', 'styler'),
                        'customizer' => true,
                        'indent' => true,
                        'required' => array( 'shop_upsells_type', '=', 'slider' )
                    ),
                    array(
                        'title' => esc_html__( 'Perview ( Min 1024px )', 'styler' ),
                        'subtitle' => esc_html__( 'You can control related post slider item count for big device with this option.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_upsells_perview',
                        'type' => 'slider',
                        'default' => 4,
                        'min' => 1,
                        'step' => 1,
                        'max' => 10,
                        'display_value' => 'text',
                        'required' => array( 'shop_upsells_type', '=', 'slider' )
                    ),
                    array(
                        'title' => esc_html__( 'Perview ( Min 768px )', 'styler' ),
                        'subtitle' => esc_html__( 'You can control related post slider item count for big device with this option.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_upsells_mdperview',
                        'type' => 'slider',
                        'default' => 3,
                        'min' => 1,
                        'step' => 1,
                        'max' => 10,
                        'display_value' => 'text',
                        'required' => array( 'shop_upsells_type', '=', 'slider' )
                    ),
                    array(
                        'title' => esc_html__( 'Perview ( Min 480px )', 'styler' ),
                        'subtitle' => esc_html__( 'You can control related post slider item count for big device with this option.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_upsells_smperview',
                        'type' => 'slider',
                        'default' => 2,
                        'min' => 1,
                        'step' => 1,
                        'max' => 10,
                        'display_value' => 'text',
                        'required' => array( 'shop_upsells_type', '=', 'slider' )
                    ),
                    array(
                        'title' => esc_html__( 'Speed', 'styler' ),
                        'subtitle' => esc_html__( 'You can control related post slider item gap.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_upsells_speed',
                        'type' => 'slider',
                        'default' => 1000,
                        'min' => 100,
                        'step' => 1,
                        'max' => 10000,
                        'display_value' => 'text',
                        'required' => array( 'shop_upsells_type', '=', 'slider' )
                    ),
                    array(
                        'title' => esc_html__( 'Gap', 'styler' ),
                        'subtitle' => esc_html__( 'You can control related post slider item gap.', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_upsells_gap',
                        'type' => 'slider',
                        'default' => 30,
                        'min' => 0,
                        'step' => 1,
                        'max' => 100,
                        'display_value' => 'text',
                        'required' => array( 'shop_upsells_type', '=', 'slider' )
                    ),
                    array(
                        'title' => esc_html__( 'Autoplay', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_upsells_autoplay',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array( 'shop_upsells_type', '=', 'slider' )
                    ),
                    array(
                        'title' => esc_html__( 'Loop', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_upsells_loop',
                        'type' => 'switch',
                        'default' => 0,
                        'required' => array( 'shop_upsells_type', '=', 'slider' )
                    ),
                    array(
                        'title' => esc_html__( 'Mousewheel', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_upsells_mousewheel',
                        'type' => 'switch',
                        'default' => 0,
                        'required' => array( 'shop_upsells_type', '=', 'slider' )
                    ),
                    array(
                        'title' => esc_html__( 'Free Mode', 'styler' ),
                        'customizer' => true,
                        'id' => 'shop_upsells_freemode',
                        'type' => 'switch',
                        'default' => 0,
                        'required' => array( 'shop_upsells_type', '=', 'slider' )
                    ),
                    array(
                        'id' => 'shop_upsells_section_slider_end',
                        'type' => 'section',
                        'customizer' => true,
                        'indent' => false,
                        'required' => array( 'shop_upsells_type', '=', 'slider' )
                    )
                )
            );
            // SINGLE CONTENT SUBSECTION
            $sections[] = array(
                'title' => esc_html__('Single Content', 'styler'),
                'id' => 'singleshopcontentsubsection',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'title' => esc_html__('Single Content Padding', 'styler'),
                        'subtitle' => esc_html__('You can set the top spacing of the site single page content.', 'styler'),
                        'customizer' => true,
                        'id' =>'single_shop_content_pad',
                        'type' => 'spacing',
                        'output' => array('#nt-woo-single .nt-styler-inner-container'),
                        'mode' => 'padding',
                        'units' => array('em', 'px'),
                        'units_extended' => 'false'
                    )
                )
            );
            // SINGLE CONTENT SUBSECTION
            $sections[] = array(
                'title' => esc_html__('Share Buttons', 'styler'),
                'id' => 'singleshopsharesubsection',
                'subsection' => true,
                'icon' => 'el el-brush',
                'fields' => array(
                    array(
                        'title' => esc_html__('Products share', 'styler'),
                        'customizer' => true,
                        'id' => 'single_shop_share_visibility',
                        'type' => 'switch',
                        'default' => 1
                    ),
                    array(
                        'title' => esc_html__( 'Share type', 'styler' ),
                        'subtitle' => esc_html__( 'Select your product share type.', 'styler' ),
                        'customizer' => true,
                        'id' => 'single_shop_share_type',
                        'type' => 'select',
                        'multiple' => false,
                        'options' => array(
                            'share' => esc_html__( 'Share', 'styler' ),
                            'follow' => esc_html__( 'follow', 'styler' )
                        ),
                        'default' => 'share',
                        'required' => array( 'single_shop_share_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Facebook', 'styler'),
                        'customizer' => true,
                        'id' => 'share_facebook',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array( 'single_shop_share_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Facebook link', 'styler'),
                        'customizer' => true,
                        'id' => 'facebook_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'share_facebook', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Twitter', 'styler'),
                        'customizer' => true,
                        'id' => 'share_twitter',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array( 'single_shop_share_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Twitter link', 'styler'),
                        'customizer' => true,
                        'id' => 'twitter_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'share_twitter', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Instagram', 'styler'),
                        'customizer' => true,
                        'id' => 'share_instagram',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Instagram link', 'styler'),
                        'customizer' => true,
                        'id' => 'instagram_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' ),
                            array( 'share_instagram', '=', '1' ),
                        )
                    ),
                    array(
                        'title' => esc_html__('Youtube', 'styler'),
                        'customizer' => true,
                        'id' => 'share_youtube',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Youtube link', 'styler'),
                        'customizer' => true,
                        'id' => 'youtube_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' ),
                            array( 'share_youtube', '=', '1' ),
                        )
                    ),
                    array(
                        'title' => esc_html__('Vimeo', 'styler'),
                        'customizer' => true,
                        'id' => 'share_vimeo',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Vimeo link', 'styler'),
                        'customizer' => true,
                        'id' => 'vimeo_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' ),
                            array( 'share_vimeo', '=', '1' ),
                        )
                    ),
                    array(
                        'title' => esc_html__('Pinterest', 'styler'),
                        'customizer' => true,
                        'id' => 'share_pinterest',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array( 'single_shop_share_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Pinterest link', 'styler'),
                        'customizer' => true,
                        'id' => 'pinterest_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'share_pinterest', '=', '1' ),
                        )
                    ),
                    array(
                        'title' => esc_html__('Linkedin', 'styler'),
                        'customizer' => true,
                        'id' => 'share_linkedin',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array( 'single_shop_share_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Linkedin link', 'styler'),
                        'customizer' => true,
                        'id' => 'linkedin_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'share_linkedin', '=', '1' ),
                        )
                    ),
                    array(
                        'title' => esc_html__('Tumblr', 'styler'),
                        'customizer' => true,
                        'id' => 'share_tumblr',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Tumblr link', 'styler'),
                        'customizer' => true,
                        'id' => 'tumblr_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' ),
                            array( 'share_tumblr', '=', '1' ),
                        )
                    ),
                    array(
                        'title' => esc_html__('Flickr', 'styler'),
                        'customizer' => true,
                        'id' => 'share_flickr',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Flickr link', 'styler'),
                        'customizer' => true,
                        'id' => 'flickr_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' ),
                            array( 'share_flickr', '=', '1' ),
                        )
                    ),
                    array(
                        'title' => esc_html__('Github', 'styler'),
                        'customizer' => true,
                        'id' => 'share_github',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Github link', 'styler'),
                        'customizer' => true,
                        'id' => 'github_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' ),
                            array( 'share_github', '=', '1' ),
                        )
                    ),
                    array(
                        'title' => esc_html__('Behance', 'styler'),
                        'customizer' => true,
                        'id' => 'share_behance',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Behance link', 'styler'),
                        'customizer' => true,
                        'id' => 'behance_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' ),
                            array( 'share_behance', '=', '1' ),
                        )
                    ),
                    array(
                        'title' => esc_html__('Dribbble', 'styler'),
                        'customizer' => true,
                        'id' => 'share_dribbble',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Dribbble link', 'styler'),
                        'customizer' => true,
                        'id' => 'dribbble_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' ),
                            array( 'share_dribbble', '=', '1' ),
                        )
                    ),
                    array(
                        'title' => esc_html__('Soundcloud', 'styler'),
                        'customizer' => true,
                        'id' => 'share_soundcloud',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Soundcloud link', 'styler'),
                        'customizer' => true,
                        'id' => 'soundcloud_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' ),
                            array( 'share_soundcloud', '=', '1' ),
                        )
                    ),
                    array(
                        'title' => esc_html__('Spotify', 'styler'),
                        'customizer' => true,
                        'id' => 'share_spotify',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Spotify link', 'styler'),
                        'customizer' => true,
                        'id' => 'spotify_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' ),
                            array( 'share_spotify', '=', '1' ),
                        )
                    ),
                    array(
                        'title' => esc_html__('Ok', 'styler'),
                        'customizer' => true,
                        'id' => 'share_ok',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array( 'single_shop_share_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Ok link', 'styler'),
                        'customizer' => true,
                        'id' => 'ok_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'share_ok', '=', '1' ),
                        )
                    ),
                    array(
                        'title' => esc_html__('Whatsapp', 'styler'),
                        'customizer' => true,
                        'id' => 'share_whatsapp',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array( 'single_shop_share_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Whatsapp link', 'styler'),
                        'customizer' => true,
                        'id' => 'whatsapp_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'share_whatsapp', '=', '1' ),
                        )
                    ),
                    array(
                        'title' => esc_html__('Telegram', 'styler'),
                        'customizer' => true,
                        'id' => 'share_telegram',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array( 'single_shop_share_visibility', '=', '1' )
                    ),
                    array(
                        'title' => esc_html__('Telegram link', 'styler'),
                        'customizer' => true,
                        'id' => 'telegram_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'share_telegram', '=', '1' ),
                        )
                    ),
                    array(
                        'title' => esc_html__('Viber', 'styler'),
                        'customizer' => true,
                        'id' => 'share_viber',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'share' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Viber link', 'styler'),
                        'customizer' => true,
                        'id' => 'viber_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'share' ),
                            array( 'share_viber', '=', '1' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Tiktok', 'styler'),
                        'customizer' => true,
                        'id' => 'share_tiktok',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Tiktok link', 'styler'),
                        'customizer' => true,
                        'id' => 'tiktok_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' ),
                            array( 'share_tiktok', '=', '1' ),
                        )
                    ),
                    array(
                        'title' => esc_html__('Snapchat', 'styler'),
                        'customizer' => true,
                        'id' => 'share_snapchat',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' )
                        )
                    ),
                    array(
                        'title' => esc_html__('Snapchat link', 'styler'),
                        'customizer' => true,
                        'id' => 'snapchat_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'single_shop_share_type', '=', 'follow' ),
                            array( 'share_snapchat', '=', '1' ),
                        )
                    ),
                    array(
                        'title' => esc_html__('Vk', 'styler'),
                        'customizer' => true,
                        'id' => 'share_vk',
                        'type' => 'switch',
                        'default' => 1,
                        'required' => array( 'single_shop_share_visibility', '=', '1' ),
                    ),
                    array(
                        'title' => esc_html__('Vk link', 'styler'),
                        'customizer' => true,
                        'id' => 'vk_link',
                        'type' => 'text',
                        'default' => '',
                        'required' => array(
                            array( 'single_shop_share_visibility', '=', '1' ),
                            array( 'share_vk', '=', '1' ),
                        )
                    ),
                )
            );
            if ( class_exists( 'WooCommerce' ) ) {
                $sections[] = array(
                    'id' => 'inportexport_settings',
                    'title' => esc_html__( 'Import / Export', 'styler' ),
                    'desc' => esc_html__( 'Import and Export your Theme Options from text or URL.', 'styler' ),
                    'icon' => 'fa fa-download',
                    'fields' => array(
                        array(
                            'id' => 'opt-import-export',
                            'type' => 'import_export',
                            'title' => '',
                            'customizer' => false,
                            'subtitle' => '',
                            'full_width' => true
                        )
                    )
                );
                $sections[] = array(
                    'id' => 'nt_support_settings',
                    'title' => esc_html__( 'Support', 'styler' ),
                    'icon' => 'el el-idea',
                    'fields' => array(
                        array(
                            'id' => 'doc',
                            'type' => 'raw',
                            'markdown' => true,
                            'class' => 'theme_support',
                            'content' => '<div class="support-section">
                            <h5>'.esc_html__( 'WE RECOMMEND YOU READ IT BEFORE YOU START', 'styler' ).'</h5>
                            <h2><i class="el el-website"></i> '.esc_html__( 'DOCUMENTATION', 'styler' ).'</h2>
                            <a target="_blank" class="button" href="https://ninetheme.com/docs/styler/">'.esc_html__( 'READ MORE', 'styler' ).'</a>
                            </div>'
                        ),
                        array(
                            'id' => 'support',
                            'type' => 'raw',
                            'markdown' => true,
                            'class' => 'theme_support',
                            'content' => '<div class="support-section">
                            <h5>'.esc_html__( 'DO YOU NEED HELP?', 'styler' ).'</h5>
                            <h2><i class="el el-adult"></i> '.esc_html__( 'SUPPORT CENTER', 'styler' ).'</h2>
                            <a target="_blank" class="button" href="https://ninetheme.com/contact/">'.esc_html__( 'GET SUPPORT', 'styler' ).'</a>
                            </div>'
                        ),
                        array(
                            'id' => 'portfolio',
                            'type' => 'raw',
                            'markdown' => true,
                            'class' => 'theme_support',
                            'content' => '<div class="support-section">
                            <h5>'.esc_html__( 'SEE MORE THE NINETHEME WORDPRESS THEMES', 'styler' ).'</h5>
                            <h2><i class="el el-picture"></i> '.esc_html__( 'NINETHEME PORTFOLIO', 'styler' ).'</h2>
                            <a target="_blank" class="button" href="https://ninetheme.com/themes/">'.esc_html__( 'SEE MORE', 'styler' ).'</a>
                            </div>'
                        ),
                        array(
                            'id' => 'like',
                            'type' => 'raw',
                            'markdown' => true,
                            'class' => 'theme_support',
                            'content' => '<div class="support-section">
                            <h5>'.esc_html__( 'WOULD YOU LIKE TO REWARD OUR EFFORT?', 'styler' ).'</h5>
                            <h2><i class="el el-thumbs-up"></i> '.esc_html__( 'PLEASE RATE US!', 'styler' ).'</h2>
                            <a target="_blank" class="button" href="https://themeforest.net/downloads/">'.esc_html__( 'GET STARS', 'styler' ).'</a>
                            </div>'
                        )
                    )
                );
            }
            return $sections;
        }
        add_filter('redux/options/'.$styler_pre.'/sections', 'styler_dynamic_section');
    }
}


/*************************************************
## ADD THEME SUPPORT FOR WOOCOMMERCE
*************************************************/
if ( ! function_exists( 'styler_wc_shop_per_page' ) ) {
    add_action( 'after_setup_theme', 'styler_wc_theme_setup' );
    function styler_wc_theme_setup()
    {
        add_theme_support( 'styler' );
        add_theme_support( 'woocommerce', array(
            'thumbnail_image_width' => 450,
            'single_image_width'    => 980
        ) );
        if ( '1' == styler_settings('styler_product_zoom', '1') ) {
            add_theme_support( 'wc-product-gallery-zoom' );
        }
        $thumbs_layout = apply_filters( 'styler_product_thumbs_layout', styler_settings( 'product_thumbs_layout', 'slider' ) );
        if ( $thumbs_layout == 'wc' ) {
            add_theme_support( 'wc-product-gallery-zoom' );
            add_theme_support( 'wc-product-gallery-lightbox' );
            add_theme_support( 'wc-product-gallery-slider' );
        }
    }
}


// Remove each style one by one
if ( ! function_exists( 'styler_dequeue_wc_styles' ) ) {
    add_filter( 'woocommerce_enqueue_styles', 'styler_dequeue_wc_styles' );
    function styler_dequeue_wc_styles( $styles ) {
        unset( $styles['woocommerce-general'] ); // Remove the gloss
        unset( $styles['woocommerce-layout'] ); // Remove the layout
        unset( $styles['woocommerce-smallscreen'] ); // Remove the smallscreen optimisation
        return $styles;
    }
}


/*************************************************
## THEME CUSTOM CSS AND JS FOR WOOCOMMERCE
*************************************************/

if ( ! function_exists( 'styler_wc_scripts' ) ) {
    function styler_wc_scripts()
    {
        wp_enqueue_style( 'styler-wc', get_template_directory_uri() . '/woocommerce/assets/css/woocommerce-general.css',false, '1.0');

        if ( class_exists('WeDevs_Dokan') ) {
            wp_enqueue_style( 'styler-dokan', get_template_directory_uri() . '/woocommerce/assets/css/dokan.css',false, '1.0');
        }

        if ( class_exists('WCFMmp') ) {
            wp_enqueue_style( 'styler-wcfm', get_template_directory_uri() . '/woocommerce/assets/css/wcfm.css',false, '1.0');
        }

        wp_enqueue_script('styler-wc', get_template_directory_uri() . '/woocommerce/assets/js/woocommerce-general.js', array('jquery'), '1.0', true);

        if ( is_shop() || is_product_category() || is_product_tag() || is_tax( 'styler_product_brands' ) ) {

            if ( '1' == styler_settings('shop_ajax_filter', '0' ) ) {
                wp_enqueue_script( 'pjax', get_template_directory_uri() . '/woocommerce/assets/js/pjax.js', array('jquery'), '1.0', true );
                wp_enqueue_script( 'shopAjaxFilter', get_template_directory_uri() . '/woocommerce/assets/js/shopAjaxFilter.js', array('jquery', 'pjax'), '1.0', true );
            }

            $pagination = apply_filters('styler_shop_pagination_type', styler_settings('shop_paginate_type') );
            if ( $pagination == 'infinite' ) {
                wp_enqueue_script( 'styler-load-more', get_template_directory_uri(). '/woocommerce/assets/js/infinite-scroll.js', array( 'jquery' ), false, '1.0' );
            }

            if ( $pagination == 'loadmore' ) {
                wp_enqueue_script( 'styler-load-more', get_template_directory_uri(). '/woocommerce/assets/js/load_more.js', array( 'jquery' ), false, '1.0' );
            }
        }

        wp_enqueue_script( 'styler-quantity-button', get_template_directory_uri() . '/woocommerce/assets/js/quantity_button.js', array('jquery'), '1.0.0', true );

        wp_dequeue_style( 'wc-blocks-vendors-style' );
        wp_dequeue_style( 'wc-blocks-style' );

    }
    //add_action( 'wp_enqueue_scripts', 'styler_wc_scripts' );
}

if ( ! function_exists( 'styler_wc_widgets_init' ) ) {
    function ajax_login_init()
    {

        if ( '1' != styler_settings( 'wc_ajax_login_register', '1' ) ) {
            return;
        }

        wp_enqueue_script( 'styler-login-register-ajax', get_template_directory_uri() . '/woocommerce/assets/js/ajax-login-register-script.js', array( 'jquery' ), false, '1.0' );

        add_action( 'wp_ajax_nopriv_ajaxlogin', 'ajax_login' );
        add_action( 'wp_ajax_nopriv_ajaxregister', 'ajax_register' );
        add_action( "woocommerce_register_form_end", 'styler_register_message' );
    }
}

// Execute the action only if the user isn't logged in
if ( !is_user_logged_in() ) {
    add_action('init', 'ajax_login_init');
}

//ajax login function
function ajax_login(){

    // First check the nonce, if it fails the function will break
    check_ajax_referer( 'woocommerce-login', 'woocommerce-login-nonce' );

    if ( ! empty( $_POST['username'] ) && ! empty( $_POST['password'] ) ) {
        // Nonce is checked, get the POST data and sign user on
        $info = array();
        $info['user_login']    = wc_clean($_POST['username']);
        $info['user_password'] = $_POST['password'];
        $info['remember']      = false;
        if ( isset( $_POST['rememberme'] ) ) {
            $info['remember'] = true;
        }

        $user_signon = wp_signon( $info, false );
        if ( is_wp_error($user_signon) ) {

            if ( isset( $user_signon->errors[ 'invalid_username' ] ) ) {
                $username_error = true;
            } else{
                $username_error = false;
            }
            if ( isset( $user_signon->errors[ 'incorrect_password' ] ) ) {
                $password_error = true;
            } else {
                $password_error = false;
            }
            $error_string = $user_signon->get_error_message();

            echo json_encode( array(
                'loggedin'           => false,
                'message'            => $error_string,
                'invalid_username'   => $username_error,
                'incorrect_password' => $password_error,
            ));

        } else {
            // hook after successfull login
            do_action( "styler_after_login", $user_signon );
            $args = array(
                'loggedin' => true,
                'message'  => esc_html__( 'Login successful, redirecting...', 'styler' ),
                'redirect' => apply_filters( "styler_login_redirect", false )
            );

            echo json_encode( $args );
        }
        die();
    } else {
        echo json_encode( array('loggedin'=>false, 'message'=>esc_html__('Please fill all required fields.','styler') ) );
        die();
    }
}

/*
* Ajax register function
*/
function ajax_register(){

    // First check the nonce, if it fails the function will break
    check_ajax_referer( 'woocommerce-register', 'woocommerce-register-nonce' );

    $generate_password = get_option( 'woocommerce_registration_generate_password' );

    if ( ! empty( $_POST['email'] ) && ! empty( $_POST['password'] ) ) {
        $username = 'no' === get_option( 'woocommerce_registration_generate_username' ) ? $_POST['username'] : '';
        $password = 'no' === get_option( 'woocommerce_registration_generate_password' ) ? $_POST['password'] : '';
        $email    = $_POST['email'];

        $validation_error = new WP_Error();
        $validation_error = apply_filters( 'woocommerce_process_registration_errors', $validation_error, $username, $password, $email );

        if ( $validation_error->get_error_code() ) {

            $error_array = array(
                'code'    => $validation_error->get_error_code(),
                'message' => $validation_error->get_error_message()
            );
        } else {
            $new_customer = wc_create_new_customer( sanitize_email( $email ), wc_clean( $username ), $password );
            if ( is_wp_error( $new_customer ) ) {
                $error_array = array(
                    'code'    => $new_customer->get_error_code(),
                    'message' => $new_customer->get_error_message()
                );
            } else {
                if ( apply_filters( 'woocommerce_registration_auth_new_customer', true, $new_customer ) ) {
                    wc_set_customer_auth_cookie( $new_customer );
                }

                $args = array(
                    'code'     => 200,
                    'message'  =>esc_html__( 'Account created successfully. redirecting...', 'styler' ),
                    'redirect' => apply_filters( "styler_register_redirect", false )
                );
                apply_filters( "styler_register_user_successful", false );
                echo json_encode( $args );
                die();
            }
        }
    }
    elseif ( $generate_password == 'yes' ) {
        if ( empty( $_POST['email'] ) ) {
            $error_array = array(
                'code'    => 'error',
                'message' => esc_html__('Please fill all required fields.','styler')
            );
        } else {
            $username         = 'no' === get_option( 'woocommerce_registration_generate_username' ) ? $_POST['username'] : '';
            $email            = $_POST['email'];
            $validation_error = new WP_Error();
            $validation_error = apply_filters( 'woocommerce_process_registration_errors', $validation_error, $username, $password, $email );

            if ( $validation_error->get_error_code() ) {
                $error_array = array(
                    'code'    => $validation_error->get_error_code(),
                    'message' => $validation_error->get_error_message()
                );
            } else {
                $new_customer = wc_create_new_customer( sanitize_email( $email ), wc_clean( $username ));
                if ( is_wp_error( $new_customer ) ) {
                    $error_array = array(
                        'code'    => $new_customer->get_error_code(),
                        'message' => $new_customer->get_error_message()
                    );
                } else {
                    if ( apply_filters( 'woocommerce_registration_auth_new_customer', true, $new_customer ) ) {
                        wc_set_customer_auth_cookie( $new_customer );
                    }

                    $args = array(
                        'code'     => 200,
                        'message'  => esc_html__( 'Account created successfully. redirecting...', 'styler' ),
                        'redirect' => apply_filters( "styler_register_redirect", false )
                    );
                    echo json_encode( $args );
                    die();
                }
            }
        }
    }
    else {
        $error_array = array(
            'code' => 'error',
            'message' => esc_html__('Please fill all required fields.','styler')
        );
    }
    echo json_encode($error_array);
    die();
}

function styler_register_message(){
    global $woocommerce;
    ?>
    <input type="hidden" name="action" value="ajaxregister">
    <?php
}

/*************************************************
## REGISTER SIDEBAR FOR WOOCOMMERCE
*************************************************/

if ( ! function_exists( 'styler_wc_widgets_init' ) ) {
    add_action( 'widgets_init', 'styler_wc_widgets_init' );
    function styler_wc_widgets_init()
    {
        //Shop page sidebar
        register_sidebar( array(
            'id' => 'shop-page-sidebar',
            'name' => esc_html__( 'Shop Page Sidebar', 'styler' ),
            'description' => esc_html__( 'These widgets for the Shop page.','styler' ),
            'before_widget' => '<div class="nt-sidebar-inner-widget shop-widget styler-widget-show mb-40 %2$s">',
            'after_widget' => '</div>',
            'before_title' => '<h5 class="nt-sidebar-inner-widget-title shop-widget-title"><span class="nt-sidebar-widget-title">',
            'after_title' => '</span><span class="nt-sidebar-widget-toggle"></span></h5>'
        ) );
        //Single product sidebar
        register_sidebar( array(
            'id' => 'shop-single-sidebar',
            'name' => esc_html__( 'Shop Single Page Sidebar', 'styler' ),
            'description' => esc_html__( 'These widgets for the Shop Single page.','styler' ),
            'before_widget' => '<div class="nt-sidebar-inner-widget shop-widget styler-widget-show mb-40 %2$s">',
            'after_widget' => '</div>',
            'before_title' => '<h5 class="nt-sidebar-inner-widget-title shop-widget-title"><span class="styler-sidebar-widget-title">',
            'after_title' => '</span><span class="styler-sidebar-widget-toggle"></span></h5>'
        ) );
    }
}


/*************************************************
## WOOCOMMERCE PAGE TITLE FUNCTION
*************************************************/

if ( ! function_exists( 'styler_shop_page_title' ) ) {
    add_filter( 'woocommerce_page_title', 'styler_shop_page_title');
    function styler_shop_page_title( $page_title )
    {
        if ( 'Shop' == $page_title && styler_settings( 'shop_title' ) ) {
            return '<h2 class="nt-hero-title page-title mb-10">'.styler_settings( 'shop_title' ).'</h2>';
        } else {
            return '<h2 class="nt-hero-title page-title mb-10">'.$page_title.'</h2>';
        }
    }
}


/*************************************************
## WOOCOMMERCE HERO FUNCTION
*************************************************/

if ( ! function_exists( 'styler_wc_hero_section' ) ) {
    add_action( 'styler_before_shop_content', 'styler_wc_hero_section', 10 );
    function styler_wc_hero_section()
    {
        $name = is_product() ? 'single_shop' : 'shop';

        $hero_type        = styler_settings( $name.'_hero_layout_type', 'mini' );
        $template_id      = apply_filters( 'styler_shop_hero_template_id', intval( styler_settings( 'shop_hero_elementor_templates' ) ) );
        $cats_template_id = apply_filters( 'styler_shop_category_hero_template_id', intval( styler_settings( 'shop_cats_hero_elementor_templates' ) ) );
        $tax_template_id  = apply_filters( 'styler_shop_tags_hero_template_id', intval( styler_settings( 'shop_tax_hero_elementor_templates' ) ) );
        $is_elementor     = class_exists( '\Elementor\Frontend' ) ? true : false;
        $frontend         = $is_elementor ? new \Elementor\Frontend : false;

        if ( '0' != styler_settings($name.'_hero_visibility', '1') ) {

            if ( is_product_category() ) {

                styler_wc_archive_category_page_hero_section();

            } elseif ( is_product_tag() && $is_elementor && $tax_template_id  ) {

                printf( '<div class="styler-shop-hero-tag">%1$s</div>', $frontend->get_builder_content_for_display( $tax_template_id, false ) );

            } elseif ( ( is_shop() || is_product() ) && $is_elementor && $template_id  ) {

                printf( '<div class="styler-shop-custom-hero">%1$s</div>', $frontend->get_builder_content_for_display( $template_id, false ) );

            } else {
                ?>
                <div class="styler-shop-hero-wrapper">
                    <div class="styler-shop-hero styler-page-hero page-hero-<?php echo esc_attr( $hero_type ); ?>">
                        <div class="container-xl styler-container-xl">
                            <div class="row">
                                <div class="col-12">
                                    <div class="styler-page-hero-content styler-flex styler-align-center styler-justify-center">

                                        <?php
                                        if ( is_product() ) {
                                            the_title('<h2 class="styler-page-title styler-product-title">','</h2>');
                                        } else {
                                            woocommerce_page_title();
                                        }
                                        if ( $hero_type == 'big' ) {
                                            echo styler_wc_category_list();
                                        }
                                        if ( $hero_type == 'mini' ) {
                                            echo woocommerce_breadcrumb();
                                        }
                                        ?>
                                    </div>
                                    <?php
                                    if ( $hero_type == 'cat-slider' ) {
                                        styler_wc_hero_category_slider();
                                    }
                                    ?>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <?php
            }
        }
    }
}

if ( ! function_exists( 'styler_wc_default_hero_section' ) ) {

    function styler_wc_default_hero_section()
    {
        ?>
        <div class="styler-shop-hero-wrapper">
            <div class="styler-shop-hero styler-page-hero page-hero-mini">
                <div class="container-xl styler-container-xl">
                    <div class="row">
                        <div class="col-12">
                            <div class="styler-page-hero-content styler-flex styler-align-center styler-justify-center">

                                <?php
                                    woocommerce_page_title();
                                    echo woocommerce_breadcrumb();
                                ?>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <?php
    }
}

if ( ! function_exists( 'styler_wc_archive_category_page_hero_section' ) ) {

    function styler_wc_archive_category_page_hero_section()
    {
        $cats_template_id = apply_filters( 'styler_shop_category_hero_template_id', intval( styler_settings( 'shop_cats_hero_elementor_templates' ) ) );
        $is_elementor     = class_exists( '\Elementor\Frontend' ) ? true : false;
        $frontend         = $is_elementor ? new \Elementor\Frontend : false;
        $term_bg_id       = get_term_meta( get_queried_object_id(), 'styler_product_cat_hero_bgimage_id', true );
        $term_bg_url      = wp_get_attachment_image_url( $term_bg_id, 'large' );

        if ( $term_bg_url ) {
            ?>
            <div class="styler-shop-hero-wrapper">
                <div class="styler-shop-hero styler-page-hero page-hero-big has-bg-image" data-bg="<?php echo esc_url( $term_bg_url ); ?>">
                    <div class="container-xl styler-container-xl">
                        <div class="row justify-content-center">
                            <div class="col-12 col-sm-10 col-md-8 col-lg-6 col-xl-5">
                                <div class="styler-page-hero-content">
                                    <?php woocommerce_page_title(); ?>
                                    <?php do_action( 'woocommerce_archive_description' ); ?>
                                    <?php echo woocommerce_breadcrumb(); ?>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <?php
        } else {
            if ( $is_elementor && $cats_template_id ) {
                printf( '<div class="styler-shop-hero-cats">%1$s</div>', $frontend->get_builder_content_for_display( $cats_template_id, false ) );
            } else {
                styler_wc_default_hero_section();
            }
        }
    }
}



/*************************************************
## WOOCOMMERCE HERO CATEGORY SLIDER FUNCTION
*************************************************/

if ( ! function_exists( 'styler_wc_hero_category_slider' ) ) {
    function styler_wc_hero_category_slider()
    {
        $categories = get_terms( 'product_cat', array(
            'orderby'    => 'name',
            'order'      => 'asc',
            'hide_empty' => true,
            'parent'     => '1' == styler_settings( 'shop_hero_only_cats_parents' ) ? 0 : ''
        ));
        $options = '"spaceBetween":1,
        "centeredSlides":true,
        "centeredSlidesBounds":true,
        "loop":false,
        "autoplay":true,
        "spaceBetween": 0,
        "speed":2000,
        "slidesPerView":1,
        "pagination": false,
        "breakpoints": { "320": {"slidesPerView": 3},"768": {"slidesPerView": 3},"992": {"slidesPerView": 5},"1200": {"slidesPerView": 7}}';
        wp_enqueue_script( 'swiper' );
        if ( !empty( $categories ) ) {
            ?>
            <div class="styler-category-slider styler-swiper-slider swiper-container" data-swiper-options='{<?php echo esc_attr( $options ); ?>}'>
                <div class="swiper-wrapper">
                    <?php
                    foreach ( $categories as $category ) {
                        $thumbnail_id = get_term_meta( $category->term_id, 'thumbnail_id', true );
                        ?>
                        <div class="styler-category-slide-item swiper-slide">
                            <a href="<?php echo esc_url( get_term_link( $category ) ); ?>">
                                <?php echo wp_get_attachment_image( $thumbnail_id, array(100,100), true ); ?>
                                <span class="cat-count"><?php echo esc_html( $category->count ); ?></span>
                                <span class="category-title"><?php echo esc_html( $category->name ); ?></span>
                            </a>
                        </div>
                        <?php
                    }
                    ?>
                </div>
            </div>
            <?php
        }
    }
}

/*************************************************
## WOOCOMMERCE HERO CATEGORY LIST FUNCTION
*************************************************/

if ( ! function_exists( 'styler_wc_category_list' ) ) {
    function styler_wc_category_list()
    {
        $categories = get_terms( 'product_cat', array(
            'orderby'    => 'name',
            'order'      => 'asc',
            'hide_empty' => true,
            'parent'     => '1' == styler_settings( 'shop_hero_only_cats_parents' ) ? 0 : ''
        ));

        if ( !empty( $categories ) ) {
            ?>
            <ul class="styler-wc-category-list">
                <?php
                foreach ( $categories as $key => $category ) {
                    $thumbnail_id = get_term_meta( $category->term_id, 'thumbnail_id', true );
                    ?>
                    <li>
                        <a href="<?php echo esc_url( get_term_link( $category ) ); ?>">
                            <span class="category-title"><?php echo esc_html( $category->name ); ?></span>
                        </a>
                    </li>
                    <?php
                }
                ?>
            </ul>
            <?php
        }
    }
}


if ( ! function_exists( 'styler_before_shop_elementor_templates' ) ) {
    add_action( 'styler_before_shop_content', 'styler_before_shop_elementor_templates', 15 );
    function styler_before_shop_elementor_templates()
    {
        echo styler_print_elementor_templates( 'shop_before_content_templates', '', true );
    }
}

if ( ! function_exists( 'styler_after_shop_loop_elementor_templates' ) ) {
    add_action( 'styler_after_shop_loop', 'styler_after_shop_loop_elementor_templates', 10 );
    function styler_after_shop_loop_elementor_templates()
    {
        echo styler_print_elementor_templates( 'shop_after_loop_templates', '', true );
    }
}

if ( ! function_exists( 'styler_after_shop_page_elementor_templates' ) ) {
    add_action( 'styler_after_shop_page', 'styler_after_shop_page_elementor_templates', 10 );
    function styler_after_shop_page_elementor_templates()
    {
        echo styler_print_elementor_templates( 'shop_after_content_templates', '' );
    }
}


/*************************************************
## Get Columns options
*************************************************/
if ( ! function_exists( 'styler_get_shop_column' ) ) {
    function styler_get_shop_column()
    {
        $column = isset( $_GET['column'] ) ? $_GET['column'] : '';
        return esc_html($column);
    }
}


if ( ! function_exists( 'styler_shop_pagination' ) ) {
    add_action( 'styler_shop_pagination', 'styler_shop_pagination', 15 );
    function styler_shop_pagination()
    {
        $pagination = apply_filters('styler_shop_pagination_type', styler_settings('shop_paginate_type') );
        if ( $pagination == 'loadmore' ) {

            styler_load_more_button();

        } elseif ( $pagination == 'infinite' ) {

            styler_infinite_scroll();

        } else  {

            woocommerce_pagination();

        }
    }
}


if ( ! function_exists( 'styler_wc_filters_for_ajax' ) ) {
    function styler_wc_filters_for_ajax()
    {
        if ( '1' == styler_get_shop_column() ) {
            $type = 7;
        } else {
            $type = isset( $_GET['product_style'] ) && $_GET['product_style'] ? esc_html ( $_GET['product_style'] ) : styler_settings( 'shop_product_type', '3' );
            $type = apply_filters( 'styler_loop_product_type', $type );
        }
        return json_encode(
            array(
                'ajaxurl'        => esc_url( admin_url( 'admin-ajax.php' ) ),
                'current_page'   => get_query_var( 'paged' ) ? get_query_var( 'paged' ) : 1,
                'max_page'       => wc_get_loop_prop( 'total_pages' ),
                'per_page'       => isset( $_GET['per_page'] ) ? $_GET['per_page'] : wc_get_loop_prop( 'per_page' ),
                'layered_nav'    => WC_Query::get_layered_nav_chosen_attributes(),
                'cat_id'         => is_product_category() && isset( get_queried_object()->term_id ) ? get_queried_object()->term_id : '',
                'tag_id'         => is_product_tag() && isset( get_queried_object()->term_id ) ? get_queried_object()->term_id : '',
                'brand_id'       => isset( $_GET['brand_id'] ) ? $_GET['brand_id'] : '',
                'filter_cat'     => isset( $_GET['filter_cat'] ) ? $_GET['filter_cat'] : '',
                'on_sale'        => isset( $_GET['on_sale'] ) ? wc_get_product_ids_on_sale() : '',
                'orderby'        => isset( $_GET['orderby'] ) ? $_GET['orderby'] : '',
                'min_price'      => isset( $_GET['min_price'] ) ? $_GET['min_price'] : '',
                'max_price'      => isset( $_GET['max_price'] ) ? $_GET['max_price'] : '',
                'product_style'  => $type,
                'column'         => styler_get_shop_column(),
                'no_more'        => esc_html__( 'All Products Loaded', 'styler' )
            )
        );
    }
}


if ( ! function_exists( 'styler_get_cat_url' ) ) {
    function styler_get_cat_url( $termid )
    {
        global $wp;
        if ( '' === get_option( 'permalink_structure' ) ) {
            $link = remove_query_arg( array( 'page', 'paged' ), add_query_arg( $wp->query_string, '', home_url( $wp->request ) ) );
        } else {
            $link = preg_replace( '%\/page/[0-9]+%', '', add_query_arg( null, null ) );
        }

        if ( isset( $_GET['filter_cat'] ) ) {
            $explode_old = explode( ',', $_GET['filter_cat'] );
            $explode_termid = explode( ',', $termid );

            if ( in_array( $termid, $explode_old ) ) {
                $data = array_diff( $explode_old, $explode_termid );
                $checkbox = 'checked';
            } else {
                $data = array_merge( $explode_termid , $explode_old );
            }
        } else {
            $data = array( $termid );
        }

        $dataimplode = implode( ',', $data );

        if ( empty( $dataimplode ) ) {
            $link = remove_query_arg( 'filter_cat', $link );
        } else {
            $link = add_query_arg( 'filter_cat', implode( ',', $data ), $link );
        }

        return $link;
    }
}


if ( ! function_exists( 'styler_get_brand_url' ) ) {
    function styler_get_brand_url( $termid )
    {
        global $wp;
        if ( '' === get_option( 'permalink_structure' ) ) {
            $link = remove_query_arg( array( 'page', 'paged' ), add_query_arg( $wp->query_string, '', home_url( $wp->request ) ) );
        } else {
            $link = preg_replace( '%\/page/[0-9]+%', '', add_query_arg( null, null ) );
        }

        if ( isset( $_GET['brand_id'] ) ) {
            $explode_old = explode( ',', $_GET['brand_id'] );
            $explode_termid = explode( ',', $termid );

            if ( in_array( $termid, $explode_old ) ) {
                $data = array_diff( $explode_old, $explode_termid );
                $checkbox = 'checked';
            } else {
                $data = array_merge( $explode_termid , $explode_old );
            }
        } else {
            $data = array( $termid );
        }

        $dataimplode = implode( ',', $data );

        if ( empty( $dataimplode ) ) {
            $link = remove_query_arg( 'brand_id', $link );
        } else {
            $link = add_query_arg( 'brand_id', implode( ',', $data ), $link );
        }

        return $link;
    }
}

/*************************************************
## MINICART AND QUICK-VIEW
*************************************************/

include get_template_directory() . '/woocommerce/minicart/actions.php';
include get_template_directory() . '/woocommerce/load-more/load-more.php';


/**
* Change number of products that are displayed per page (shop page)
*/
if ( ! function_exists( 'styler_wc_shop_per_page' ) ) {
    add_filter( 'loop_shop_per_page', 'styler_wc_shop_per_page', 20 );
    add_filter( 'dokan_store_products_per_page', 'styler_wc_shop_per_page', 20 );
    function styler_wc_shop_per_page( $cols )
    {
        if ( isset( $_GET['per_page'] ) && $_GET['per_page'] ) {
            return $_GET['per_page'];
        }

        $cols = apply_filters( 'styler_wc_shop_per_page', styler_settings( 'shop_perpage', '8' ) );

        if ( class_exists('WeDevs_Dokan') && dokan_is_store_page() ) {
            $store_user  = dokan()->vendor->get( get_query_var( 'author' ) );
            $store_info  = dokan_get_store_info( $store_user->get_id() );
            $cols        = dokan_get_option( 'store_products_per_page', 'dokan_general', 12 );

            return $cols;
        }

        return $cols;
    }
}


/**
* Change product column
*/
if ( ! function_exists( 'styler_wc_product_column' ) ) {

    function styler_wc_product_column()
    {
        if ( '1' == styler_get_shop_column() ) {
            $listcol = styler_settings('shop_list_type_colxl', '2');
            return apply_filters( 'styler_product_column', 'row-cols-2 row-cols-md-3 row-cols-xl-'.$listcol.' styler-product-list' );
        }
        if ( '2' == styler_get_shop_column() ) {
            return apply_filters( 'styler_product_column', 'row-cols-2 row-cols-sm-3 row-cols-lg-2' );
        }
        if ( '3' == styler_get_shop_column() ) {
            return apply_filters( 'styler_product_column', 'row-cols-2 row-cols-sm-3 row-cols-lg-3' );
        }
        if ( '4' == styler_get_shop_column() ) {
            return apply_filters( 'styler_product_column', 'row-cols-2 row-cols-sm-3 row-cols-lg-4' );
        }
        if ( '5' == styler_get_shop_column() ) {
            return apply_filters( 'styler_product_column', 'row-cols-2 row-cols-sm-3 row-cols-lg-3 row-cols-xl-5' );
        }
        if ( '6' == styler_get_shop_column() ) {
            return apply_filters( 'styler_product_column', 'row-cols-2 row-cols-sm-3 row-cols-lg-3 row-cols-xl-6' );
        }

        $col[] = 'row-cols-' . styler_settings('shop_colxs', '2');
        $col[] = 'row-cols-sm-' . styler_settings('shop_colsm', '2');
        $col[] = 'row-cols-lg-' . styler_settings('shop_collg', '3');
        $col[] = 'row-cols-xl-' . styler_settings('shop_colxl', '4');
        $col = implode( ' ', $col );

        return apply_filters( 'styler_product_column', $col );
    }
}


/**
* Change number of upsells products column
*/
if ( ! function_exists( 'styler_wc_sells_product_column' ) ) {

    function styler_wc_sells_product_column()
    {
        $sells = is_cart() ? 'cross_sells' : 'upsells';
        $col[] = 'cart row-cols-' . styler_settings('shop_'.$sells.'_colxs', '2');
        $col[] = 'row-cols-sm-' . styler_settings('shop_'.$sells.'_colsm', '2');
        $col[] = 'row-cols-lg-' . styler_settings('shop_'.$sells.'_collg', '3');
        $col[] = 'row-cols-xl-' . styler_settings('shop_'.$sells.'_colxl', '4');
        $col   = implode( ' ', $col );
        return apply_filters( 'styler_wc_sells_column', $col );
    }
}


/**
* Change number of related products output
*/
if ( ! function_exists( 'styler_wc_related_products_limit' ) ) {

    add_filter( 'woocommerce_output_related_products_args', 'styler_wc_related_products_limit', 20 );
    function styler_wc_related_products_limit( $args )
    {
        $args['posts_per_page'] = apply_filters( 'styler_wc_related_products_limit', styler_settings('single_shop_related_count', '6') ); // 4 related products
        return $args;
    }
}


/**
* Theme custom filter and actions for woocommerce
*/

remove_action( 'woocommerce_before_shop_loop_item', 'woocommerce_template_loop_product_link_open', 10 );
remove_action( 'woocommerce_after_shop_loop_item', 'woocommerce_template_loop_product_link_close', 5 );
remove_action( 'woocommerce_before_shop_loop', 'woocommerce_output_all_notices', 10 );
remove_action( 'woocommerce_before_shop_loop', 'woocommerce_result_count', 20 );
remove_action( 'woocommerce_before_shop_loop', 'woocommerce_catalog_ordering', 30 );

remove_action( 'woocommerce_before_shop_loop_item_title', 'woocommerce_show_product_loop_sale_flash', 10 );
remove_action( 'woocommerce_before_shop_loop_item_title', 'woocommerce_template_loop_product_thumbnail', 10 );
remove_action( 'woocommerce_before_single_product_summary', 'woocommerce_show_product_sale_flash', 10 );


// add actions

add_action( 'woocommerce_single_product_summary', 'styler_product_countdown', 25 );
add_action( 'woocommerce_single_product_summary', 'styler_product_stock_progress_bar', 26 );
add_action( 'woocommerce_product_meta_end', 'styler_product_brands', 10 );

add_action( 'woocommerce_widget_shopping_cart_before_buttons', 'styler_minicart_before_buttons', 10 );


/**
* Clear Filters
*/
if ( ! function_exists( 'styler_clear_filters' ) ) {
    function styler_clear_filters() {

        $url = wc_get_page_permalink( 'shop' );
        $_chosen_attributes = WC_Query::get_layered_nav_chosen_attributes();

        $min_price = isset( $_GET['min_price'] ) ? esc_attr( $_GET['min_price'] ) : '';
        $max_price = isset( $_GET['max_price'] ) ? esc_attr( $_GET['max_price'] ) : '';

        if ( 0 < count( $_chosen_attributes ) || $min_price || $max_price ) {
            $reset_url = strtok( $url, '?' );
            if ( isset( $_GET['post_type'] ) ) {
                $reset_url = add_query_arg( 'post_type', wc_clean( wp_unslash( $_GET['post_type'] ) ), $reset_url );
            }
            ?>
            <div class="styler-clear-filters">
                <a href="<?php echo esc_url( $reset_url ); ?>"><?php echo esc_html__( 'Clear filters', 'styler' ); ?></a>
            </div>
            <?php
        }
    }
    add_action( 'styler_before_choosen_filters', 'styler_clear_filters' );
}



/**
* Product thumbnail
*/
if ( ! function_exists( 'styler_minicart_before_buttons' ) ) {
    function styler_minicart_before_buttons()
    {
        if ( styler_settings('header_cart_before_buttons', '' ) ) {
            ?>
            <div class="minicart-extra-text">
                <?php echo styler_settings('header_cart_before_buttons', '' ); ?>
            </div>
            <?php
        }
    }
}

/**
* wp_get_attachment_image_attributes
*/
if ( ! function_exists( 'styler_wp_get_attachment_image_attributes' ) ) {
    add_filter( 'wp_get_attachment_image_attributes', 'styler_wp_get_attachment_image_attributes');
    function styler_wp_get_attachment_image_attributes($attr) {
        if ( '1' != styler_settings('theme_lazyload_images', '1' ) ){
            return $attr;
        }
        $placeholder = 'data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7';
        $blank_img = get_template_directory().'/images/blank.gif';
        $blank_img = file_exists( $blank_img ) ? get_template_directory_uri().'/images/blank.gif' : $placeholder;
        $attr['data-src'] = $attr['src'];

        $attr['src'] = is_admin() || isset($attr['loading']) != 'lazy' ? $attr['src'] : $blank_img;

        $attr['data-srcset'] = isset( $attr['srcset'] ) ? $attr['srcset'] : '';

        unset( $attr['srcset'] );

        $attr['data-sizes']  = isset( $attr['sizes'] ) ? $attr['sizes'] : '';

        unset( $attr['sizes'] );

        return $attr;
    }
}

/**
* Product thumbnail
*/
if ( ! function_exists( 'shop_related_thumb_size' ) ) {
    function shop_related_thumb_size()
    {
        return apply_filters( 'shop_related_thumb_size', [370,370] );
    }
}

/**
* Product thumbnail
*/
if ( ! function_exists( 'styler_loop_product_thumb' ) ) {
    function styler_loop_product_thumb($column='')
    {
        global $product;
        $column = isset( $_GET['column'] ) ? esc_html( $_GET['column'] ) : $column;
        $size   = styler_settings('product_imgsize','woocommerce_thumbnail');
        if ( '1' != styler_settings('keep_image_size', '0') ) {
            switch ( $column ) {
                case '6':
                    $size = 'styler-mini';
                    break;
                case '5':
                    $size = 'styler-mini';
                    break;
                case '4':
                    $size = 'styler-medium';
                    break;
                case '3':
                    $size = 'styler-square';
                    break;
                case '2':
                    $size = 'styler-grid';
                    break;
                case '1':
                    $size = 'styler-medium';
                    break;
                default:
                    $size = styler_settings('product_imgsize','woocommerce_thumbnail');
                    break;
            }
        }
        $id         = $product->get_id();
        $size       = isset( $_POST['img_size'] ) != null ? $_POST['img_size'] : $size;
        $size       = apply_filters( 'styler_product_thumb_size', $size );
        $attr       = !empty( $gallery ) ? 'product-thumb attachment-woocommerce_thumbnail size-'.$size : 'attachment-woocommerce_thumbnail size-'.$size;
        $show_video = get_post_meta( $id, 'styler_product_video_on_shop', true );
        $iframe_id  = get_post_meta( $id, 'styler_product_iframe_video', true );

        if ( '1' == styler_settings( 'shop_loop_custom_image_size', '0' ) ) {
            $dimensions = styler_settings( 'shop_loop_custom_image_dimensions' );
            $width  = !empty( $dimensions['width'] ) ? $dimensions['width'] : '';
            $height = !empty( $dimensions['height'] ) ? $dimensions['height'] : '';
            $crop   = '1' == styler_settings( 'shop_loop_custom_image_crop', '0' ) ? true : false;
            $size   = [$width,$height];
        }

        if ( $iframe_id && $show_video == 'yes' && ( is_shop() || is_product_category() || is_product_tag() ) ) {
            $iframe_html = '<iframe class="lazy" loading="lazy" data-src="https://www.youtube.com/embed/'.$iframe_id.'?playlist='.$iframe_id.'&modestbranding=1&rel=0&controls=0&autoplay=1&enablejsapi=1&showinfo=0&mute=1&loop=1&start=5&end=25" allow="autoplay; fullscreen; accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" frameborder="0" allowfullscreen></iframe>';
            echo '<div class="styler-loop-product-iframe-wrapper"><a href="'.esc_url( get_permalink() ).'" title="'.get_the_title().'"></a>'.$iframe_html.'</div>';
        } else {
            ?>
            <a href="<?php echo esc_url( get_permalink() ); ?>" class="product-link">
                <?php
                if ( '1' == styler_settings('use_wc_image_sizes', '0') ) {
                    woocommerce_template_loop_product_thumbnail();
                } else {
                    echo has_post_thumbnail() ? get_the_post_thumbnail( $id, $size, array( 'class' => $attr ) ) : wc_placeholder_img( $size );
                }
                ?>
            </a>
            <?php
        }
    }
}

/**
* Product thumbnail
*/
if ( ! function_exists( 'styler_loop_product_thumb_overlay' ) ) {
    function styler_loop_product_thumb_overlay($column='')
    {
        global $product;
        $column = isset( $_GET['column'] ) ? esc_html( $_GET['column'] ) : $column;
        $size   = styler_settings('product_imgsize','woocommerce_thumbnail');
        if ( '1' != styler_settings('keep_image_size', '0') ) {
            //custom image size by column filter
            switch ( $column ) {
                case '6':
                    $size = 'styler-mini';
                    break;
                case '5':
                    $size = 'styler-mini';
                    break;
                case '4':
                    $size = 'styler-medium';
                    break;
                case '3':
                    $size = 'styler-square';
                    break;
                case '2':
                    $size = 'styler-grid';
                    break;
                case '1':
                    $size = 'styler-medium';
                    break;
                default:
                    $size = styler_settings('product_imgsize','woocommerce_thumbnail');
                    break;
            }
        }

        $id           = $product->get_id();
        $size         = isset( $_POST['img_size'] ) != null ? $_POST['img_size'] : $size;
        $size         = apply_filters( 'styler_product_thumb_size', $size );
        $gallery      = $product->get_gallery_image_ids();
        $has_images   = !empty( $gallery ) && !wp_is_mobile() ? 'product-link has-images' : 'product-link';
        $attr         = !empty( $gallery ) ? 'product-thumb attachment-woocommerce_thumbnail size-'.$size : 'attachment-woocommerce_thumbnail size-'.$size;
        $show_video   = get_post_meta( $id, 'styler_product_video_on_shop', true );
        $iframe_video = get_post_meta( $id, 'styler_product_iframe_video', true );
        $show_gallery = get_post_meta( $id, 'styler_loop_product_slider', true );
        $isshop       = is_shop() ? ' is-shop' : '';

        if ( '1' == styler_settings( 'shop_loop_custom_image_size', '0' ) ) {
            $dimensions = styler_settings( 'shop_loop_custom_image_dimensions' );
            $width  = !empty( $dimensions['width'] ) ? $dimensions['width'] : '';
            $height = !empty( $dimensions['height'] ) ? $dimensions['height'] : '';
            $size   = [$width,$height];
        }

        if ( $iframe_video && $show_video == 'yes' && ( is_shop() || wp_doing_ajax() ) ) {
            $iframe_html = '<iframe class="lazy" loading="lazy" data-src="https://www.youtube.com/embed/'.$iframe_video.'?playlist='.$iframe_video.'&modestbranding=1&rel=0&controls=0&autoplay=1&enablejsapi=1&showinfo=0&mute=1&loop=1&start=5&end=25" allow="autoplay; fullscreen; accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" frameborder="0" allowfullscreen></iframe>';
            echo '<div class="styler-loop-product-iframe-wrapper"><a href="'.esc_url( get_permalink() ).'" title="'.get_the_title().'"></a>'.$iframe_html.'</div>';
        } elseif ( !empty( $gallery ) && $show_gallery == 'yes' ) {
            styler_loop_product_gallery();
        } else {
            ?>
            <a href="<?php echo esc_url( get_permalink() ); ?>" class="<?php echo esc_attr( $has_images ); ?>">
                <?php
                if ( '1' == styler_settings('use_wc_image_sizes', '0') ) {
                    woocommerce_template_loop_product_thumbnail();

                    if ( !empty( $gallery ) && !wp_is_mobile() ) {
                        $wcsize = wc_get_image_size('thumbnail');
                        $width  = isset($wcsize['width']) ? $wcsize['width'] : '';
                        $height = isset($wcsize['height']) ? $wcsize['height'] : '';
                        $crop   = 1 == $wcsize['crop'] ? true : false;
                        $wc_size = [$width,$height,$crop];
                        echo wp_get_attachment_image( $gallery[0], $wc_size, "", array( "class" => "overlay-thumb ".$isshop ) );
                    }
                } else {
                    echo has_post_thumbnail() ? get_the_post_thumbnail( $id, $size, array( 'class' => $attr ) ) : wc_placeholder_img( $size );

                    if ( !empty( $gallery ) && !wp_is_mobile() ) {
                        echo wp_get_attachment_image( $gallery[0], $size, "", array( "class" => "overlay-thumb ".$isshop ) );
                    }
                }
                ?>
            </a>
            <?php
        }
    }
}

/**
* loop product gallery
*/
if ( ! function_exists( 'styler_loop_product_gallery' ) ) {
    function styler_loop_product_gallery($column='')
    {
        global $product;

        $column = isset( $_GET['column'] ) ? esc_html( $_GET['column'] ) : $column;
        $size   = styler_settings('product_imgsize','woocommerce_thumbnail');
        if ( '1' != styler_settings('keep_image_size', '0') ) {
            switch ( $column ) {
                case '6':
                    $size  = 'styler-mini';
                    break;
                case '5':
                    $size  = 'styler-mini';
                    break;
                case '4':
                    $size  = 'styler-medium';
                    break;
                case '3':
                    $size  = 'styler-square';
                    break;
                case '2':
                    $size  = 'styler-grid';
                    break;
                case '1':
                    $size  = 'styler-medium';
                    break;
                default:
                    $size  = styler_settings('product_imgsize','woocommerce_thumbnail');
                    break;
            }
        }
        $id           = $product->get_id();
        $data         = array();
        $show_gallery = get_post_meta( $id, 'styler_loop_product_slider', true );
        $autoplay     = get_post_meta( $id, 'styler_loop_product_slider_autoplay', true );
        $speed        = get_post_meta( $id, 'styler_loop_product_slider_speed', true );
        $gallery      = $product->get_gallery_image_ids();
        $size         = isset( $_POST['img_size'] ) != null ? $_POST['img_size'] : $size;
        $size         = apply_filters( 'styler_product_thumb_size', $size );
        $attr         = !empty( $gallery ) ? 'product-thumb attachment-woocommerce_thumbnail size-'.$size : 'attachment-woocommerce_thumbnail size-'.$size;
        $thumburl     = get_the_post_thumbnail_url( $id, $size, array( 'class' => $attr ) );
        $data[]       = 'yes' == $autoplay ? '"autoplay":true' : '"autoplay":false';
        $data[]       = is_numeric($speed) ? '"speed":'.round($speed) : '"speed":500';
        $data[]       = '"slidesPerView":1';
        $data[]       = '"pagination":{"el": ".swiper-pagination","type": "bullets","clickable":true}';
        $data         = apply_filters('styler_loop_product_slider_options', $data);

        if ( '1' == styler_settings( 'shop_loop_custom_image_size', '0' ) ) {
            $dimensions = styler_settings( 'shop_loop_custom_image_dimensions' );
            $width  = !empty( $dimensions['width'] ) ? $dimensions['width'] : '';
            $height = !empty( $dimensions['height'] ) ? $dimensions['height'] : '';
            $crop   = '1' == styler_settings( 'shop_loop_custom_image_crop', '0' ) ? true : false;
            $size   = [$width,$height];
        }

        wp_enqueue_script( 'swiper' );

        if ( !empty( $gallery ) && 'yes' == $show_gallery ) {
            ?>
            <div class="styler-loop-slider styler-swiper-slider swiper-container" data-swiper-options='{<?php echo implode(',', $data ); ?>}'>
                <div class="swiper-wrapper">
                    <div class="styler-loop-slider-item swiper-slide">
                        <a href="<?php echo esc_url( get_permalink() ); ?>" class="product-link" data-img="<?php echo esc_url( $thumburl ); ?>">
                            <?php
                            if ( '1' == styler_settings('use_wc_image_sizes', '0') ) {
                                woocommerce_template_loop_product_thumbnail();
                            } else {
                                echo has_post_thumbnail() ? get_the_post_thumbnail( $id, $size, ['class'=>$attr] ) : wc_placeholder_img( $size );
                            }
                            ?>
                        </a>
                    </div>
                    <?php
                    foreach ( $gallery as $img ) {
                        $imgurl = wp_get_attachment_image_url( $img, $size );
                        ?>
                        <div class="styler-loop-slider-item swiper-slide">
                            <a href="<?php echo esc_url( get_permalink() ); ?>" class="product-link" data-img="<?php echo esc_url( $imgurl ); ?>">
                                <?php
                                if ( '1' == styler_settings('use_wc_image_sizes', '0') ) {
                                    $wcsize  = wc_get_image_size('thumbnail');
                                    $width   = isset($wcsize['width']) ? $wcsize['width'] : '';
                                    $height  = isset($wcsize['height']) ? $wcsize['height'] : '';
                                    $crop    = 1 == $wcsize['crop'] ? true : fale;
                                    $wc_size = [$width,$height,$crop];
                                    echo wp_get_attachment_image( $img, $wc_size );
                                } else {
                                    echo wp_get_attachment_image( $img, $size );
                                }
                                ?>
                            </a>
                        </div>
                        <?php
                    }
                    ?>
                </div>
                <div class="swiper-pagination"></div>
            </div>
            <?php
        } else {
            styler_loop_product_thumb($column);
        }
    }
}


/**
* Add stock to loop
*/
if ( ! function_exists( 'styler_loop_product_nostock' ) ) {
    function styler_loop_product_nostock()
    {
        global $product;
        $stock = get_post_meta( $product->get_id(), 'styler_product_hide_stock', true );

        if ( 'yes' == $stock ) {
            return;
        }

        if ( !$product->is_in_stock() ) {
            echo '<span class="styler-small-title styler-stock-status styler-out-of-stock">'.esc_html__('Out of stock', 'styler').'</span>';
        }
    }
}


/**
* Product buttons
*/
if ( ! function_exists( 'styler_add_to_cart' ) ) {
    function styler_add_to_cart()
    {
        do_action( 'woocommerce_after_shop_loop_item' );
    }
}


/**
* Cart Button with Quantity Box
*/
if ( !function_exists( 'styler_cart_with_quantity' ) ) {
    function styler_cart_with_quantity()
    {
        ?>
        <div class="product-cart-with-quantity">
            <div class="quantity ajax-quantity">
                <div class="quantity-button minus">-</div>
                <input type="text" class="input-text qty text" name="quantity" value="1" title="Menge" size="4" inputmode="numeric">
                <div class="quantity-button plus">+</div>
            </div>
            <?php woocommerce_template_loop_add_to_cart(); ?>
        </div>
        <?php
    }
}


/**
* Product wishlist button
*/
if ( ! function_exists( 'styler_single_product_buttons' ) ) {
    add_action( 'woocommerce_after_add_to_cart_button', 'styler_single_product_buttons', 10 );
    function styler_single_product_buttons()
    {
        echo styler_wishlist_button();
        echo styler_compare_button();
    }
}

/**
* Product wishlist button
*/
if ( ! function_exists( 'styler_wishlist_button' ) ) {
    function styler_wishlist_button()
    {
        if ( ! class_exists( 'Styler_Wishlist' ) ) {
            return;
        }
        global $product;
        $id = $product->get_id();
        $text = esc_html__( 'Add to Wishlist', 'styler' );
        $icon = styler_svg_lists( 'love', 'styler-svg-icon' );

        return '<div class="styler-wishlist-btn styler-product-button" data-id="' . esc_attr( $id ) . '" data-label="'.$text.'">'.$icon.'</div>';
    }
}


/**
* Product compare button
*/
if ( ! function_exists( 'styler_compare_button' ) ) {
    function styler_compare_button()
    {
        if ( ! class_exists( 'Styler_Compare' ) ) {
            return;
        }
        global $product;
        $id   = $product->get_id();
        $text = esc_html__( 'Compare', 'styler' );
        $icon = styler_svg_lists( 'compare', 'styler-svg-icon' );

        return '<div class="styler-compare-btn styler-product-button" data-id="'.$id.'" data-label="'.$text.'">'.$icon.'</div>';
    }
}

/**
* Product add to cart icon button
*/
if ( ! function_exists( 'styler_add_to_cart_button' ) ) {
    function styler_add_to_cart_button($args = array())
    {
        global $product;

        if ( $product ) {
            $id   = $product->get_id();
            $text = esc_html( $product->add_to_cart_text() );
            $icon = $product->supports( 'ajax_add_to_cart' ) && $product->is_purchasable() && $product->is_in_stock() ? 'bag' : 'arrow-right';
            $icon = styler_svg_lists( $icon, 'styler-svg-icon' );
            $type = $product->get_type();

            $defaults = array();

            $args = apply_filters( 'woocommerce_loop_add_to_cart_args', wp_parse_args( $args, $defaults ), $product );

            if ( isset( $args['attributes']['aria-label'] ) ) {
                $args['attributes']['aria-label'] = wp_strip_all_tags( $args['attributes']['aria-label'] );
            }

            $btn = sprintf(
                '<a href="%s" data-quantity="%s" class="%s" %s></a>',
                esc_url( $product->add_to_cart_url() ),
                esc_attr( isset( $args['quantity'] ) ? $args['quantity'] : 1 ),
                esc_attr( isset( $args['class'] ) ? $args['class'] : 'styler-add-to-cart-icon-link' ),
                isset( $args['attributes'] ) ? wc_implode_html_attributes( $args['attributes'] ) : ''
            );

            return '<div class="styler-add-to-cart-btn styler-product-button type-'.$type.'" data-id="'.$id.'" data-label="'.$text.'">'.$btn.$icon.'</div>';
        }
    }
}

if ( !function_exists( 'styler_wc_loop_add_to_cart_args' ) ) {
    add_filter( 'woocommerce_loop_add_to_cart_args', 'styler_wc_loop_add_to_cart_args', 10, 2 );
    function styler_wc_loop_add_to_cart_args() {
        global $product;
        $type = $product->get_type();
        $defaults = array(
            'quantity'   => 1,
            'class'      => implode(
                ' ',
                array_filter(
                    array(
                        'styler-btn-small',
                        'product_type_' . $product->get_type(),
                        $product->is_purchasable() && $product->is_in_stock() ? 'add_to_cart_button' : '',
                        $type == 'variable' || $type == 'grouped' ? 'ninetheme-quick-shop-btn' : '',
                        $product->supports( 'ajax_add_to_cart' ) && $product->is_purchasable() && $product->is_in_stock() ? 'ajax_add_to_cart' : '',
                    )
                )
            ),
            'attributes' => array(
                'data-product_id'  => $product->get_id(),
                'data-product_sku' => $product->get_sku(),
                'aria-label'       => $product->add_to_cart_description(),
                'rel'              => 'nofollow'
            )
        );
        return $defaults;
    }
}


/**
* Product quickview button
*/
if ( ! function_exists( 'styler_quickview_button' ) ) {
    function styler_quickview_button()
    {
        if ( class_exists( 'Styler_QuickView' ) && '1' == styler_settings('quick_view_visibility', '1') ) {
            echo do_shortcode( '[styler_quickview]' );
        }
    }
}


/**
* Product discount label
*/
if ( ! function_exists( 'styler_product_discount' ) ) {
    function styler_product_discount($echo=true)
    {
        global $product;
        $discount = get_post_meta( $product->get_id(), 'styler_product_discount', true );
        if ( 'yes' != $discount && $product->is_on_sale() && ! $product->is_type('variable') ) {
            $regular = (float) $product->get_regular_price();
            $sale = (float) $product->get_sale_price();
            $precision = 1; // Max number of decimals
            $saving = $sale && $regular ? round( 100 - ( $sale / $regular * 100 ), 0 ) . '%' : '';
            if ( $echo == true ) {
                echo !empty( $saving ) ? '<span class="styler-label styler-discount">'.$saving.'</span>' : '';
            } else {
                return !empty( $saving ) ? '<span class="styler-label styler-discount">'.$saving.'</span>' : '';
            }
        }
    }
}


/**
* Get all product categories
*/
if ( ! function_exists( 'styler_product_all_categories' ) ) {
    function styler_product_all_categories()
    {
        $cats = get_terms( 'product_cat' );
        $categories = array();

        if ( empty( $cats ) ) {
            return;
        }

        foreach ( $cats as $cat ) {
            $categories[] = '<a href="'.esc_url( get_term_link( $cat ) ) .'" >'. esc_html( $cat->name ) .'</a>';
        }
        return implode( ', ', $categories );
    }
}


/**
* Get all product tags
*/
if ( ! function_exists( 'styler_product_tags' ) ) {
    function styler_product_tags()
    {
        $tags = get_terms( 'product_tag' );
        $alltags = array();
        if ( empty( $tags ) ) {
            return;
        }
        foreach ( $tags as $tag ) {
            $alltags[] = '<a href="'.esc_url( get_term_link( $tag ) ) .'" >'. esc_html( $tag->name ) .'</a>';
        }
        return implode( ', ', $alltags );
    }
}


if ( ! function_exists( 'styler_product_terms' ) ) {

    /**
    * Function to return list of the terms.
    *
    * @param string 'taxonomy'
    *
    * @return html Returns the list of elements.
    */

    function styler_product_terms( $taxonomy, $label ) {

        $terms = get_the_terms( get_the_ID(), $taxonomy );

        if ( $terms && ! is_wp_error( $terms ) ) {

            $term_links = array();
            echo '<div class="styler-meta-wrapper">';
                foreach ( $terms as $term ) {
                    $term_links[] = '<a href="' . esc_url( get_term_link( $term->slug, $taxonomy ) ) . '">' . $term->name . '</a>';
                }
                $all_terms = join( ', ', $term_links );

                echo !empty( $label ) ? '<span class="styler-terms-label styler-small-title">' . $label . '</span>' : '';
                echo '<span class="styler-small-title terms-' . esc_attr( $term->slug ) . '">' . $all_terms . '</span>';
            echo '</div>';
        }
    }
}


/**
* Add product attribute name
*/
if ( ! function_exists( 'styler_product_attr_label' ) ) {
    function styler_product_attr_label()
    {
        global $product;

        $attributes = $product->get_attributes();
        foreach ( $attributes as $attribute ) {
            $values = array();
            $product_attributes[ 'attribute_' . sanitize_title_with_dashes( $attribute->get_name() ) ] = array(
                'label' => wc_attribute_label( $attribute->get_name() ),
                'value' => apply_filters( 'woocommerce_attribute', wpautop( wptexturize( implode( ', ', $values ) ) ), $attribute, $values ),
            );
            $label = $product_attributes[ 'attribute_' . sanitize_title_with_dashes( $attribute->get_name() ) ]['label'];
            $value = $product_attributes[ 'attribute_' . sanitize_title_with_dashes( $attribute->get_name() ) ]['value'];
            echo !empty( $label ) ? '<span class="product-attr_label">'.$label.'</span>' : '';
        }
    }
}



/**
* product page gallery
*/
if ( ! function_exists( 'styler_product_gallery_slider' ) ) {
    function styler_product_gallery_slider()
    {
        global $product;
        $images = $product->get_gallery_image_ids();
        $size   = apply_filters( 'styler_product_thumb_size', 'woocommerce_single' );
        $id     = $product->get_id();
        $effect = styler_settings( 'product_gallery_slider_effect', 'slide' );

        // gallery top first thumbnail
        $img    = get_the_post_thumbnail( $id, $size, [ 'class' => 'swiper-lazyy' ] );
        $full   = get_the_post_thumbnail_url( $id, 'full' );
        $url    = get_the_post_thumbnail_url( $id, $size );
        $str    = json_encode( $img );

        // gallery bottom first thumbnail
        $tsize = [90,90];
        $timg  = get_the_post_thumbnail( $id, $tsize );
        $tstr  = json_encode( $timg );

        $type       = apply_filters( 'styler_product_gallery_slider_layout', styler_settings( 'product_gallery_slider_layout', 'bottom' ) );
        $direction  = 'left' == $type || 'right' == $type ? 'vertical' : 'horizontal';

        $iframe_video = get_post_meta( get_the_ID(), 'styler_product_iframe_video', true );
        $popup_video  = get_post_meta( get_the_ID(), 'styler_product_popup_video', true );
        $video_type   = apply_filters( 'styler_product_video_type', get_post_meta( get_the_ID(), 'styler_product_video_type', true ) );
        $video_img    = get_template_directory_uri() . '/images/video-play.png';

        $col1_order = '';
        $col2_order = '';

        switch ( $type ) {
            case 'bottom':
                $col1_order = ' order-2';
                $col2_order = ' order-1';
                break;
            case 'left':
                $col1_order = ' col-md-2 order-1';
                $col2_order = ' col-md-10 order-md-2';
                break;
            case 'right':
                $col1_order = ' col-md-2 order-2';
                $col2_order = ' col-md-10 order-1';
                break;
            default:
                $col1_order = '';
                $col2_order = '';
                break;
        }
        $main_slider_options = json_encode( apply_filters('styler_product_gallery_js_options',
            array(
                "loop"                 => false,
                "speed"                => 800,
                "spaceBetween"         => 0,
                "slidesPerView"        => 1,
                "slidesPerView"        => 1,
                "freeMode"             => false,
                "direction"            => "horizontal",
                "autoHeight"           => true,
                "autoPlay"             => false,
                "rewind"               => true,
                "observer"             => true,
                "observeParents"       => true,
                "observeSlideChildren" => true,
                "navigation"           => [
                    "nextEl" => ".styler-product-gallery-main-slider .swiper-button-next",
                    "prevEl" => ".styler-product-gallery-main-slider .swiper-button-prev"
                ],
                "effect"               => $effect,
                "creativeEffect"       => [
                    "prev" => [ "translate" => ['0%', 0, -400] ],
                    "next" => [ "translate" => ['100%', 0, 0] ]
                ]
            )
        ));
        $thumbs_slider_options = json_encode( apply_filters('styler_product_gallery_thumbs_js_options',
            array(
                "loop"          => false,
                "speed"         => 1000,
                "spaceBetween"  => 10,
                "slidesPerView" => 6,
                "freeMode"      => false,
                "direction"     => "horizontal",
                "autoHeight"    => false,
                "preventClicks" => false,
                "navigation"    => [
                    "nextEl" => ".styler-product-gallery-main-slider .swiper-button-next",
                    "prevEl" => ".styler-product-gallery-main-slider .swiper-button-prev"
                ],
                "breakpoints"   => [
                    "768" => [
                        "direction"     => $direction,
                        "slidesPerView" => 8
                    ]
                ]
            )
        ));
        remove_action( 'woocommerce_product_thumbnails', 'woocommerce_show_product_thumbnails', 20 );

        $lightbox = 'fancybox' == styler_settings( 'product_gallery_lightbox', 'fancybox' ) ? ' data-fancybox="images"' : '';
        if ( 'fancybox' == styler_settings( 'product_gallery_lightbox', 'fancybox' ) ) {
            wp_enqueue_style( 'fancybox' );
            wp_enqueue_script( 'fancybox' );
        }
        ?>
        <div class="styler-swiper-slider-wrapper styler-slider-thumbs-<?php echo esc_attr( $type ); ?>">
            <div class="row">

                <div class="col-12<?php echo esc_attr( $col1_order ); ?>">
                    <div class="styler-product-thumbnails styler-swiper-thumbnails swiper-container" data-swiper-options="<?php echo esc_attr( $thumbs_slider_options ); ?>">
                        <div class="swiper-wrapper">
                            <?php
                            echo '<div class="swiper-slide styler-swiper-slide-first" data-lightbox="1">'.$timg.'</div>';
                            foreach ( $images as $image ) {
                                $tcount = 2;
                                echo '<div class="swiper-slide" data-lightbox="'.$tcount.'">'.wp_get_attachment_image( $image, $tsize ).'</div>';
                                $tcount++;
                            }
                            if ( $iframe_video && 'gallery' == $video_type ) {
                                echo '<div class="swiper-slide swiper-slide-video-item"><img src="'.esc_url($video_img).'" /></div>';
                            }
                            ?>
                        </div>
                    </div>
                </div>
                <div class="col-12<?php echo esc_attr( $col2_order ); ?>">
                    <div class="styler-product-gallery-main-slider styler-swiper-main swiper-container" data-swiper-options="<?php echo esc_attr( $main_slider_options ); ?>">
                        <?php
                        if ( $popup_video && 'popup' == $video_type ) {
                            echo '<a href="'.$popup_video.'" class="styler-product-video-button mfp-iframe"><i class="fa fa-play"></i></a>';

                        }
                        styler_single_product_labels();
                        do_action( 'woocommerce_product_thumbnails' );

                        echo '<div class="styler-product-gallery-popups">';
                            echo '<a class="styler-product-popup active" href="'.esc_url( $url ).'" data-lightbox="1"'.$lightbox.'><i class="fas fa-expand"></i></a>';
                            $count = 2;
                            foreach ( $images as $image ) {
                                $lbxurl = wp_get_attachment_image_url( $image, 'full' );
                                if ( $lbxurl ){
                                    echo '<a class="styler-product-popup lightbox-images" href="'.esc_url( $lbxurl ).'" data-lightbox="'.$count.'"'.$lightbox.'><i class="fas fa-expand"></i></a>';
                                }
                                $count++;
                            }
                        echo '</div>';
                        ?>
                        <div class="swiper-wrapper styler-gallery-items">
                            <?php
                            echo '<div class="swiper-slide styler-swiper-slide-first" data-zoom-img="'.$full.'" data-lightbox="1">'.$img.'</div>';
                            $countt = 2;
                            foreach ( $images as $image ) {
                                $gimg = wp_get_attachment_image( $image, $size );
                                $gurl = wp_get_attachment_image_url( $image, 'full' );
                                echo '<div class="swiper-slide" data-zoom-img="'.$gurl.'" data-lightbox="'.$countt.'">'.$gimg.'</div>';
                                $countt++;
                            }
                            if ( $iframe_video && 'gallery' == $video_type ) {
                                $iframe_html = '<iframe class="lazy" loading="lazy" data-src="https://www.youtube.com/embed/'.$iframe_video.'?playlist='.$iframe_video.'&modestbranding=1&rel=0&controls=0&autoplay=1&enablejsapi=1&showinfo=0&mute=1&loop=1&start=5&end=25" allow="autoplay; fullscreen; accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" frameborder="0" allowfullscreen></iframe>';
                                echo '<div class="swiper-slide swiper-slide-video-item iframe-video"><div class="styler-slide-iframe-wrapper">'.$iframe_html.'</div></div>';
                            }
                            ?>
                        </div>
                        <?php if ( is_rtl() ) { ?>
                            <div class="swiper-button-next styler-swiper-next"></div>
                            <div class="swiper-button-prev styler-swiper-prev"></div>
                        <?php } else { ?>
                            <div class="swiper-button-prev styler-swiper-prev"></div>
                            <div class="swiper-button-next styler-swiper-next"></div>
                        <?php } ?>
                    </div>
                </div>

            </div>
        </div>
        <?php
    }
}

/**
* product page gallery strecth
*/
if ( ! function_exists( 'styler_product_gallery_slider_stretch' ) ) {
    function styler_product_gallery_slider_stretch()
    {
        global $product;
        $images = $product->get_gallery_image_ids();
        $size   = apply_filters( 'styler_product_thumb_size', 'woocommerce_single' );
        $id     = $product->get_id();

        // gallery top first thumbnail
        $img    = get_the_post_thumbnail( $id, $size, [ 'class' => 'swiper-lazyy' ] );
        $full   = get_the_post_thumbnail_url( $id, 'full' );
        $url    = get_the_post_thumbnail_url( $id, $size );
        $str    = json_encode( $img );

        // gallery bottom first thumbnail
        $tsize = [70,70];
        $timg  = get_the_post_thumbnail( $id, $tsize );
        $tstr  = json_encode( $timg );

        $type       = 'left';
        $direction  = 'vertical';

        $iframe_video = get_post_meta( get_the_ID(), 'styler_product_iframe_video', true );
        $popup_video  = get_post_meta( get_the_ID(), 'styler_product_popup_video', true );
        $video_type   = apply_filters( 'styler_product_video_type', get_post_meta( get_the_ID(), 'styler_product_video_type', true ) );
        $video_img    = get_template_directory_uri() . '/images/video-play.png';

        $col1_order = '';
        $col2_order = '';

        switch ( $type ) {
            case 'bottom':
                $col1_order = ' order-2';
                $col2_order = ' order-1';
                break;
            case 'left':
                $col1_order = ' col-md-2 order-1';
                $col2_order = ' col-md-10 order-md-2';
                break;
            case 'right':
                $col1_order = ' col-md-2 order-2';
                $col2_order = ' col-md-10 order-1';
                break;
            default:
                $col1_order = '';
                $col2_order = '';
                break;
        }
        $main_slider_options = json_encode( apply_filters('styler_product_gallery_js_options',
            array(
                //"loop"                 => true,
                "speed"                => 800,
                "spaceBetween"         => 0,
                "slidesPerView"        => 1,
                //"freeMode"             => false,
                "direction"            => "horizontal",
                //"autoHeight"           => false,
                "autoPlay"             => false,
                "rewind"               => true,
                "observer"             => true,
                "observeParents"       => true,
                "observeSlideChildren" => true,
                //"watchOverflow"        => true,
                //"watchSlidesVisibility"=> true,
                //"watchSlidesProgress"  => true,
                "navigation"           => [
                    "nextEl" => ".styler-product-gallery-main-slider .swiper-button-next",
                    "prevEl" => ".styler-product-gallery-main-slider .swiper-button-prev"
                ],
                "effect"               => "slide",
                "creativeEffect"       => [
                    "prev" => [ "translate" => ['0%', 0, -400] ],
                    "next" => [ "translate" => ['100%', 0, 0] ]
                ]
            )
        ));
        $thumbs_slider_options = json_encode( apply_filters('styler_product_gallery_thumbs_js_options',
            array(
                //"loop"                  => true,
                //"speed"                 => 1000,
                "spaceBetween"          => 10,
                "slidesPerView"         => 10,
                //"freeMode"              => false,
                "direction"             => "horizontal",
                //"rewind"                => true,
                //"effect"               => "slide",
                //"autoHeight"            => false,
                //"watchOverflow"         => true,
                //"watchSlidesVisibility" => true,
                //"watchSlidesProgress"   => true,
                //"centeredSlides"        => true,
                //"centeredSlidesBounds"  => true,
                "breakpoints"   => [
                    "992" => [
                        "direction"     => "vertical",
                        "slidesPerView" => 5
                    ]
                ]
            )
        ));
        remove_action( 'woocommerce_product_thumbnails', 'woocommerce_show_product_thumbnails', 20 );

        $popups_imgs = array(
            array(
                "src" => $url
            )
        );

        $thumbs_images = array();
        foreach ( $images as $image ) {
            //$tumons_images[] .= [ "src" => wp_get_attachment_image_url( $image, $size ) ];
            array_push($popups_imgs, [ "src" => wp_get_attachment_image_url( $image, $size ) ] );
        }
        $popups_images = json_encode( $popups_imgs );

        $lightbox = 'fancybox' == styler_settings( 'product_gallery_lightbox', 'fancybox' ) ? ' data-fancybox="images"' : '';
        if ( 'fancybox' == styler_settings( 'product_gallery_lightbox', 'fancybox' ) ) {
            wp_enqueue_style( 'fancybox' );
            wp_enqueue_script( 'fancybox' );
        }
        ?>
        <div class="styler-swiper-slider-wrapper styler-slider-thumbs-vertical-left">

            <div class="styler-product-gallery-main-slider styler-swiper-main swiper-container" data-swiper-options="<?php echo esc_attr( $main_slider_options ); ?>">
                <?php
                if ( $popup_video && 'popup' == $video_type ) {
                    echo '<a href="'.$popup_video.'" class="styler-product-video-button mfp-iframe"><i class="fa fa-play"></i></a>';

                }
                styler_single_product_labels();
                do_action( 'woocommerce_product_thumbnails' );

                echo '<div class="styler-product-gallery-popups">';
                    echo '<a class="styler-product-popup active" href="'.esc_url( $url ).'"'.$lightbox.'><i class="fas fa-expand"></i></a>';
                    $count = 2;
                    foreach ( $images as $image ) {
                        $lbxurl = wp_get_attachment_image_url( $image, 'full' );
                        if ( $lbxurl ){
                            echo '<a class="styler-product-popup lightbox-images" href="'.esc_url( $lbxurl ).'" data-lightbox="'.$count.'"'.$lightbox.'><i class="fas fa-expand"></i></a>';
                        }
                        $count++;
                    }
                echo '</div>';

                //echo '<a class="styler-product-popup" href="'.esc_url( $url ).'" data-popup-gallery="'.esc_attr( $popups_images ).'"'.$lightbox.'><i class="fas fa-expand"></i></a>';
                ?>
                <div class="swiper-wrapper styler-gallery-items">
                    <?php
                    echo '<div class="swiper-slide styler-swiper-slide-first" data-zoom-img="'.$full.'" data-lightbox="1">'.$img.'</div>';
                    $countt = 2;
                    foreach ( $images as $image ) {
                        $gimg = wp_get_attachment_image( $image, $size );
                        $gurl = wp_get_attachment_image_url( $image, 'full' );
                        echo '<div class="swiper-slide" data-zoom-img="'.$gurl.'" data-lightbox="'.$countt.'">'.$gimg.'</div>';
                        $countt++;
                    }
                    if ( $iframe_video && 'gallery' == $video_type ) {
                        $iframe_html = '<iframe class="lazy" loading="lazy" data-src="https://www.youtube.com/embed/'.$iframe_video.'?playlist='.$iframe_video.'&modestbranding=1&rel=0&controls=0&autoplay=1&enablejsapi=1&showinfo=0&mute=1&loop=1&start=5&end=25" allow="autoplay; fullscreen; accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" frameborder="0" allowfullscreen></iframe>';
                        echo '<div class="swiper-slide swiper-slide-video-item iframe-video"><div class="styler-slide-iframe-wrapper">'.$iframe_html.'</div></div>';
                    }
                    ?>
                </div>
                <?php if ( is_rtl() ) { ?>
                    <div class="swiper-button-next styler-swiper-next"></div>
                    <div class="swiper-button-prev styler-swiper-prev"></div>
                <?php } else { ?>
                    <div class="swiper-button-prev styler-swiper-prev"></div>
                    <div class="swiper-button-next styler-swiper-next"></div>
                <?php } ?>
            </div>

            <div class="styler-product-thumbnails-vertical">
                <div class="styler-product-thumbnails styler-swiper-thumbnails swiper-container" data-swiper-options="<?php echo esc_attr( $thumbs_slider_options ); ?>">
                    <div class="swiper-wrapper">
                        <?php
                        echo '<div class="swiper-slide styler-swiper-slide-first">'.$timg.'</div>';
                        foreach ( $images as $image ) {
                            echo '<div class="swiper-slide">'.wp_get_attachment_image( $image, $tsize ).'</div>';
                        }
                        if ( $iframe_video && 'gallery' == $video_type ) {
                            echo '<div class="swiper-slide swiper-slide-video-item"><img width="70" height="70" src="'.esc_url($video_img).'" /></div>';
                        }
                        ?>
                    </div>
                </div>
            </div>

        </div>
        <?php
    }
}

/**
* product page gallery
*/
if ( ! function_exists( 'styler_product_gallery_slider_full' ) ) {
    function styler_product_gallery_slider_full()
    {
        global $product;
        $images = $product->get_gallery_image_ids();
        $size   = apply_filters( 'styler_product_thumb_size', 'woocommerce_single' );
        $id     = $product->get_id();

        // gallery top first thumbnail
        $img   = get_the_post_thumbnail( $id, $size );
        $url   = get_the_post_thumbnail_url( $id, $size );
        $str   = json_encode( $img );

        // gallery bottom first thumbnail
        $tsize = [90,90];
        $timg  = get_the_post_thumbnail( $id, $tsize );
        $tstr  = json_encode( $timg );

        $iframe_video = get_post_meta( get_the_ID(), 'styler_product_iframe_video', true );
        $popup_video  = get_post_meta( get_the_ID(), 'styler_product_popup_video', true );
        $video_type   = apply_filters( 'styler_product_video_type', get_post_meta( get_the_ID(), 'styler_product_video_type', true ) );

        $main_slider_options = json_encode( apply_filters('styler_product_gallery_showcase_js_options',
            array(
                "loop"                 => false,
                "speed"                => 800,
                "spaceBetween"         => 0,
                "slidesPerView"        => 1,
                "freeMode"             => false,
                "direction"            => "horizontal",
                "autoHeight"           => false,
                "observer"             => true,
                "observeParents"       => true,
                "observeSlideChildren" => true,
                "updateOnWindowResize" => true,
                "preventClicks"        => true,
                "preventClicksPropagation"        => true,
                "navigation"           => [
                    "nextEl" => ".styler-product-gallery-main-slider .swiper-button-next",
                    "prevEl" => ".styler-product-gallery-main-slider .swiper-button-prev"
                ],
                "effect"               => styler_settings('single_shop_showcase_full_effect_type', 'creative'),
                "creativeEffect"       => [
                    "prev" => [ "translate" => [0, 0, -400] ],
                    "next" => [ "translate" => ['100%', 0, 0] ]
                ]
            )
        ));
        $thumbs_slider_options = json_encode( apply_filters('styler_product_gallery_thumbs_js_options',
            array(
                "loop"          => false,
                "speed"         => 1000,
                "spaceBetween"  => 10,
                "slidesPerView" => 6,
                "freeMode"      => false,
                "direction"     => "horizontal",
                "autoHeight"    => false,
                "preventClicks" => true,
                "navigation"    => [
                    "nextEl" => ".styler-product-gallery-main-slider .swiper-button-next",
                    "prevEl" => ".styler-product-gallery-main-slider .swiper-button-prev"
                ],
                "breakpoints"   => [
                    "768" => [
                        "slidesPerView" => 8
                    ]
                ]
            )
        ));

        remove_action( 'woocommerce_product_thumbnails', 'woocommerce_show_product_thumbnails', 20 );

        $lightbox = 'fancybox' == styler_settings( 'product_gallery_lightbox', 'fancybox' ) ? ' data-fancybox="images"' : '';
        if ( 'fancybox' == styler_settings( 'product_gallery_lightbox', 'fancybox' ) ) {
            wp_enqueue_style( 'fancybox' );
            wp_enqueue_script( 'fancybox' );
        }
        ?>
        <div class="styler-swiper-slider-wrapper styler-slider-thumbs-bottom container-xl styler-container-xl">

            <div class="styler-product-gallery-main-slider styler-swiper-main swiper-container col-12 col-lg-12" data-swiper-options="<?php echo esc_attr( $main_slider_options ); ?>">
                <?php
                if ( $popup_video && 'popup' == $video_type ) {
                    echo '<a href="'.$popup_video.'" class="styler-product-video-button mfp-iframe"><i class="fa fa-play"></i></a>';
                }
                styler_single_product_labels();
                do_action( 'woocommerce_product_thumbnails' );
                echo '<a class="styler-product-popup" href="'.esc_url( $url ).'"'.$lightbox.'><i class="fas fa-expand"></i></a>';
                ?>
                <div class="swiper-wrapper styler-gallery-items">
                    <?php
                    echo '<div class="swiper-slide styler-swiper-slide-first">'.$img.'</div>';
                    foreach ( $images as $image ) {
                        $gimg = wp_get_attachment_image( $image, $size );
                        $gurl = wp_get_attachment_image_url( $image, $size );
                        echo '<div class="swiper-slide">'.$gimg.'</div>';
                    }
                    if ( $iframe_video && 'gallery' == $video_type ) {
                        $iframe_html = '<iframe class="lazy" loading="lazy" data-src="https://www.youtube.com/embed/'.$iframe_video.'?playlist='.$iframe_video.'&modestbranding=1&rel=0&controls=0&autoplay=1&enablejsapi=1&showinfo=0&mute=1&loop=1&start=5&end=25" allow="autoplay; fullscreen; accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" frameborder="0" allowfullscreen></iframe>';
                        echo '<div class="swiper-slide swiper-slide-video-item iframe-video"><div class="styler-slide-iframe-wrapper">'.$iframe_html.'</div></div>';
                    }
                    ?>
                </div>
                <?php if ( is_rtl() ) { ?>
                    <div class="swiper-button-next styler-swiper-next"></div>
                    <div class="swiper-button-prev styler-swiper-prev"></div>
                <?php } else { ?>
                    <div class="swiper-button-prev styler-swiper-prev"></div>
                    <div class="swiper-button-next styler-swiper-next"></div>
                <?php } ?>
            </div>

            <div class="styler-product-thumbnails styler-swiper-thumbnails styler-slider-thumbnails-full swiper-container col-12 col-lg-12" data-swiper-options="<?php echo esc_attr( $thumbs_slider_options ); ?>">
                <div class="swiper-wrapper">
                    <?php
                    echo '<div class="swiper-slide styler-swiper-slide-first">'.$timg.'</div>';
                    foreach ( $images as $image ) {
                        echo '<div class="swiper-slide">'.wp_get_attachment_image( $image, $tsize ).'</div>';
                    }
                    if ( $iframe_video && 'gallery' == $video_type ) {
                        echo '<div class="swiper-slide swiper-slide-video-item"><div class="styler-slide-video-item-icon" data-height="90"><i class="fa fa-play"></i></div></div>';
                    }
                    ?>
                </div>
            </div>

        </div>
        <?php
    }
}

/**
* product page gallery
*/
if ( ! function_exists( 'styler_product_gallery_slider_carousel' ) ) {
    function styler_product_gallery_slider_carousel()
    {
        global $product;
        $images = $product->get_gallery_image_ids();
        $size   = apply_filters( 'styler_product_carousel_lightbox_images_size', 'woocommerce_single' );
        $csize  = apply_filters( 'styler_product_carousel_images_size', [500,500] );
        $id     = $product->get_id();

        // gallery top first thumbnail
        $img = get_the_post_thumbnail( $id, $csize );
        $url = get_the_post_thumbnail_url( $id, 'full' );
        $str = json_encode( $img );

        $iframe_video = get_post_meta( get_the_ID(), 'styler_product_iframe_video', true );
        $popup_video  = get_post_meta( get_the_ID(), 'styler_product_popup_video', true );
        $video_type   = apply_filters( 'styler_product_video_type', get_post_meta( get_the_ID(), 'styler_product_video_type', true ) );
        $loader       = '<div class="loading-wrapper"><span class="ajax-loading"></span></div>';

        $main_slider_options = json_encode( apply_filters('styler_product_gallery_showcase_js_options',
            array(
                "loop"                 => '1' == styler_settings('single_shop_showcase_carousel_loop', '1') ? true : false,
                "roundLengths"         => true,
                "speed"                => 800,
                "spaceBetween"         => 0,
                "slidesPerView"        => 1,
                "freeMode"             => false,
                "direction"            => "horizontal",
                "centeredSlides"       => true,
                "slideToClickedSlide"  => true,
                "grabCursor"           => true,
                "autoHeight"           => false,
                "preventClicks"        => false,
                "observer"             => true,
                "observeParents"       => true,
                "observeSlideChildren" => true,
                "navigation"           => [
                    "nextEl" => ".styler-product-gallery-main-slider-carousel .swiper-button-next",
                    "prevEl" => ".styler-product-gallery-main-slider-carousel .swiper-button-prev"
                ],
                "pagination"           => [
                    "el"        => ".styler-product-gallery-main-slider-carousel .swiper-pagination",
                    "type"      => "bullets",
                    "clickable" => true
                ],
                "effect"               => styler_settings('single_shop_showcase_carousel_effect_type', ''),
                "coverflowEffect"      => [
                    "rotate"       => styler_settings('single_shop_showcase_carousel_coverflow_rotate', ''),
                    "slideShadows" => false
                ],
                "breakpoints"          => [
                    "768" => [
                        "slidesPerView" => 3
                    ],
                    "1024" => [
                        "slidesPerView" => 4
                    ]
                ]
            )
        ));
        remove_action( 'woocommerce_product_thumbnails', 'woocommerce_show_product_thumbnails', 20 );

        $lightbox = 'fancybox' == styler_settings( 'product_gallery_lightbox', 'fancybox' ) ? ' data-fancybox="images"' : '';
        if ( 'fancybox' == styler_settings( 'product_gallery_lightbox', 'fancybox' ) ) {
            wp_enqueue_style( 'fancybox' );
            wp_enqueue_script( 'fancybox' );
        }
        ?>
        <div class="styler-swiper-slider-wrapper">

            <div class="styler-product-gallery-main-slider-carousel styler-swiper-main swiper-container" data-swiper-options="<?php echo esc_attr( $main_slider_options ); ?>">
                <?php
                do_action( 'woocommerce_product_thumbnails' );
                ?>
                <div class="swiper-wrapper styler-gallery-items">
                    <?php
                    if ( $iframe_video && 'gallery' == $video_type ) {
                        $iframe_html = '<iframe class="lazy" loading="lazy" data-src="https://www.youtube.com/embed/'.$iframe_video.'?playlist='.$iframe_video.'&modestbranding=1&rel=0&controls=0&autoplay=1&enablejsapi=1&showinfo=0&mute=1&loop=1&start=5&end=25" allow="autoplay; fullscreen; accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" frameborder="0" allowfullscreen></iframe>';
                        echo '<div class="swiper-slide swiper-slide-video-item iframe-video"><div class="styler-slide-iframe-wrapper">'.$iframe_html.'</div></div>';
                    }
                    echo '<div class="swiper-slide styler-swiper-slide-first" data-zoom-img="'.esc_url( $url ).'"><a class="styler-product-popup" href="'.esc_url( $url ).'"'.$lightbox.'><i class="fas fa-expand"></i></a>'.$img.'</div>';
                    foreach ( $images as $image ) {
                        $gimg = wp_get_attachment_image( $image, $csize );
                        $gurl = wp_get_attachment_image_url( $image, 'full' );
                        echo '<div class="swiper-slide" data-zoom-img="'.esc_url( $gurl ).'"><a class="styler-product-popup" href="'.esc_url( $gurl ).'"'.$lightbox.'><i class="fas fa-expand"></i></a>'.$gimg.'</div>';
                    }
                    ?>
                </div>
                <div class="swiper-pagination"></div>
                <?php if ( is_rtl() ) { ?>
                    <div class="swiper-button-next styler-swiper-next"></div>
                    <div class="swiper-button-prev styler-swiper-prev"></div>
                <?php } else { ?>
                    <div class="swiper-button-prev styler-swiper-prev"></div>
                    <div class="swiper-button-next styler-swiper-next"></div>
                <?php } ?>
            </div>

        </div>
        <?php
    }
}

/**
* product page gallery
*/
if ( ! function_exists( 'styler_product_gallery_grid' ) ) {
    function styler_product_gallery_grid()
    {
        global $product;
        $column = apply_filters( 'styler_product_gallery_type_column', styler_settings( 'styler_product_gallery_grid_column', '2' ) );
        $images = $product->get_gallery_image_ids();
        $size   = apply_filters( 'styler_product_thumb_size', 'woocommerce_single' );
        $id     = $product->get_id();

        // gallery top first thumbnail
        $img   = get_the_post_thumbnail( $product->get_id(), $size );
        $url   = get_the_post_thumbnail_url( $product->get_id(), $size );
        $str   = json_encode($img);

        $iframe_video = get_post_meta( get_the_ID(), 'styler_product_iframe_video', true );
        $popup_video  = get_post_meta( get_the_ID(), 'styler_product_popup_video', true );
        $video_type   = apply_filters( 'styler_product_video_type', get_post_meta( get_the_ID(), 'styler_product_video_type', true ) );

        switch ( $column ) {
            case '1':
                $tsize = 'woocommerce_single';
                break;
            case '2':
                $tsize = [500,500];
                break;
            case '3':
                $tsize = [300,300];
                break;
            case '4':
                $tsize = [200,200];
                break;
            default:
                $tsize = [400,400];
                break;
        }
        remove_action( 'woocommerce_product_thumbnails', 'woocommerce_show_product_thumbnails', 20 );

        $lightbox = 'fancybox' == styler_settings( 'product_gallery_lightbox', 'fancybox' ) ? ' data-fancybox="images"' : '';
        if ( 'fancybox' == styler_settings( 'product_gallery_lightbox', 'fancybox' ) ) {
            wp_enqueue_style( 'fancybox' );
            wp_enqueue_script( 'fancybox' );
        }
        ?>
        <div class="styler-product-main-gallery-grid grid-column-<?php echo esc_attr( $column ); ?>">
            <?php
            if ( $iframe_video || $popup_video ) {
                if ( 'gallery' == $video_type ) {

                    if ( $iframe_video && 'gallery' == $video_type ) {
                        $iframe_html = '<iframe class="lazy" loading="lazy" data-src="https://www.youtube.com/embed/'.$iframe_video.'?playlist='.$iframe_video.'&modestbranding=1&rel=0&controls=0&autoplay=1&enablejsapi=1&showinfo=0&mute=1&loop=1&start=5&end=25" allow="autoplay; fullscreen; accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" frameborder="0" allowfullscreen></iframe>';
                        echo '<div class="styler-gallery-grid-item styler-gallery-grid-video-item iframe-video">'.$iframe_html.'</div>';
                    }
                } else {
                    if ( $popup_video ) {
                        echo '<a href="'.$popup_video.'" class="styler-product-video-button mfp-iframe"><i class="fa fa-play"></i></a>';
                    }
                }
            }
            styler_single_product_labels();
            do_action( 'woocommerce_product_thumbnails' );
            echo '<div class="styler-gallery-grid-item styler-gallery-grid-item-first"><a class="styler-product-popup" href="'.esc_url( $url ).'"'.$lightbox.'><i class="fas fa-expand"></i></a>'.$img.'</div>';
            if ( !empty( $images ) ) {
                echo '<div class="row row-cols-1 row-cols-sm-'.esc_attr( $column ).'">';
                foreach ( $images as $image ) {
                    $gimg = wp_get_attachment_image( $image, $tsize );
                    $gurl = wp_get_attachment_image_url( $image, $size );
                    echo '<div class="col styler-gallery-grid-item mt-30"><a class="styler-product-popup" href="'.esc_url( $gurl ).'"'.$lightbox.'><i class="fas fa-expand"></i></a>'.$gimg.'</div>';
                }
                echo '</div>';
            }
            ?>
        </div>
        <?php
    }
}


if ( ! function_exists( 'styler_single_product_nav_two' ) ) {
    function styler_single_product_nav_two() {

        if ( '0' == styler_settings('single_shop_nav_visibility', '1') ) {
            return;
        }
        $prev    = get_previous_post();
        $prevID  = $prev ? $prev->ID : '';
        $next    = get_next_post();
        $nextID  = $next ? $next->ID : '';
        $imgSize = array(40,40,true);
        ?>
        <div class="styler-product-nav styler-flex styler-align-center">
            <?php if ( $prevID ) : ?>
                <a class="product-nav-link styler-nav-prev" href="<?php echo esc_url( get_permalink( $prevID ) ); ?>">
                    <span class="styler-nav-arrow styler-nav-prev-arrow"></span>
                    <span class="product-nav-content">
                        <?php echo apply_filters( 'styler_products_nav_image', get_the_post_thumbnail( $prevID, $imgSize ) ); ?>
                        <span class="product-nav-title"><?php echo get_the_title( $prevID ); ?></span>
                    </span>
                </a>
            <?php else : ?>
                <a class="product-nav-link styler-nav-prev disabled" href="#0">
                    <span class="styler-nav-arrow styler-nav-prev-arrow"></span>
                </a>
            <?php endif ?>

            <a href="<?php echo apply_filters( 'styler_single_product_back_btn_url', get_permalink( wc_get_page_id( 'shop' ) ) ); ?>" class="product-nav-link styler-nav-shop">
                <span class="styler-shop-link-inner">
                    <span class="styler-shop-link-icon"></span>
                    <span class="styler-shop-link-icon"></span>
                </span>
            </a>

            <?php if ( $nextID ) : ?>
                <a class="product-nav-link styler-nav-next" href="<?php echo esc_url( get_permalink( $nextID ) ); ?>">
                    <span class="styler-nav-arrow styler-nav-next-arrow"></span>
                    <span class="product-nav-content">
                        <?php echo apply_filters( 'styler_products_nav_image', get_the_post_thumbnail( $nextID, $imgSize ) ); ?>
                        <span class="product-nav-title"><?php echo get_the_title( $nextID ); ?></span>
                    </span>
                </a>
            <?php else : ?>
                <a class="product-nav-link styler-nav-next disabled" href="#0">
                    <span class="styler-nav-arrow styler-nav-next-arrow"></span>
                </a>
            <?php endif ?>
        </div>
        <?php
    }
}


/**
* Add stock progressbar
*/
if ( ! function_exists( 'styler_product_stock_progress_bar' ) ) {
    function styler_product_stock_progress_bar() {
        global $post,$product;
        $product_id   = $post->ID;
        $progressbar  = styler_settings( 'single_shop_progressbar_visibility', '0' );
        $manage_stock = get_post_meta( $product_id, '_manage_stock', true );

        if ( $manage_stock != 'yes' || '0' == $progressbar ) {
            return;
        }

        $current_stock = get_post_meta( $product_id, '_stock', true );
        $total_sold    = $product->get_total_sales();
        $percentage    = $total_sold > 0 && $current_stock > 0 ? round( $total_sold / $current_stock * 100 ) : 0;

        if ( $current_stock > 0 ) {
            ?>
            <div class="styler-summary-item styler-single-product-stock">
                <div class="stock-details">
                    <div class="stock-sold"><?php esc_html_e( 'Ordered:', 'styler' ); ?><span> <?php echo esc_html( $total_sold ); ?></span></div>
                    <div class="current-stock"><?php esc_html_e( 'Items available:', 'styler' ); ?><span> <?php echo esc_html( wc_trim_zeros( $current_stock ) ); ?></span></div>
                </div>
                <div class="styler-product-stock-progress">
                    <div class="styler-product-stock-progressbar" data-stock-percent="<?php echo esc_attr( $percentage ); ?>%"></div>
                </div>
            </div>
            <?php
        }
    }
}

/**
* Add size guide popup
*/
if ( ! function_exists( 'styler_product_popup_details' ) ) {
    add_action( 'woocommerce_single_product_summary', 'styler_product_popup_details', 35 );
    function styler_product_popup_details()
    {
        $product_id = get_the_ID();
        $guide      = get_post_meta( $product_id, 'styler_product_size_guide', true );
        $question   = styler_settings( 'single_shop_question_form_template', null );
        $delivery   = styler_settings( 'single_shop_delivery_template', null );
        if ( $guide || $question || $delivery ) {
            ?>
            <div class="styler-summary-item styler-product-popup-details">
                <?php
                styler_product_size_guide();
                styler_product_delivery_return();
                styler_product_question_form();
                styler_product_estimated_delivery();
                styler_product_views();
                ?>
            </div>
            <?php
        }
    }
}
/**
* Add size guide popup
*/
if ( ! function_exists( 'styler_product_size_guide' ) ) {
    function styler_product_size_guide()
    {
        $product_id = get_the_ID();
        $guide_id   = get_post_meta( $product_id, 'styler_product_size_guide', true );

        if ( '0' == styler_settings( 'single_shop_size_guide_visibility', '0' ) && '' == $guide_id ) {
            return;
        }
        $title = styler_settings( 'product_shop_question_title', '' );
        $title = $title ? $title : esc_html__( 'Size Guide', 'styler' );
        ?>
        <div class="styler-size-guide-btn has-svg-icon styler-flex styler-align-center">
            <?php echo styler_svg_lists('ruler', 'styler-svg-icon'); ?>&nbsp;
            <a href="#styler_size_guide_<?php echo esc_attr( $product_id ); ?>" class="styler-open-popup"><?php echo esc_html( $title ); ?></a>
        </div>
        <div class="styler-single-product-size-guide styler-popup-content-big zoom-anim-dialog mfp-hide" id="styler_size_guide_<?php echo esc_attr( $product_id ); ?>">
            <?php styler_print_elTemplates_by_category( $guide_id, '', true ); ?>
        </div>
        <?php
    }
}

/**
* Add question form popup
*/
if ( ! function_exists( 'styler_product_question_form' ) ) {
    function styler_product_question_form()
    {
        global $product;
        $template_id = styler_settings( 'single_shop_question_form_template', null );

        if ( null == $template_id || '' == $template_id ) {
            return;
        }
        $terms = wc_get_product_term_ids( $product->get_id(), 'product_cat' );
        $category_exclude = styler_settings( 'single_shop_question_template_category_exclude', null );
        if ( !empty($terms) ) {
            foreach ($terms as $term ) {
                if ( !empty($category_exclude) ) {
                    foreach ($category_exclude as $val ) {
                        if ( $term == $val ) {
                            return;
                        }
                    }
                }
            }
        }
        $title = styler_settings( 'product_shop_question_title', '' );
        $title = $title ? $title : esc_html__( 'Size Guide', 'styler' );
        ?>
        <div class="styler-product-question-btn has-svg-icon styler-flex styler-align-center">
            <?php echo styler_svg_lists('question', 'styler-svg-icon'); ?>&nbsp;
            <a href="#styler_product_question_<?php echo esc_attr( $template_id ); ?>" class="styler-open-popup"><?php echo esc_html( $title ); ?></a>
        </div>
        <div class="styler-single-product-question styler-popup-content-big zoom-anim-dialog mfp-hide" id="styler_product_question_<?php echo esc_attr( $template_id ); ?>">
            <?php echo styler_print_elementor_templates( 'single_shop_question_form_template', '' ); ?>
        </div>
        <?php
    }
}


/**
* Add delivery and return popup
*/
if ( ! function_exists( 'styler_product_delivery_return' ) ) {
    function styler_product_delivery_return()
    {
        global $product;
        $template_id = styler_settings( 'single_shop_delivery_template', null );
        $terms = wc_get_product_term_ids( $product->get_id(), 'product_cat' );
        $category_exclude = styler_settings( 'single_shop_delivery_template_category_exclude', null );
        if ( !empty($terms) ) {
            foreach ($terms as $term ) {
                if ( !empty($category_exclude) ) {
                    foreach ($category_exclude as $val ) {
                        if ( $term == $val ) {
                            return;
                        }
                    }
                }
            }
        }

        if ( null == $template_id || '' == $template_id ) {
            return;
        }
        $title = styler_settings( 'product_delivery_return_title', '' );
        $title = $title ? $title : esc_html__( 'Delivery & Return', 'styler' );
        ?>
        <div class="styler-product-delivery-btn has-svg-icon styler-flex styler-align-center">
            <?php echo styler_svg_lists('delivery-return', 'styler-svg-icon'); ?>&nbsp;
            <a href="#styler_product_delivery_<?php echo esc_attr( $template_id ); ?>" class="styler-open-popup"><?php echo esc_html( $title ); ?></a>
        </div>
        <div class="styler-single-product-delivery styler-popup-content-big zoom-anim-dialog mfp-hide" id="styler_product_delivery_<?php echo esc_attr( $template_id ); ?>">
            <?php echo styler_print_elementor_templates( 'single_shop_delivery_template', '' ); ?>
        </div>
        <?php
    }
}

if ( ! function_exists( 'styler_product_views' ) ) {
    function styler_product_views()
    {
        if ( '0' == styler_settings('single_shop_visit_count_visibility', '0' ) ) {
            return;
        }
        wp_enqueue_script( 'jquery-cookie');
        global $product;

        $data[] = styler_settings( 'visit_count_min' ) ? '"min":' . styler_settings( 'visit_count_min' ) : '"min":10';
        $data[] = styler_settings( 'visit_count_max' ) ? '"max":' . styler_settings( 'visit_count_max' ) : '"max":50';
        $data[] = styler_settings( 'visit_count_delay' ) ? '"delay":' . styler_settings( 'visit_count_delay' ) : '"delay":30000';
        $data[] = styler_settings( 'visit_count_change' ) ? '"change":' . styler_settings( 'visit_count_change' ) : '"change":5';
        $data[] = '"id":' . $product->get_id();
        ?>
        <div class="styler-product-view" data-product-view='{<?php echo implode(',', $data ); ?>}'>
            <?php echo styler_svg_lists( 'smile', 'styler-svg-icon' ); ?>&nbsp;
            <span><span class="styler-view-count">&nbsp;</span> <?php esc_html_e( 'people', 'styler' ); ?></span>&nbsp;
            <?php esc_html_e( 'are viewing this right now', 'styler' ); ?>
        </div>
        <?php
    }
}

if ( ! function_exists( 'styler_product_estimated_delivery' ) ) {
    function styler_product_estimated_delivery() {

        if ( '0' == styler_settings('single_shop_estimated_delivery_visibility', '0' ) ) {
            return;
        }
        $title = styler_settings( 'product_estimated_delivery_title',  );
        $title = $title ? $title : esc_html__( 'Estimated Delivery', 'styler' );

        $min_ed = styler_settings('single_shop_min_estimated_delivery');
        $max_ed = styler_settings('single_shop_max_estimated_delivery');

        $min = $min_ed ? $min_ed : 3;
        $from = '+' . $min;
        $from .= ' ' . ( $min = 1 ? 'day' : 'days' );

        $max = $max_ed ? (int) $max_ed : 7;
        $to = '+' . $max;
        $to .= ' ' . ( $max = 1 ? 'day' : 'days' );

        $now = get_date_from_gmt( date('Y-m-d H:i:s'), 'Y-m-d' );
        $est_days = array();

        $format = esc_html__( 'M d', 'styler' );
        $est_days[] = date_i18n( $format, strtotime( $now . $from ), true );
        $est_days[] = date_i18n( $format, strtotime( $now . $to ), true );

        if ( !empty( $est_days ) ) {
            ?>
            <div class="styler-estimated-delivery">
                <?php echo styler_svg_lists( 'shipping', 'styler-svg-icon' ); ?>&nbsp;
                <span><?php echo esc_html( $title ); ?>&nbsp;</span>
                <?php echo implode( ' ', $est_days ); ?>
            </div>
            <?php
        }
    }
}


/**
* Add product excerpt
*/
if ( ! function_exists( 'styler_product_excerpt' ) ) {
    function styler_product_excerpt()
    {
        global $product;
        if ( $product->get_short_description() ) {
            $limit = styler_settings('shop_loop_excerpt_limit');
            ?>
            <p class="styler-product-excerpt"><?php echo wp_trim_words( $product->get_short_description(), apply_filters( 'styler_loop_excerpt_limit', $limit ) ); ?></p>
            <?php
        }
    }
}

/**
* Add product rating
*/
if ( ! function_exists( 'styler_product_rating' ) ) {

    function styler_product_rating()
    {
        global $product;
        $rating_count = $product->get_rating_count();
        $review_count = $product->get_review_count();
        $average      = $product->get_average_rating();
        if ( $product->get_average_rating() ) {
            ?>
            <div class="styler-rating star-rating">
                <span data-width="<?php echo esc_attr( ( $average / 5 ) * 100  ); ?>"></span>
                <?php if ( comments_open() ) { ?>
                    <a href="#reviews" class="styler-review-link styler-small-title" rel="nofollow"><?php printf( _n( '%s review', '%s reviews', $review_count, 'styler' ), '<span class="count">' . esc_html( $review_count ) . '</span>' ); ?></a>
                <?php } ?>
            </div>
            <?php
        }
    }
}

/**
* Add product rating
*/
if ( ! function_exists( 'styler_product_meta' ) ) {

    function styler_product_meta()
    {
        global $product;
        ?>
        <div class="styler-summary-item styler-product-meta">
            <?php do_action( 'woocommerce_product_meta_start' ); ?>
            <?php echo wc_get_product_category_list( $product->get_id(), ', ', '<span class="styler-small-title posted_in">' . _n( 'Category:', 'Categories:', count( $product->get_category_ids() ), 'styler' ) . ' ', '</span>' ); ?>
            <?php echo wc_get_product_tag_list( $product->get_id(), ', ', '<span class="styler-small-title tagged_as">' . _n( 'Tag:', 'Tags:', count( $product->get_tag_ids() ), 'styler' ) . ' ', '</span>' ); ?>
            <?php do_action( 'woocommerce_product_meta_end' ); ?>
        </div>
        <?php
    }
}


/**
* Get product sku
*/
if ( ! function_exists( 'styler_product_sku' ) ) {
    function styler_product_sku()
    {
        global $product;
        if ( $product->get_sku() ) {
        echo '<div class="styler-meta-wrapper styler-small-title"><span class="styler-terms-label">'.esc_html__('SKU:', 'styler') .'</span><span class="styler-sku">'.esc_html( $product->get_sku() ).'</span></div>';
        }
    }
}


if ( ! function_exists( 'styler_product_badge' ) ) {
    function styler_product_badge($echo=true)
    {
        global $product;
        $title  = get_post_meta( $product->get_id(), 'styler_custom_badge', true );
        $ishtml = get_post_meta( $product->get_id(), 'styler_custom_html_badge', true );
        $color  = get_post_meta( $product->get_id(), 'styler_badge_color', true );
        $color  = $color ? $color : '';

        if ( true == $echo ) {
            if ( '' != $title ) {
                if ( 'yes' == $ishtml ) {
                echo '<span class="styler-label styler-badge styler-custom-html-badge">'.$title.'</span>';
                } else {
                    echo '<span class="styler-label styler-badge badge-'.esc_attr( $title ).'" data-label-color="'.$color.'">'.esc_html( $title ).'</span>';
                }
            } else {
                if ( $product->is_on_sale() ) {
                    echo '<span class="styler-label styler-badge badge-def" data-label-color="'.esc_attr( $color ).'">'.esc_html__( 'Sale!', 'styler' ).'</span>';
                }
            }
        } else {
            if ( '' != $title ) {
                if ( 'yes' == $ishtml ) {
                    return '<span class="styler-label styler-badge styler-custom-html-badge">'.$title.'</span>';
                    } else {
                        return '<span class="styler-label styler-badge badge-'.esc_attr( $title ).'" data-label-color="'.$color.'">'.esc_html( $title ).'</span>';
                    }
            } else {
                if ( $product->is_on_sale() ) {
                    return '<span class="styler-label styler-badge badge-def" data-label-color="'.esc_attr( $color ).'">'.esc_html__( 'Sale!', 'styler' ).'</span>';
                }
            }
        }
    }
}

/**
* Single product labels
*/
if ( ! function_exists( 'styler_single_product_labels' ) ) {
    function styler_single_product_labels()
    {
        if ( '0' == styler_settings('single_shop_top_labels_visibility', '1' ) ) {
            return;
        }
        echo '<div class="styler-product-labels">';
            styler_product_badge();
            styler_product_discount();
        echo '</div>';
    }
}


if ( ! function_exists( 'styler_loop_category_title' ) ) {

    /**
    * Show the subcategory title in the product loop.
    *
    * @param object $category Category object.
    */
    function styler_loop_category_title( $category ) {
        ?>
        <h4 class="styler-loop-category-title">
            <?php
            echo esc_html( $category->name );

            if ( $category->count > 0 ) {
                echo '<span class="cat-count">' . esc_html( $category->count ) . '</span>';
            }
            ?>
        </h4>
        <?php
    }
}


/**
* product brand
*/
if ( ! function_exists( 'styler_product_brands' ) ) {
    function styler_product_brands()
    {
        global $product;
        $brands = '';
        $metaid = defined( 'YITH_WCBR' ) ? 'yith_product_brand' : 'styler_product_brands';
        $terms = get_the_terms( $product->get_id(), $metaid );
        if ( ! empty( $terms ) && ! is_wp_error( $terms ) ) {
            $brands = array();
            foreach ( $terms as $term ) {
                if ( $term->parent == 0 ) {
                    $brands[] = sprintf( '<a class="styler-brands" href="%s" itemprop="brand" title="%s">%s</a>',
                        get_term_link( $term ),
                        $term->slug,
                        $term->name
                    );
                }
            }
        }
        echo !empty( $brands ) ? '<span class="styler-brands">'.esc_html__('Brands: ', 'styler' ) . implode( ', ', $brands ) .'</span>' : '';
    }
}



/**
*  add custom color field to for product badge
*/
if ( ! function_exists( 'styler_wc_product_meta_color' ) ) {

    function styler_wc_product_meta_color( $field )
    {
        global $thepostid, $post;

        $thepostid      = empty( $thepostid ) ? $post->ID : $thepostid;
        $field['class'] = isset( $field['class'] ) ? $field['class'] : 'styler-color-field';
        $field['value'] = isset( $field['value'] ) ? $field['value'] : get_post_meta( $thepostid, $field['id'], true );

        echo '<p class="form-field ' . esc_attr( $field['id'] ) . '_field"><label for="' . esc_attr( $field['id'] ) . '">' . wp_kses_post( $field['label'] ) . '</label>
        <input type="text" class="styler-color-field" name="' . esc_attr( $field['id'] ) . '" id="' . esc_attr( $field['id'] ) . '" value="' . esc_attr( $field['value'] ) . '" /></p>';
    }
}


/**
*  countdown for product
*/
if ( ! function_exists( 'styler_product_countdown' ) ) {

    function styler_product_countdown()
    {
        if ( '0' != styler_settings('single_shop_countdown_visibility','1') ) {
            global $product;
            $time = get_post_meta( $product->get_id(), 'styler_countdown_date', true);
            $text = get_post_meta( $product->get_id(), 'styler_countdown_text', true);

            if ( $time ) {
                wp_enqueue_script( 'jquery-countdown' );
                wp_enqueue_script( 'styler-countdown' );
                $data[] = '"date":"'.$time.'"';
                $data[] = '"day":"'.esc_html__('day', 'styler').'"';
                $data[] = '"hr":"'.esc_html__('hour', 'styler').'"';
                $data[] = '"min":"'.esc_html__('min', 'styler').'"';
                $data[] = '"sec":"'.esc_html__('sec', 'styler').'"';

                echo '<div class="styler-summary-item styler-viewed-offer-time">';
                    if ( $text ) {
                        echo '<p class="offer-time-text">'.$text.'</p>';
                    }
                    echo '<div class="styler-coming-time" data-countdown=\'{'.implode(', ', $data ).'}\'></div>';
                echo '</div>';
            }
        }
    }
}


/**
*  custom extra tabs for product page
*/
if ( ! function_exists( 'styler_wc_extra_tabs_array' ) ) {
    function styler_wc_extra_tabs_array()
    {
        global $product;
        $tabs        = array();
        $tab_title   = get_post_meta( $product->get_id(), 'styler_tabs_title', true);
        $tab_content = get_post_meta( $product->get_id(), 'styler_tabs_content', true);
        $tabtitle    = preg_split("/\\r\\n|\\r|\\n/", $tab_title );
        $tabcontent  = preg_split("/\\r\\n|\\r|\\n/", $tab_content );

        $count    = 30;
        foreach( styler_combine_arr($tabtitle, $tabcontent) as $title => $details ) {
            if ( !empty( $title ) && !empty( $details ) ) {
                $replaced_title = preg_replace('/\s+/', '_', strtolower(trim($title)));
                $tabs[$replaced_title] = array(
                    'title' => $title,
                    'priority' => $count,
                    'content' => $details
                );
            }
            $count = $count + 10;
        }
        return $tabs;
    }
}


/*
* Tab
*/
if ( ! function_exists( 'styler_product_settings_tabs' ) ) {
    add_filter('woocommerce_product_data_tabs', 'styler_product_settings_tabs' );
    function styler_product_settings_tabs( $tabs ){
        $tabs['styler_general'] = array(
            'label'    => esc_html__('Styler General', 'styler'),
            'target'   => 'styler_product_general_data',
            'priority' => 100,
        );
        $tabs['styler_product_page'] = array(
            'label'    => esc_html__('Styler Product Page', 'styler'),
            'target'   => 'styler_product_page_data',
            'priority' => 101,
        );
        return $tabs;
    }
}
/*
* Tab content
*/
if ( ! function_exists( 'styler_product_panels' ) ) {
    add_action( 'woocommerce_product_data_panels', 'styler_product_panels' );
    function styler_product_panels(){

        echo '<div id="styler_product_general_data" class="panel woocommerce_options_panel hidden">';
            echo '<h3 class="styler-panel-heading">'.esc_html__('Styler Product General Settings', 'styler').'</h3>';
            woocommerce_wp_checkbox(
                array(
                    'id' => 'styler_loop_product_slider',
                    'label' => esc_html__( 'Show Slider Thumbnails on Archive page?', 'styler' ),
                    'desc_tip' => false,
                )
            );
            woocommerce_wp_checkbox(
                array(
                    'id' => 'styler_loop_product_slider_autoplay',
                    'label' => esc_html__( 'Slider Autoplay?', 'styler' ),
                    'desc_tip' => false,
                )
            );
            woocommerce_wp_text_input(
                array(
                    'id' => 'styler_loop_product_slider_speed',
                    'label' => esc_html__( 'Slider Speed ( ms )', 'styler' ),
                    'desc_tip' => true,
                    'description' => esc_html__( 'Duration of transition between slides (in ms).Use simple number', 'styler' ),
                )
            );
            echo '<div class="styler-panel-divider"></div>';
            woocommerce_wp_checkbox(
                array(
                    'id' => 'styler_product_discount',
                    'label' => esc_html__( 'Hide Product Discount?', 'styler' ),
                    'wrapper_class' => 'hide_if_variable',
                    'desc_tip' => false,
                )
            );
            woocommerce_wp_checkbox(
                array(
                    'id' => 'styler_product_hide_stock',
                    'label' => esc_html__( 'Hide Product Stock Label?', 'styler' ),
                    'wrapper_class' => 'hide_if_variable',
                    'desc_tip' => false,
                )
            );
            echo '<div class="styler-panel-divider"></div>';
            echo '<h4 class="styler-panel-subheading">'.esc_html__('Badge Settings', 'styler').'</h4>';
            woocommerce_wp_text_input(
                array(
                    'id' => 'styler_custom_badge',
                    'label' => esc_html__( 'Badge Label', 'styler' ),
                    'desc_tip' => true,
                    'description' => esc_html__( 'Add your custom badge label here', 'styler' ),
                )
            );
            woocommerce_wp_checkbox(
                array(
                    'id' => 'styler_custom_html_badge',
                    'label' => esc_html__( 'Use Custom HTML?', 'styler' ),
                    'description' => esc_html__( 'Add your custom html label here.', 'styler' ),
                    'desc_tip' => true,
                )
            );
            styler_wc_product_meta_color(
                array(
                    'id' => 'styler_badge_color',
                    'label' => esc_html__( 'Badge Color', 'styler' ),
                )
            );

            echo '<div class="styler-panel-divider"></div>';
            echo '<h4 class="styler-panel-subheading">'.esc_html__('Countdown Settings', 'styler').'</h4>';
            woocommerce_wp_text_input(
                array(
                    'id' => 'styler_countdown_date',
                    'label' => esc_html__( 'Date for Countdown', 'styler' ),
                    'desc_tip' => true,
                    'description' => sprintf('%s <br/> %s%s',
                        esc_html__( 'Usage : month/day/year', 'styler' ),
                        esc_html__( 'Example : ', 'styler' ),
                        date('m/d/Y', strtotime('+1 month'))
                    )
                )
            );
            woocommerce_wp_text_input(
                array(
                    'id' => 'styler_countdown_text',
                    'label' => esc_html__( 'Countdown Text', 'styler' ),
                    'desc_tip' => true,
                    'description' => esc_html__( 'Add your custom text here', 'styler' ),
                )
            );
        echo '</div>';

        echo '<div id="styler_product_page_data" class="panel woocommerce_options_panel hidden">';
            echo '<h3 class="styler-panel-heading">'.esc_html__('Styler Product Page Settings', 'styler').'</h3>';
            echo '<h4 class="styler-panel-subheading">'.esc_html__('Product Header Type Settings', 'styler').'</h4>';
            woocommerce_wp_select(
                array(
                    'id' => 'styler_product_header_type',
                    'label' => esc_html__( 'Header Type?', 'styler' ),
                    'options' => array(
                        '' => 'Select a type',
                        'default' => esc_html__( 'Theme options settings', 'styler' ),
                        'dark' => esc_html__( 'Dark', 'styler' ),
                        'trans-light' => esc_html__( 'Transparent Light', 'styler' ),
                        'trans-dark' => esc_html__( 'Transparent Dark', 'styler' ),
                        'custom' => esc_html__( 'Custom Color', 'styler' ),
                    ),
                    'desc_tip' => true,
                    'description' => esc_html__( 'You can use this option to use a different header for this product', 'styler' )
                )
            );
            echo '<h4 class="styler-panel-subheading menu-customize">'.esc_html__('Header Custom Color Settings', 'styler').'</h4>';
            styler_wc_product_meta_color(
                array(
                    'id' => 'styler_product_header_bgcolor',
                    'label' => esc_html__( 'Header Background Color', 'styler' )
                )
            );
            styler_wc_product_meta_color(
                array(
                    'id' => 'styler_product_header_menuitem_color',
                    'label' => esc_html__( 'Menu Item Color', 'styler' )
                )
            );
            styler_wc_product_meta_color(
                array(
                    'id' => 'styler_product_header_menuitem_hvrcolor',
                    'label' => esc_html__( 'Menu Item Hover/Active Color', 'styler' )
                )
            );
            styler_wc_product_meta_color(
                array(
                    'id' => 'styler_product_header_svgicon_color',
                    'label' => esc_html__( 'Header SVG Buttons Color', 'styler' )
                )
            );
            styler_wc_product_meta_color(
                array(
                    'id' => 'styler_product_header_counter_bgcolor',
                    'label' => esc_html__( 'Header SVG Buttons Counter Background Color', 'styler' )
                )
            );
            styler_wc_product_meta_color(
                array(
                    'id' => 'styler_product_header_counter_color',
                    'label' => esc_html__( 'Header SVG Buttons Counter Color', 'styler' )
                )
            );
            echo '<h4 class="styler-panel-subheading menu-customize">'.esc_html__('Sticky Header Custom Color Settings', 'styler').'</h4>';
            styler_wc_product_meta_color(
                array(
                    'id' => 'styler_product_sticky_header_bgcolor',
                    'label' => esc_html__( 'Sticky Header Background Color', 'styler' )
                )
            );
            styler_wc_product_meta_color(
                array(
                    'id' => 'styler_product_sticky_header_menuitem_color',
                    'label' => esc_html__( 'Menu Item Color', 'styler' )
                )
            );
            styler_wc_product_meta_color(
                array(
                    'id' => 'styler_product_sticky_header_menuitem_hvrcolor',
                    'label' => esc_html__( 'Menu Item Hover/Active Color', 'styler' )
                )
            );
            styler_wc_product_meta_color(
                array(
                    'id' => 'styler_product_sticky_header_svgicon_color',
                    'label' => esc_html__( 'Header SVG Buttons Color', 'styler' )
                )
            );
            styler_wc_product_meta_color(
                array(
                    'id' => 'styler_product_sticky_header_counter_bgcolor',
                    'label' => esc_html__( 'Header SVG Buttons Counter Background Color', 'styler' )
                )
            );
            styler_wc_product_meta_color(
                array(
                    'id' => 'styler_product_sticky_header_counter_color',
                    'label' => esc_html__( 'Header SVG Buttons Counter Color', 'styler' )
                )
            );
            echo '<div class="styler-panel-divider"></div>';
            echo '<h4 class="styler-panel-subheading">'.esc_html__('Product Showcase Type Settings', 'styler').'</h4>';
            woocommerce_wp_select(
                array(
                    'id' => 'styler_showcase_type',
                    'label' => esc_html__( 'Showcase Type?', 'styler' ),
                    'options' => array(
                        '' => 'Select a type',
                        'full' => esc_html__( 'Full', 'styler' ),
                        'carousel' => esc_html__( 'Carousel', 'styler' ),
                    ),
                    'desc_tip' => false,
                )
            );
            woocommerce_wp_select(
                array(
                    'id' => 'styler_showcase_bg_type',
                    'label' => esc_html__( 'Background Color Type?', 'styler' ),
                    'options' => array(
                        '' => 'Select a type',
                        'dark' => esc_html__( 'Dark', 'styler' ),
                        'light' => esc_html__( 'Light', 'styler' ),
                        'custom' => esc_html__( 'Custom Color', 'styler' ),
                    ),
                    'desc_tip' => false,
                )
            );
            styler_wc_product_meta_color(
                array(
                    'id' => 'styler_showcase_custom_bgcolor',
                    'label' => esc_html__( 'Custom Background Color', 'styler' ),
                )
            );
            styler_wc_product_meta_color(
                array(
                    'id' => 'styler_showcase_custom_textcolor',
                    'label' => esc_html__( 'Custom Text Color', 'styler' ),
                )
            );
            echo '<div class="styler-panel-divider"></div>';
            echo '<h4 class="styler-panel-subheading">'.esc_html__('Product Showcase Type Settings', 'styler').'</h4>';
            woocommerce_wp_select(
                array(
                    'id' => 'styler_showcase_type',
                    'label' => esc_html__( 'Showcase Type?', 'styler' ),
                    'options' => array(
                        '' => 'Select a type',
                        'full' => esc_html__( 'Full', 'styler' ),
                        'carousel' => esc_html__( 'Carousel', 'styler' ),
                    ),
                    'desc_tip' => false,
                )
            );
            woocommerce_wp_select(
                array(
                    'id' => 'styler_showcase_bg_type',
                    'label' => esc_html__( 'Background Color Type?', 'styler' ),
                    'options' => array(
                        '' => 'Select a type',
                        'dark' => esc_html__( 'Dark', 'styler' ),
                        'light' => esc_html__( 'Light', 'styler' ),
                        'custom' => esc_html__( 'Custom Color', 'styler' ),
                    ),
                    'desc_tip' => false,
                )
            );
            styler_wc_product_meta_color(
                array(
                    'id' => 'styler_showcase_custom_bgcolor',
                    'label' => esc_html__( 'Custom Background Color', 'styler' ),
                )
            );
            styler_wc_product_meta_color(
                array(
                    'id' => 'styler_showcase_custom_textcolor',
                    'label' => esc_html__( 'Custom Text Color', 'styler' ),
                )
            );
            echo '<div class="styler-panel-divider"></div>';
            echo '<h4 class="styler-panel-subheading">'.esc_html__('Product Summary Settings', 'styler').'</h4>';
            woocommerce_wp_select(
                array(
                    'id' => 'styler_product_size_guide',
                    'label' => esc_html__( 'Size Guide of product', 'styler' ),
                    'options' => styler_get_elementorCategories(),
                    'desc_tip' => true,
                    'description' => sprintf('%s <a href="'.esc_url(admin_url('edit.php?post_type=elementor_library')).'"><b>%s</b></a> %s <a href="'.esc_url(admin_url('edit-tags.php?taxonomy=elementor_library_category&post_type=elementor_library')).'"><b>%s</b></a> %s',
                        esc_html__( 'Please create your size guide with', 'styler' ),
                        esc_html__( 'elementor template', 'styler' ),
                        esc_html__( 'and assign it to a', 'styler' ),
                        esc_html__( 'category', 'styler' ),
                        esc_html__( 'the categories you create will be listed here.', 'styler' )
                    )
                )
            );
            echo '<div class="styler-panel-divider"></div>';
            echo '<h4 class="styler-panel-subheading">'.esc_html__('Product Video Settings', 'styler').'</h4>';
            woocommerce_wp_select(
                array(
                    'id' => 'styler_product_video_type',
                    'label' => esc_html__( 'Product Video Type?', 'styler' ),
                    'options' => array(
                        '' => 'Select a type',
                        'popup' => esc_html__( 'Popup', 'styler' ),
                        'gallery' => esc_html__( 'Gallery Item', 'styler' ),
                    ),
                    'desc_tip' => false
                )
            );
            woocommerce_wp_text_input(
                array(
                    'id' => 'styler_product_popup_video',
                    'label' => esc_html__( 'Popup Video URL', 'styler' ),
                    'desc_tip' => true,
                    'description' => esc_html__( 'Add your youtube,vimeo,hosted video URL here', 'styler' )
                )
            );
            woocommerce_wp_text_input(
                array(
                    'id' => 'styler_product_iframe_video',
                    'label' => esc_html__( 'Youtube video ID', 'styler' ),
                    'desc_tip' => true,
                    'description' => esc_html__( 'Add your youtube video ID here for background autoplay video.', 'styler' ),
                    'rows' => 4
                )
            );
            woocommerce_wp_select(
                array(
                    'id' => 'styler_product_video_on_shop',
                    'label' => esc_html__( 'Show this iframe video on shop archive?', 'styler' ),
                    'options' => array(
                        '' => 'Select an option',
                        'no' => esc_html__( 'No', 'styler' ),
                        'yes' => esc_html__( 'Yes', 'styler' ),
                    ),
                    'desc_tip' => false
                )
            );
            echo '<div class="styler-panel-divider"></div>';
            echo '<h4 class="styler-panel-subheading">'.esc_html__('Extra Tabs Settings', 'styler').'</h4>';
            woocommerce_wp_textarea_input(
                array(
                    'id' => 'styler_tabs_title',
                    'label' => esc_html__( 'Extra Tabs Title', 'styler' ),
                    'desc_tip' => true,
                    'description' => esc_html__( '!Important note: One title per line.', 'styler' ),
                    'rows' => 3
                )
            );
            woocommerce_wp_textarea_input(
                array(
                    'id' => 'styler_tabs_content',
                    'label' => esc_html__( 'Extra Tabs Content', 'styler' ),
                    'desc_tip' => true,
                    'description' => esc_html__( '!Important note: One content per line.Iframe,shortcode,HTML content allowed.', 'styler' ),
                    'rows' => 4
                )
            );
        echo '</div>';
    }
}

/**
*  Save Custom Field
*/
if ( ! function_exists( 'styler_save_product_custom_field' ) ) {
    add_action( 'woocommerce_process_product_meta', 'styler_save_product_custom_field' );
    function styler_save_product_custom_field( $_post_id )
    {
        if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ){
            return;
        }
        $options = array(
            'styler_loop_product_slider',
            'styler_loop_product_slider_autoplay',
            'styler_loop_product_slider_speed',
            'styler_showcase_type',
            'styler_showcase_bg_type',
            'styler_showcase_custom_bgcolor',
            'styler_showcase_custom_textcolor',
            'styler_badge_color',
            'styler_custom_badge',
            'styler_custom_html_badge',
            'styler_product_discount',
            'styler_product_size_guide',
            'styler_product_hide_stock',
            'styler_countdown_date',
            'styler_countdown_text',
            'styler_product_video_type',
            'styler_product_popup_video',
            'styler_product_iframe_video',
            'styler_product_video_on_shop',
            'styler_tabs_title',
            'styler_tabs_content',
            'styler_product_header_type',
            'styler_product_header_bgcolor',
            'styler_product_header_menuitem_color',
            'styler_product_header_menuitem_hvrcolor',
            'styler_product_header_svgicon_color',
            'styler_product_header_counter_bgcolor',
            'styler_product_header_counter_color',
            'styler_product_sticky_header_bgcolor',
            'styler_product_sticky_header_menuitem_color',
            'styler_product_sticky_header_menuitem_hvrcolor',
            'styler_product_sticky_header_svgicon_color',
            'styler_product_sticky_header_counter_bgcolor',
            'styler_product_sticky_header_counter_color'
        );
        foreach ( $options as $option ) {
            if ( isset( $_POST[$option] ) ) {
                update_post_meta( $_post_id, $option, $_POST[$option] );
            } else {
                delete_post_meta( $_post_id, $option );
            }
        }
    }
}


/**
* Remove Reviews tab from tabs
*/
if ( ! function_exists( 'styler_wc_remove_product_tabs' ) ) {
    add_filter( 'woocommerce_product_tabs', 'styler_wc_remove_product_tabs', 98 );
    function styler_wc_remove_product_tabs( $tabs )
    {
        $tabs_type = apply_filters( 'styler_product_tabs_type', styler_settings( 'product_tabs_type', 'tabs' ) );
        if ( 'accordion' == $tabs_type ) {
            unset($tabs['reviews']);
        }

        $tabs['description']['callback'] = 'styler_wc_custom_description_tab_content'; // Custom description callback

        return $tabs;
    }
}


/**
 * Customize product data tabs
 */
if ( ! function_exists( 'styler_wc_custom_description_tab_content' ) ) {
    function styler_wc_custom_description_tab_content()
    {
        $desc_tab_title = '' != styler_settings( 'product_description_tab_title', '' ) ? styler_settings( 'product_description_tab_title', '' ) : esc_html__( 'Product Details', 'styler' );
        ?>
        <div class="product-desc-content">
            <?php if ( '0' != styler_settings( 'product_description_tab_title_visibility', '1' ) ) { ?>
                <h4 class="title"><?php echo apply_filters( 'styler_description_tab_title', $desc_tab_title ); ?></h4>
            <?php } ?>
            <?php the_content(); ?>
        </div>
        <?php
    }
}


/**
 * Move Reviews tab after product related
 */
if ( ! function_exists( 'styler_wc_move_product_reviews' ) ) {
    function styler_wc_move_product_reviews()
    {
        comments_template();
    }
}


/**
 * woocommerce_layered_nav_term_html WIDGET
 */
if ( !function_exists( 'styler_add_span_wc_layered_nav_term_html' ) ) {
    function styler_add_span_wc_layered_nav_term_html( $links )
    {
        $links = str_replace( '</a> (', '</a> <span class="widget-list-span">', $links );
        $links = str_replace( '</a> <span class="count">(', '</a> <span class="widget-list-span">', $links );
        $links = str_replace( ')', '</span>', $links );

        return $links;
    }
    add_filter( 'woocommerce_layered_nav_term_html', 'styler_add_span_wc_layered_nav_term_html' );
}


/**
* Add to cart handler.
*/
if ( !function_exists( 'styler_ajax_add_to_cart_handler' ) ) {

    function styler_ajax_add_to_cart_handler()
    {
        WC_Form_Handler::add_to_cart_action();
        WC_AJAX::get_refreshed_fragments();
    }
    add_action( 'wc_ajax_styler_ajax_add_to_cart', 'styler_ajax_add_to_cart_handler' );
    add_action( 'wc_ajax_nopriv_styler_ajax_add_to_cart', 'styler_ajax_add_to_cart_handler' );

    // Remove WC Core add to cart handler to prevent double-add
    remove_action( 'wp_loaded', array( 'WC_Form_Handler', 'add_to_cart_action' ), 20 );

    /**
    * Add fragments for notices.
    */
    function styler_ajax_add_to_cart_add_fragments( $fragments )
    {
        $all_notices  = WC()->session->get( 'wc_notices', array() );
        $notice_types = apply_filters( 'woocommerce_notice_types', array( 'error', 'success', 'notice' ) );

        ob_start();
        foreach ( $notice_types as $notice_type ) {
            if ( wc_notice_count( $notice_type ) > 0 ) {
                wc_get_template( "notices/{$notice_type}.php", array(
                    'notices' => array_filter( $all_notices[ $notice_type ] ),
                ) );
            }
        }
        $fragments['notices_html'] = ob_get_clean();

        wc_clear_notices();

        return $fragments;
    }
    add_filter( 'woocommerce_add_to_cart_fragments', 'styler_ajax_add_to_cart_add_fragments' );
}


/**
* ajax quick shop handler.
*/
if ( !function_exists( 'styler_ajax_quick_shop' ) ) {

    add_action( 'wp_ajax_styler_ajax_quick_shop', 'styler_ajax_quick_shop' );
    add_action( 'wp_ajax_nopriv_styler_ajax_quick_shop', 'styler_ajax_quick_shop' );

    function styler_ajax_quick_shop()
    {
        global $post, $product;
        $product_id = absint( $_GET['product_id'] );
        $product    = wc_get_product( $product_id );

        if ( !$product ) {
            return;
        }

        $post = get_post( $product_id );
        setup_postdata( $post );
        ?>
        <div id="product-<?php echo esc_attr( $product_id ); ?>" <?php wc_product_class( 'styler-quickshop-wrapper single-content zoom-anim-dialog', $product ); ?>>

            <?php if ( styler_settings('header_cart_before_buttons', '' ) ) { ?>
                <div class="minicart-extra-text">
                    <?php echo styler_settings('header_cart_before_buttons', '' ); ?>
                </div>
            <?php } ?>

            <div class="styler-quickshop-form-wrapper">
                <h4 class="styler-product-title"><a class="product-link" href="<?php echo esc_url( get_permalink( $product_id ) ) ?>"><?php the_title();?></a></h4>
                <?php woocommerce_template_single_add_to_cart( $product ); ?>
                <div class="styler-quickshop-notices-wrapper"></div>
            </div>

            <div class="styler-quickshop-buttons-wrapper">
                <div class="styler-flex">
                    <div class="styler-btn-medium styler-btn styler-bg-black open-cart-panel"><?php echo esc_html_e( 'View Cart', 'styler' ); ?></div>
                    <div class="styler-btn-medium styler-btn styler-bg-black open-checkout-panel"><?php echo esc_html_e( 'Checkout', 'styler' ); ?></div>
                </div>
            </div>

        </div>

        <?php
        wp_reset_postdata();
        die();
    }
}

/**
* ajax quick shop handler.
*/
if ( ! function_exists( 'styler_quick_shop_ajax_add_to_cart' ) ) {

    add_action( 'wp_ajax_styler_quick_shop_ajax_add_to_cart', 'styler_quick_shop_ajax_add_to_cart' );
    add_action( 'wp_ajax_nopriv_styler_quick_shop_ajax_add_to_cart', 'styler_quick_shop_ajax_add_to_cart' );

    function styler_quick_shop_ajax_add_to_cart() {
        WC_Form_Handler::add_to_cart_action();
        WC_AJAX::get_refreshed_fragments();
    }
}


/**
* quantity callback
*/
if ( ! function_exists( 'styler_quantity_button_callback' ) ) {
    add_action( 'wp_ajax_nopriv_styler_quantity_button', 'styler_quantity_button_callback' );
    add_action( 'wp_ajax_styler_quantity_button', 'styler_quantity_button_callback' );
    function styler_quantity_button_callback() {

        if ( isset( $_POST['id'] ) ) {
            $id       = intval( $_POST['id'] );
            $quantity = intval( $_POST['quantity'] );
            $product  = isset( $_POST['id'] ) ? wc_get_product( absint( $_POST['id'] ) ) : false;

            $specific_ids = array( $id );
            $new_qty      = $quantity; // New quantity

            foreach( WC()->cart->get_cart() as $cart_item_key => $cart_item ) {
                $product_id = $cart_item['data']->get_id();
                // Check for specific product IDs and change quantity
                if ( in_array( $product_id, $specific_ids ) && $cart_item['quantity'] != $new_qty ){
                    WC()->cart->set_quantity( $cart_item_key, $new_qty ); // Change quantity
                }
            }
            wp_die();
        }
    }
}



/**
* Add category banner if shortcode exists
*/
if ( !function_exists( 'styler_print_category_banner' ) ) {
    add_action( 'styler_shop_before_loop', 'styler_print_category_banner', 10 );
    function styler_print_category_banner()
    {
        $banner = get_term_meta( get_queried_object_id(), 'styler_wc_cat_banner', true );
        $layouts = isset( $_GET['shop_layouts'] ) && ( 'left-sidebar' == $_GET['shop_layouts'] || 'right-sidebar' == $_GET['shop_layouts'] ) ? true : false;

        if ( $banner && ( is_product_category() || is_product_tag() ) ) {

            printf( '<div class="shop-cat-banner styler-before-loop">%s</div>', do_shortcode( $banner ) );

        } else {

            if ( 'left-sidebar' == styler_settings('shop_layout') || 'right-sidebar' == styler_settings('shop_layout') || $layouts ) {

                echo styler_print_elementor_templates( 'shop_before_loop_templates', 'shop-cat-banner-template-wrapper', true );
            }
        }
    }
}


add_action('product_cat_add_form_fields', 'styler_wc_taxonomy_add_new_meta_field', 15, 1);
//Product Cat Create page
function styler_wc_taxonomy_add_new_meta_field() {
    woocommerce_wp_textarea_input(
        array(
            'id' => 'styler_wc_cat_banner',
            'label' => esc_html__( 'Styler Category Banner ', 'styler' ),
            'description' => esc_html__( 'If you want to show a different banner on the archive category page for this category, use this field.Iframe,shortcode,HTML content allowed.', 'styler' ),
            'rows' => 4
        )
    );
    ?>
	<div class="form-field styler_term-hero-bgimage-wrap">
		<label><?php esc_html_e( 'Styler Shop Category Page Hero Background Image', 'styler' ); ?></label>
		<div id="styler_product_cat_hero_bgimage" style="float: left; margin-right: 10px;"><img src="<?php echo esc_url( wc_placeholder_img_src() ); ?>" width="60px" height="60px" /></div>
		<div style="line-height: 60px;">
			<input type="hidden" id="styler_product_cat_hero_bgimage_id" name="styler_product_cat_hero_bgimage_id" />
			<button type="button" class="styler_upload_image_button button"><?php esc_html_e( 'Upload/Add image', 'styler' ); ?></button>
			<button type="button" class="styler_remove_image_button button"><?php esc_html_e( 'Remove image', 'styler' ); ?></button>
		</div>
		<div class="clear"></div>
		<span class="description"><?php esc_html_e( 'If you want to show a different background image on the shop archive category page for this category, upload your image from here.', 'styler'); ?></span>
		<script type="text/javascript">

			// Only show the "remove image" button when needed
			if ( ! jQuery( '#styler_product_cat_hero_bgimage_id' ).val() ) {
				jQuery( '.styler_term-hero-bgimage-wrap .styler_remove_image_button' ).hide();
			}

			// Uploading files
			var styler_cat_hero_file_frame;

			jQuery( document ).on( 'click', '.styler_term-hero-bgimage-wrap .styler_upload_image_button', function( event ) {

				event.preventDefault();

				// If the media frame already exists, reopen it.
				if ( styler_cat_hero_file_frame ) {
					styler_cat_hero_file_frame.open();
					return;
				}

				// Create the media frame.
				styler_cat_hero_file_frame = wp.media.frames.downloadable_file = wp.media({
					title: '<?php esc_html_e( 'Choose an image', 'styler' ); ?>',
					button: {
						text: '<?php esc_html_e( 'Use image', 'styler' ); ?>'
					},
					multiple: false
				});

				// When an image is selected, run a callback.
				styler_cat_hero_file_frame.on( 'select', function() {
					var attachment           = styler_cat_hero_file_frame.state().get( 'selection' ).first().toJSON();
					var attachment_thumbnail = attachment.sizes.thumbnail || attachment.sizes.full;

					jQuery( '#styler_product_cat_hero_bgimage_id' ).val( attachment.id );
					jQuery( '#styler_product_cat_hero_bgimage' ).find( 'img' ).attr( 'src', attachment_thumbnail.url );
					jQuery( '.styler_term-hero-bgimage-wrap .styler_remove_image_button' ).show();
				});

				// Finally, open the modal.
				styler_cat_hero_file_frame.open();
			});

			jQuery( document ).on( 'click', '.styler_term-hero-bgimage-wrap .styler_remove_image_button', function() {
				jQuery( '#styler_product_cat_hero_bgimage' ).find( 'img' ).attr( 'src', '<?php echo esc_js( wc_placeholder_img_src() ); ?>' );
				jQuery( '#styler_product_cat_hero_bgimage_id' ).val( '' );
				jQuery( '.styler_term-hero-bgimage-wrap .styler_remove_image_button' ).hide();
				return false;
			});

			jQuery( document ).ajaxComplete( function( event, request, options ) {
				if ( request && 4 === request.readyState && 200 === request.status
					&& options.data && 0 <= options.data.indexOf( 'action=add-tag' ) ) {

					var res = wpAjax.parseAjaxResponse( request.responseXML, 'ajax-response' );
					if ( ! res || res.errors ) {
						return;
					}
					// Clear Thumbnail fields on submit
					jQuery( '#styler_product_cat_hero_bgimage' ).find( 'img' ).attr( 'src', '<?php echo esc_js( wc_placeholder_img_src() ); ?>' );
					jQuery( '#styler_product_cat_hero_bgimage_id' ).val( '' );
					jQuery( '.styler_term-hero-bgimage-wrap .styler_remove_image_button' ).hide();
					return;
				}
			} );

		</script>
	</div>
	<div class="clear"></div>
	<?php
}

add_action('product_cat_edit_form_fields', 'styler_wc_taxonomy_edit_meta_field', 15, 1);
//Product Cat Edit page
function styler_wc_taxonomy_edit_meta_field($term) {

    //getting term ID
    $term_id = $term->term_id;

    // retrieve the existing value(s) for this meta field.
    $styler_wc_cat_banner = get_term_meta($term_id, 'styler_wc_cat_banner', true);
	$thumbnail_id = absint( get_term_meta( $term_id, 'styler_product_cat_hero_bgimage_id', true ) );

	if ( $thumbnail_id ) {
		$image = wp_get_attachment_thumb_url( $thumbnail_id );
	} else {
		$image = wc_placeholder_img_src();
	}
    ?>
    <tr class="form-field term-styler-banner-wrap">
        <th scope="row" valign="top"><label for="styler_wc_cat_banner"><?php esc_html_e('Styler Banner', 'styler'); ?></label></th>
        <td>
            <textarea name="styler_wc_cat_banner" id="styler_wc_cat_banner" rows="5" cols="50" class="large-text"><?php echo esc_html($styler_wc_cat_banner) ? $styler_wc_cat_banner : ''; ?></textarea>
            <p class="description"><?php esc_html_e('If you want to show a different banner on the archive category page for this category, use this field.Iframe,shortcode,HTML content allowed.', 'styler'); ?></p>
        </td>
    </tr>

	<tr class="form-field styler_term-hero_bgimage-wrap">
		<th scope="row" valign="top"><label><?php esc_html_e( 'Styler Shop Category Page Hero Background Image', 'styler' ); ?></label></th>
		<td>
			<div id="styler_product_cat_hero_bgimage" style="float: left; margin-right: 10px;"><img src="<?php echo esc_url( $image ); ?>" width="60px" height="60px" /></div>
			<div style="line-height: 60px;">
				<input type="hidden" id="styler_product_cat_hero_bgimage_id" name="styler_product_cat_hero_bgimage_id" value="<?php echo esc_attr( $thumbnail_id ); ?>" />
				<button type="button" class="styler_upload_image_button button"><?php esc_html_e( 'Upload/Add image', 'styler' ); ?></button>
				<button type="button" class="styler_remove_image_button button"><?php esc_html_e( 'Remove image', 'styler' ); ?></button>
			</div>
			<div class="clear"></div>
			<span class="description"><?php esc_html_e( 'If you want to show a different background image on the shop archive category page for this category, upload your image from here.', 'styler'); ?></span>
			<script type="text/javascript">

				// Only show the "remove image" button when needed
				if ( '0' === jQuery( '#styler_product_cat_hero_bgimage_id' ).val() ) {
					jQuery( '.styler_term-hero_bgimage-wrap .styler_remove_image_button' ).hide();
				}

				// Uploading files
				var styler_cat_hero_file_frame;

				jQuery( document ).on( 'click', '.styler_term-hero_bgimage-wrap .styler_upload_image_button', function( event ) {

					event.preventDefault();

					// If the media frame already exists, reopen it.
					if ( styler_cat_hero_file_frame ) {
						styler_cat_hero_file_frame.open();
						return;
					}

					// Create the media frame.
					styler_cat_hero_file_frame = wp.media.frames.downloadable_file = wp.media({
						title: '<?php esc_html_e( 'Choose an image', 'styler' ); ?>',
						button: {
							text: '<?php esc_html_e( 'Use image', 'styler' ); ?>'
						},
						multiple: false
					});

					// When an image is selected, run a callback.
					styler_cat_hero_file_frame.on( 'select', function() {
						var attachment           = styler_cat_hero_file_frame.state().get( 'selection' ).first().toJSON();
						var attachment_thumbnail = attachment.sizes.thumbnail || attachment.sizes.full;

						jQuery( '#styler_product_cat_hero_bgimage_id' ).val( attachment.id );
						jQuery( '#styler_product_cat_hero_bgimage' ).find( 'img' ).attr( 'src', attachment_thumbnail.url );
						jQuery( '.styler_term-hero_bgimage-wrap .styler_remove_image_button' ).show();
					});

					// Finally, open the modal.
					styler_cat_hero_file_frame.open();
				});

				jQuery( document ).on( 'click', '.styler_term-hero_bgimage-wrap .styler_remove_image_button', function() {
					jQuery( '#styler_product_cat_hero_bgimage' ).find( 'img' ).attr( 'src', '<?php echo esc_js( wc_placeholder_img_src() ); ?>' );
					jQuery( '#styler_product_cat_hero_bgimage_id' ).val( '' );
					jQuery( '.styler_term-hero_bgimage-wrap .styler_remove_image_button' ).hide();
					return false;
				});

			</script>
			<div class="clear"></div>
		</td>
	</tr>
    <?php
}

add_action('edited_product_cat', 'styler_wc_save_taxonomy_custom_meta', 15, 1);
add_action('create_product_cat', 'styler_wc_save_taxonomy_custom_meta', 15, 1);
// Save extra taxonomy fields callback function.
function styler_wc_save_taxonomy_custom_meta( $term_id ) {

    $styler_wc_cat_banner = filter_input(INPUT_POST, 'styler_wc_cat_banner');
    $styler_product_cat_hero_bgimage_id = filter_input(INPUT_POST, 'styler_product_cat_hero_bgimage_id');
    update_term_meta($term_id, 'styler_wc_cat_banner', $styler_wc_cat_banner);
    update_term_meta($term_id, 'styler_product_cat_hero_bgimage_id', $styler_product_cat_hero_bgimage_id);

}

//Displaying Additional Columns
add_filter( 'manage_edit-product_cat_columns', 'styler_wc_customFieldsListTitle' ); //Register Function

function styler_wc_customFieldsListTitle( $columns ) {
    $columns['styler_cat_banner'] = esc_html__( 'Banner', 'styler' );
    return $columns;
}

add_action( 'manage_product_cat_custom_column', 'styler_wc_customFieldsListDisplay' , 10, 3); //Populating the Columns
function styler_wc_customFieldsListDisplay( $columns, $column, $id ) {
    if ( 'styler_cat_banner' == $column ) {
        $columns = get_term_meta($id, 'styler_wc_cat_banner', true);
        $columns = $columns ? '<span class="wc-banner"></span>' : '';
    }
    return $columns;
}

if ( ! function_exists( 'styler_wc_per_page_select' ) ) {
    function styler_wc_per_page_select()
    {
        if ( ! wc_get_loop_prop( 'is_paginated' ) ) {
            return;
        }

        $numbers = styler_settings( 'per_page_select_options' );
        $per_page_opt = ( ! empty( $numbers ) ) ? explode( ',', $numbers ) : array( 9, 12, 24, 36 );

        ?>
        <div class="styler-filter-per-page styler-shop-filter-item">
            <ul class="styler-filter-action">
                <li class="styler-per-page-title"><?php esc_html_e( 'Show', 'styler' ); ?></li>
                <?php foreach ( $per_page_opt as $key => $value ) {

                    $link = add_query_arg( 'per_page', $value );

                    $classes = isset( $_GET['per_page'] ) && $_GET['per_page'] === $value ? ' active' : '';
                    $val = $value == -1 ? esc_html__( 'All', 'styler' ) : $value;
                    ?>
                    <li class="styler-per-page-item<?php echo esc_attr( $classes ); ?>">
                        <a rel="nofollow noopener" href="<?php echo esc_url( $link ); ?>"><?php esc_html( printf( '%s', $val ) ); ?></a>
                    </li>
                <?php } ?>
            </ul>
        </div>
        <?php
    }
}

if ( ! function_exists( 'styler_wc_column_select' ) ) {
    function styler_wc_column_select()
    {
        if ( ! wc_get_loop_prop( 'is_paginated' ) ) {
            return;
        }
        if ( !styler_get_shop_column() && 'list' == styler_settings( 'shop_product_type', '1' ) ) {
            $col = 1;
        } elseif ( intval(styler_get_shop_column()) > 1 ) {
            $col = intval(styler_get_shop_column());
        } else {
            $col = isset( $_GET['column'] ) && $_GET['column'] ? intval( $_GET['column'] ) : intval( styler_settings( 'shop_colxl' ) );
        }

        $active = $hide = '';
        $cols = array( 1, 2, 3, 4, 5 );

        ?>
        <div class="styler-filter-column-select styler-shop-filter-item">
            <ul class="styler-filter-action styler-filter-columns styler-mini-icon">
                <?php
                foreach ( $cols as $key => $value ) {

                    if ( ( $col < 6 ) && ( $col === $value ) ) {
                        $active = ' active';
                    }
                    if ( $value === 3 ) {
                        $hide = ' d-none d-sm-flex';
                    }
                    if ( $value === 4 ) {
                        $hide = ' d-none d-lg-flex';
                    }
                    if ( $value === 5 ) {
                        $hide = ' d-none d-xl-flex';
                    }
                    ?>
                    <li class="<?php echo esc_attr( 'val-'.$value.$active.$hide ); ?>">
                        <a href="<?php echo esc_url( add_query_arg( 'column', $value ) ); ?>"><?php echo styler_svg_lists('column-'.$value, 'styler-svg-icon');?></a>
                    </li>
                    <?php
                    $active = '';
                }
                ?>
            </ul>
        </div>
        <?php
    }
}


if ( !function_exists( 'styler_wc_category_search_form' ) ) {
    function styler_wc_category_search_form() {

        $terms = get_terms( array( 'taxonomy' => 'product_cat', 'hide_empty' => false, 'parent' => 0 ) );
        ?>
        <div class="header-search-wrap">
            <form role="search" method="get" action="<?php echo esc_url( home_url( '/'  ) ) ?>">
                <input  type="text" name="s"
                value="<?php get_search_query() ?>"
                placeholder="<?php echo esc_attr_e( 'Search for your item\'s type.....', 'styler' ) ?>">
                <input type="hidden" name="post_type" value="product" />
                <select class="custom-select" name="product_cat">
                    <option value="" selected><?php echo esc_html_e( 'All Category', 'styler' ) ?></option>
                    <?php
                    foreach ( $terms as $term ) {
                        if ( $term->count >= 1 ) {
                            ?>
                            <option value="<?php echo esc_attr( $term->slug ) ?>"><?php echo esc_html( $term->name ) ?></option>
                            <?php
                        }
                    }
                    ?>
                </select>
                <button class="btn-submit" type="submit"><?php echo styler_svg_lists( 'search' ); ?></button>
                <?php do_action( 'wpml_add_language_form_field' ); ?>
            </form>
        </div>
        <?php
    }
}

if ( !function_exists( 'styler_wc_format_sale_price' ) ) {
    /**
     * Format a sale price for display.
     *
     * @since  3.0.0
     * @param  string $regular_price Regular price.
     * @param  string $sale_price    Sale price.
     * @return string
     */
    add_filter( 'woocommerce_format_sale_price', 'styler_wc_format_sale_price', 10, 3 );
    function styler_wc_format_sale_price( $price, $regular_price, $sale_price ) {
        $price = '<span class="styler-primary-color del"><span>' . ( is_numeric( $regular_price ) ? wc_price( $regular_price ) : $regular_price ) . '</span> – </span> <span class="styler-primary-color ins">' . ( is_numeric( $sale_price ) ? wc_price( $sale_price ) : $sale_price ) . '</span>';
        return $price;
    }
}


if ( !function_exists( 'styler_shop_main_loop' ) ) {
    add_action('styler_shop_main_loop','styler_shop_main_loop', 10 );
    function styler_shop_main_loop()
    {
        if ( !styler_is_pjax() ) {
        echo '<div class="styler-products-wrapper">';
        }
            do_action( 'styler_shop_choosen_filters' );

            echo '<div class="shop-data-filters" data-shop-filters=\''.styler_wc_filters_for_ajax().'\'></div>';

            woocommerce_product_loop_start();

            if ( woocommerce_product_loop() ) {

                if ( wc_get_loop_prop( 'total' ) ) {
                    while ( have_posts() ) {
                        the_post();

                        /**
                        * Hook: woocommerce_shop_loop.
                        */
                        do_action( 'woocommerce_shop_loop' );

                        wc_get_template_part( 'content', 'product' );
                    }
                }
            }

            woocommerce_product_loop_end();

            if ( woocommerce_product_loop() ) {
                /**
                * Hook: styler_shop_pagination.
                *
                * @hooked styler_shop_pagination
                */
                do_action( 'styler_shop_pagination' );
            } else {
                /**
                * Hook: woocommerce_no_products_found.
                *
                * @hooked wc_no_products_found - 10
                */
                do_action( 'woocommerce_no_products_found' );
            }
        if ( !styler_is_pjax() ) {
        echo '</div>';
        }
    }
}

if ( !function_exists( 'styler_shop_after_ajax' ) ) {
    add_action('styler_shop_after_ajax','styler_shop_after_ajax', 10 );
    function styler_shop_after_ajax()
    {
        ?>
        <div class="styler-after-ajax-content d-none">

            <?php do_action( 'styler_before_shop_content' ); ?>

            <div class="perpage-filter-ajax-content">
                <?php styler_wc_per_page_select(); ?>
            </div>

            <div class="column-select-ajax-content">
                <?php styler_wc_column_select(); ?>
            </div>

            <?php woocommerce_result_count(); ?>

            <div id="nt-sidebar" class="nt-sidebar-ajax-content">
                <div class="styler-panel-close-button styler-close-sidebar"></div>
                <div class="nt-sidebar-inner-wrapper">
                    <?php do_action( 'styler_choosen_filters' );?>
                    <div class="nt-sidebar-inner">
                        <?php dynamic_sidebar( 'shop-page-sidebar' ); ?>
                    </div>
                </div>
            </div>

        </div>
        <?php
    }
}

if ( !function_exists( 'styler_shop_sidebar' ) ) {
    add_action('styler_shop_before_loop','styler_shop_choosen_filters_row', 20 );
    function styler_shop_choosen_filters_row()
    {
        $layout = apply_filters('styler_shop_layout', styler_settings( 'shop_layout', 'left-sidebar' ) );
        if ( '0' == styler_settings( 'choosen_filters_before_loop', '1' ) ) {
            return;
        }
        if ( ('left-sidebar' == $layout || 'right-sidebar' == $layout ) && is_active_sidebar( 'shop-page-sidebar' ) ) {
            ?>
            <div class="styler-choosen-filters-row row styler-hidden-on-mobile">
                <div class="col-12">
                    <?php do_action( 'styler_choosen_filters' );?>
                </div>
            </div>
            <?php
        }
    }
}

if ( !function_exists( 'styler_shop_sidebar' ) ) {
    add_action('styler_shop_sidebar','styler_shop_sidebar', 10 );
    function styler_shop_sidebar()
    {
        $layout = apply_filters('styler_shop_layout', styler_settings( 'shop_layout', 'left-sidebar' ) );
        if ( 'top-sidebar' == $layout || 'fixed-sidebar' == $layout || 'no-sidebar' == $layout || !is_active_sidebar( 'shop-page-sidebar' ) ) {
            return;
        }
        ?>
        <div id="nt-sidebar" class="nt-sidebar default-sidebar col-lg-3">
            <div class="styler-panel-close-button styler-close-sidebar"></div>
            <div class="nt-sidebar-inner-wrapper">
                <?php do_action( 'styler_choosen_filters' );?>
                <div class="nt-sidebar-inner">
                    <?php dynamic_sidebar( 'shop-page-sidebar' ); ?>
                </div>
            </div>
        </div>
        <?php
    }
}

if ( !function_exists( 'styler_shop_top_hidden_sidebar' ) ) {
    add_action('styler_shop_before_loop','styler_shop_top_hidden_sidebar', 20 );
    function styler_shop_top_hidden_sidebar()
    {
        $layout = apply_filters('styler_shop_layout', styler_settings( 'shop_layout', 'left-sidebar' ) );
        if ( 'top-sidebar' != $layout || 'no-sidebar' == $layout || !is_active_sidebar( 'shop-page-sidebar' ) ) {
            return;
        }
        $column = styler_settings( 'shop_hidden_sidebar_column', '3' );
        ?>
        <div id="nt-sidebar" class="nt-sidebar styler-shop-hidden-top-sidebar d-none" data-column="row row-cols-<?php echo esc_attr( $column ); ?>">
            <div class="styler-panel-close-button styler-close-sidebar"></div>
            <div class="nt-sidebar-inner-wrapper">
                <?php do_action( 'styler_choosen_filters' );?>
                <div class="nt-sidebar-inner row row-cols-<?php echo esc_attr( $column ); ?>">
                    <?php dynamic_sidebar( 'shop-page-sidebar' ); ?>
                </div>
            </div>
        </div>
        <?php
    }
}

if ( !function_exists( 'styler_shop_sidebar_fixed' ) ) {
    add_action('styler_after_shop_page','styler_shop_sidebar_fixed', 20 );
    function styler_shop_sidebar_fixed()
    {
        $layout = apply_filters('styler_shop_layout', styler_settings( 'shop_layout', 'left-sidebar' ) );
        if ( 'fixed-sidebar' != $layout || 'no-sidebar' == $layout || !is_active_sidebar( 'shop-page-sidebar' ) ) {
            return;
        }
        ?>
        <div id="nt-sidebar" class="nt-sidebar styler-shop-fixed-sidebar">
            <div class="styler-panel-close-button styler-close-sidebar"></div>
            <div class="nt-sidebar-inner-wrapper">
                <?php do_action( 'styler_choosen_filters' );?>
                <div class="nt-sidebar-inner">
                    <?php dynamic_sidebar( 'shop-page-sidebar' ); ?>
                </div>
            </div>
        </div>
        <?php
    }
}


if ( !function_exists( 'styler_shop_loop_notices' ) ) {
    add_action('styler_before_wp_footer','styler_shop_loop_notices', 15 );
    function styler_shop_loop_notices()
    {
        if ( '0' == styler_settings( 'shop_cart_popup_notices_visibility', '1' ) ) {
            return;
        }
        ?>
        <div class="styler-shop-popup-notices">
            <div class="styler-panel-close-button"></div>
            <div class="styler-shop-popup-notices-wrapper">
                <?php woocommerce_output_all_notices(); ?>
            </div>
        </div>
        <?php
    }
}



if ( !function_exists( 'shop_loop_filters_layouts' ) ) {
    add_action('styler_shop_before_loop','shop_loop_filters_layouts', 15 );
    function shop_loop_filters_layouts()
    {
        $defaults = [
            'left'=> [
                'result-count' => ''
            ],
            'right'=> [
                'sidebar-filter' => '',
                'per-page' => '',
                'ordering' => '',
                'column-select' => ''
            ]
        ];
        $layouts = apply_filters( 'styler_get_filters_layouts', styler_settings( 'shop_loop_filters_layouts', $defaults ) );
        $page_layout = apply_filters('styler_shop_layout', styler_settings( 'shop_layout', 'left-sidebar' ) );
        if ( $layouts ) {

            unset( $layouts['left']['placebo'] );
            unset( $layouts['right']['placebo'] );

            echo '<div class="styler-inline-two-block styler-before-loop styler-shop-filter-top-area">';

                if ( !empty( $layouts['left'] ) ) {
                    echo '<div class="styler-block-left">';
                        foreach ( $layouts['left'] as $key => $value ) {
                            switch ( $key ) {
                                case 'sidebar-filter':
                                if ( $page_layout == 'top-sidebar' && is_active_sidebar( 'shop-page-sidebar' ) ) {
                                    echo '<div class="styler-toggle-hidden-sidebar"><span>'.esc_html__( 'Filter', 'styler' ).'</span> '.styler_svg_lists( 'filter', 'styler-svg-icon' ).'<div class="styler-filter-close"></div></div>';
                                }
                                if ( $page_layout != 'no-sidebar' && is_active_sidebar( 'shop-page-sidebar' ) ) {
                                    echo '<div class="styler-open-fixed-sidebar"><span>'.esc_html__( 'Filter', 'styler' ).'</span> '.styler_svg_lists( 'filter', 'styler-svg-icon' ).'</div>';
                                }
                                break;

                                case 'search':
                                echo '<div class="top-action-btn" data-name="search-popup">'.styler_svg_lists( 'search', 'styler-svg-icon' ).'</div>';
                                break;

                                case 'result-count':
                                echo '<div class="styler-woo-result-count">';woocommerce_result_count();echo '</div>';
                                break;

                                case 'breadcrumbs':
                                echo '<div class="styler-woo-breadcrumb">'.woocommerce_breadcrumb().'</div>';
                                break;

                                case 'per-page':
                                echo '<div class="styler-shop-filter-area styler-filter-per-page-area">';
                                    styler_wc_per_page_select();
                                echo '</div>';
                                break;

                                case 'column-select':
                                echo '<div class="styler-shop-filter-area styler-filter-column-select-area">';
                                    styler_wc_column_select();
                                echo '</div>';
                                break;

                                case 'ordering':
                                if ( woocommerce_product_loop() ) {
                                    echo '<div class="styler-shop-filter-area styler-filter-ordering-area">';
                                        woocommerce_catalog_ordering();
                                    echo '</div>';
                                }
                                break;
                            }
                        }
                    echo '</div>';
                }

                if ( !empty( $layouts['right'] ) ) {
                    echo '<div class="styler-block-right">';
                        foreach ( $layouts['right'] as $key => $value ) {
                            switch ( $key ) {

                                case 'sidebar-filter':
                                if ( $page_layout == 'top-sidebar' && is_active_sidebar( 'shop-page-sidebar' ) ) {
                                    echo '<div class="styler-toggle-hidden-sidebar"><span>'.esc_html__( 'Filter', 'styler' ).'</span> '.styler_svg_lists( 'filter', 'styler-svg-icon' ).'<div class="styler-filter-close"></div></div>';
                                }
                                if ( $page_layout != 'no-sidebar' && is_active_sidebar( 'shop-page-sidebar' ) ) {
                                    echo '<div class="styler-open-fixed-sidebar"><span>'.esc_html__( 'Filter', 'styler' ).'</span> '.styler_svg_lists( 'filter', 'styler-svg-icon' ).'</div>';
                                }
                                break;

                                case 'search':
                                echo '<div class="top-action-btn" data-name="search-popup">'.styler_svg_lists( 'search', 'styler-svg-icon' ).'</div>';
                                break;

                                case 'result-count':
                                echo '<div class="styler-woo-result-count">';woocommerce_result_count();echo '</div>';
                                break;

                                case 'breadcrumbs':
                                echo '<div class="styler-woo-breadcrumb">'.woocommerce_breadcrumb().'</div>';
                                break;

                                case 'per-page':
                                echo '<div class="styler-shop-filter-area styler-filter-per-page-area">';
                                    styler_wc_per_page_select();
                                echo '</div>';
                                break;

                                case 'column-select':
                                echo '<div class="styler-shop-filter-area styler-filter-column-select-area">';
                                    styler_wc_column_select();
                                echo '</div>';
                                break;

                                case 'ordering':
                                if ( woocommerce_product_loop() ) {
                                    echo '<div class="styler-shop-filter-area styler-filter-ordering-area">';
                                        woocommerce_catalog_ordering();
                                    echo '</div>';
                                }
                                break;
                            }
                        }
                    echo '</div>';
                }
            echo '</div>';
        }
    }
}

if ( !function_exists( 'styler_loop_product_buttons_layouts' ) ) {
    function styler_loop_product_buttons_layouts()
    {
        $defaults = [
            'show'=> [
                'quickview'=>'',
                'compare'=>'',
                'wishlist'=>''
            ]
        ];
        $type    = apply_filters( 'styler_loop_product_type', styler_settings( 'shop_product_type', '3' ) );
        $layouts = 'custom' == $type ? styler_settings( 'shop_loop_product_buttons_layouts' ) : $defaults;
        $layouts = apply_filters( 'styler_loop_product_buttons_layouts', $layouts );
        echo styler_add_to_cart_button();
        if ( $layouts ) {
            unset( $layouts['show']['placebo'] );
            foreach ( $layouts['show'] as $key => $value ) {

                switch ( $key ) {

                    case 'quickview':
                    echo styler_quickview_button();
                    break;

                    case 'compare':
                    echo styler_compare_button();
                    break;

                    case 'wishlist':
                    echo styler_wishlist_button();
                    break;
                }
            }
        } else {

            if ( '1' == styler_get_shop_column() ) {
                echo styler_add_to_cart_button();
                echo styler_quickview_button();
                echo styler_compare_button();
                echo styler_wishlist_button();
            }
        }
    }
}


if ( !function_exists( 'styler_loop_product_prelayouts' ) ) {
    function styler_loop_product_prelayouts($types='')
    {
        $type = $types ? $types : apply_filters( 'styler_loop_product_type', styler_settings( 'shop_product_type', '3' ) );
        $type = '1' == styler_get_shop_column() ? 7 : $type;

        switch ( $type ) {
            case '1':
            $layouts = [
                'show'=> [
                    'thumb'=>'',
                    'price-rating'=>'',
                    'title-cart-hover'=>'',
                    'buttons-hover'=>'',
                    'sale-discount'=>'',
                    'stock'=>''
                ]
            ];
            break;
            case '2':
            $layouts = [
                'show'=> [
                    'thumb'=>'',
                    'title-cart-hover'=>'',
                    'price-buttons'=>'',
                    //'buttons-hover'=>'',
                    'sale-discount'=>'',
                    'stock'=>''
                ]
            ];
            break;
            case '3':
            $layouts = [
                'show'=> [
                    'thumb-overlay'=>'',
                    'title-cart-hover'=>'',
                    'price-rating'=>'',
                    'buttons-hover'=>'',
                    'sale-discount'=>'',
                    'stock'=>''
                ]
            ];
            break;
            case '4':
            $layouts = [
                'show'=> [
                    'thumb-overlay'=>'',
                    'title-buttons-hover'=>'',
                    'price-rating'=>'',
                    'sale-discount'=>'',
                    'stock'=>''
                ]
            ];
            break;
            case '5':
            $layouts = [
                'show'=> [
                    'gallery'=>'',
                    'title-cart-hover'=>'',
                    'price-buttons'=>'',
                    'sale-discount'=>'',
                    'stock'=>''
                ]
            ];
            break;
            case '6':
            $layouts = [
                'show'=> [
                    'thumb-overlay'=>'',
                    'price-rating'=>'',
                    'title-buttons-hover'=>'',
                    'sale-discount'=>'',
                    'stock'=>''
                ]
            ];
            break;
            case '7':
            $layouts = [
                'show'=> [
                    'thumb-overlay'=>'',
                    'buttons-hover'=>'',
                    'title'=>'',
                    'rating'=>'',
                    'desc'=>'',
                    //'swatches'=>'',
                    'price-cart'=>'',
                    'sale-discount'=>'',
                    'stock'=>''
                ]
            ];
            break;
        }
        return $layouts;
    }
}

if ( !function_exists( 'styler_loop_product_layout_manager' ) ) {
    function styler_loop_product_layout_manager($types='',$column='')
    {
        global $product;
        $type          = $types ? $types : styler_settings( 'shop_product_type', '3' );
        $type          = apply_filters( 'styler_loop_product_type', $type );
        $layouts       = $type != 'custom' ? styler_loop_product_prelayouts($types) : apply_filters( 'styler_shop_loop_product_layouts', styler_settings( 'shop_loop_product_layouts' ) );
        $list_type     = '1' == styler_get_shop_column() || '1' == $column ? ' row row-cols-1 row-cols-sm-1 row-cols-xl-2' : '';
        $list_type_col = '1' == styler_get_shop_column() || '1' == $column ? ' col' : '';
        $show_video    = get_post_meta( $product->get_id(), 'styler_product_video_on_shop', true );
        $show_video    = 'yes' ==$show_video ? ' has-iframe-video' : '';

        if ( $layouts ) {
            unset( $layouts['show']['placebo'] );
            if ( '1' == styler_get_shop_column() || '1' == $column ) {
                echo '<div class="styler-loop-item-list-wrapper">';
            }
            echo '<div class="woocommerce styler-product'.$list_type.'" data-id="'.$product->get_id().'">';

                foreach ( $layouts['show'] as $key => $value ) {

                    switch ( $key ) {

                        case 'thumb':
                        echo '<div class="styler-thumb-wrapper'.$list_type_col.$show_video.'">';
                            styler_loop_product_thumb($column);
                            if ( array_key_exists( 'stock', $layouts['show'] ) ) {
                                styler_loop_product_nostock();
                            }
                            if ( array_key_exists( 'sale-discount', $layouts['show'] ) ) {
                                echo '<div class="styler-product-labels">';
                                    styler_product_badge();
                                    styler_product_discount();
                                echo '</div>';
                            }
                            if ( array_key_exists( 'buttons-hover', $layouts['show'] ) ) {
                                echo '<div class="styler-loop-product-buttons-hover">';
                                    styler_loop_product_buttons_layouts();
                                echo '</div>';
                            }
                            if ( array_key_exists( 'swatches-hover', $layouts['show'] ) ) {
                                echo '<div class="styler-swatches-hover">'.do_shortcode( '[styler_swatches]' ).'</div>';
                            }
                            echo '<span class="loading-wrapper"><span class="ajax-loading"></span></span>';
                        echo '</div>';
                        if ( array_key_exists( 'buttons-hover', $layouts['show'] ) ) {
                            echo '<div class="styler-loop-product-buttons-mobile styler-mini-icon">';
                                styler_loop_product_buttons_layouts();
                            echo '</div>';
                        }
                        if ( '1' == styler_get_shop_column() || '1' == $column ) {
                            echo '<div class="styler-loop-item-content-wrapper'.$list_type_col.'">';
                        }
                        break;

                        case 'thumb-overlay':
                        echo '<div class="styler-thumb-wrapper'.$list_type_col.$show_video.'">';
                            styler_loop_product_thumb_overlay($column);
                            if ( array_key_exists( 'stock', $layouts['show'] ) ) {
                                styler_loop_product_nostock();
                            }
                            if ( array_key_exists( 'sale-discount', $layouts['show'] ) ) {
                                echo '<div class="styler-product-labels">';
                                    styler_product_badge();
                                    styler_product_discount();
                                echo '</div>';
                            }
                            if ( array_key_exists( 'buttons-hover', $layouts['show'] ) ) {
                                echo '<div class="styler-loop-product-buttons-hover">';
                                    styler_loop_product_buttons_layouts();
                                echo '</div>';
                            }
                            if ( array_key_exists( 'swatches-hover', $layouts['show'] ) ) {
                                echo '<div class="styler-swatches-hover">'.do_shortcode( '[styler_swatches]' ).'</div>';
                            }
                            echo '<span class="loading-wrapper"><span class="ajax-loading"></span></span>';
                        echo '</div>';
                        if ( array_key_exists( 'buttons-hover', $layouts['show'] ) || array_key_exists( 'title-buttons-hover', $layouts['show'] ) ) {
                            echo '<div class="styler-loop-product-buttons-mobile styler-mini-icon">';
                                styler_loop_product_buttons_layouts();
                            echo '</div>';
                        }
                        if ( '1' == styler_get_shop_column() || '1' == $column ) {
                            echo '<div class="styler-loop-item-content-wrapper'.$list_type_col.'">';
                        }
                        break;

                        case 'gallery':
                        $has_swatches = array_key_exists( 'swatches-hover', $layouts['show'] ) ? ' has-swatches' : '';
                        echo '<div class="styler-thumb-wrapper styler-thumb-slider'.$has_swatches.$list_type_col.$show_video.'">';
                            styler_loop_product_gallery();
                            if ( array_key_exists( 'stock', $layouts['show'] ) ) {
                                styler_loop_product_nostock();
                            }
                            if ( array_key_exists( 'sale-discount', $layouts['show'] ) ) {
                                echo '<div class="styler-product-labels">';
                                    styler_product_badge();
                                    styler_product_discount();
                                echo '</div>';
                            }
                            if ( array_key_exists( 'buttons-hover', $layouts['show'] ) ) {
                                echo '<div class="styler-loop-product-buttons-hover">';
                                    styler_loop_product_buttons_layouts();
                                echo '</div>';
                            }
                            if ( array_key_exists( 'swatches-hover', $layouts['show'] ) ) {
                                echo '<div class="styler-swatches-hover">'.do_shortcode( '[styler_swatches]' ).'</div>';
                            }
                            echo '<span class="loading-wrapper"><span class="ajax-loading"></span></span>';
                        echo '</div>';
                        if ( array_key_exists( 'buttons-hover', $layouts['show'] ) || array_key_exists( 'title-buttons-hover', $layouts['show'] ) ) {
                            echo '<div class="styler-loop-product-buttons-mobile styler-mini-icon">';
                                styler_loop_product_buttons_layouts();
                            echo '</div>';
                        }
                        if ( '1' == styler_get_shop_column() || '1' == $column ) {
                            echo '<div class="styler-loop-item-content-wrapper'.$list_type_col.'">';
                        }
                        break;

                        case 'title':
                        echo '<h6 class="styler-product-name"><a href="'.esc_url( get_permalink() ).'">'.get_the_title().'</a></h6>';
                        break;

                        case 'title-stock':
                        echo '<div class="styler-title-stock styler-title-block styler-inline-two-block">';
                            echo '<div class="styler-block-left">';
                                echo '<h6 class="styler-product-name"><a href="'.esc_url( get_permalink() ).'">'.get_the_title().'</a></h6>';
                            echo '</div>';
                            echo '<div class="styler-block-right">';
                                styler_loop_product_nostock();
                            echo '</div>';
                        echo '</div>';
                        break;

                        case 'title-price':
                        echo '<div class="styler-title-price styler-title-block styler-inline-two-block">';
                            echo '<div class="styler-block-left">';
                                echo '<h6 class="styler-product-name"><a href="'.esc_url( get_permalink() ).'">'.get_the_title().'</a></h6>';
                            echo '</div>';
                            echo '<div class="styler-block-right">';
                                woocommerce_template_loop_price();
                            echo '</div>';
                        echo '</div>';
                        break;

                        case 'title-rating':
                        echo '<div class="styler-title-rating styler-title-block styler-inline-two-block">';
                            echo '<div class="styler-block-left">';
                                echo '<h6 class="styler-product-name"><a href="'.esc_url( get_permalink() ).'">'.get_the_title().'</a></h6>';
                            echo '</div>';
                            if ( $product->get_average_rating() ) {
                                echo '<div class="styler-block-right">';
                                    woocommerce_template_loop_rating();
                                echo '</div>';
                            }
                        echo '</div>';
                        break;

                        case 'title-cart-hover':
                        echo '<div class="styler-title-cart-hover styler-title-block styler-has-hidden-cart">';
                            echo '<h6 class="styler-product-name"><a href="'.esc_url( get_permalink() ).'">'.get_the_title().'</a></h6>';
                            echo '<div class="styler-cart-hidden">';
                                styler_add_to_cart();
                            echo '</div>';
                        echo '</div>';
                        break;

                        case 'title-buttons-hover':
                        echo '<div class="styler-title-buttons-hover styler-title-block styler-has-hidden-cart">';
                            echo '<h6 class="styler-product-name"><a href="'.esc_url( get_permalink() ).'">'.get_the_title().'</a></h6>';
                            echo '<div class="styler-inline-two-block styler-sm-flex-left styler-mini-icon styler-cart-hidden">';
                                echo '<div class="styler-block-left">';
                                    styler_add_to_cart();
                                echo '</div>';
                                echo '<div class="styler-block-right">';
                                    styler_loop_product_buttons_layouts();
                                echo '</div>';
                            echo '</div>';
                        echo '</div>';
                        break;

                        case 'title-buttons-static':
                        echo '<div class="styler-title-buttons-static styler-title-block">';
                            echo '<h6 class="styler-product-name"><a href="'.esc_url( get_permalink() ).'">'.get_the_title().'</a></h6>';
                            echo '<div class="styler-block-right styler-mini-icon">';
                                styler_loop_product_buttons_layouts();
                            echo '</div>';
                        echo '</div>';
                        break;

                        case 'title-discount':
                        echo '<div class="styler-title-discount styler-title-block styler-inline-two-block">';
                            echo '<div class="styler-block-left">';
                                echo '<h6 class="styler-product-name"><a href="'.esc_url( get_permalink() ).'">'.get_the_title().'</a></h6>';
                            echo '</div>';
                            echo '<div class="styler-block-right">';
                                styler_product_discount();
                            echo '</div>';
                        echo '</div>';
                        break;

                        case 'price':
                        woocommerce_template_loop_price();
                        break;

                        case 'price-stock':
                        echo '<div class="styler-price-stock styler-inline-two-block styler-sm-flex-column">';
                            echo '<div class="styler-block-left">';
                                woocommerce_template_loop_price();
                            echo '</div>';
                            echo '<div class="styler-block-right styler-sm-flex-left">';
                                styler_loop_product_nostock();
                            echo '</div>';
                        echo '</div>';
                        break;

                        case 'price-rating':
                        echo '<div class="styler-price-rating styler-inline-two-block styler-sm-flex-column">';
                            echo '<div class="styler-block-left">';
                                woocommerce_template_loop_price();
                            echo '</div>';
                                echo '<div class="styler-block-right">';
                                    woocommerce_template_loop_rating();
                                echo '</div>';
                        echo '</div>';
                        break;

                        case 'price-cart-hover':
                        echo '<div class="styler-price-cart-hover styler-title-block styler-has-hidden-cart">';
                            woocommerce_template_loop_price();
                            echo '<div class="styler-cart-hidden">';
                                styler_add_to_cart();
                            echo '</div>';
                        echo '</div>';
                        break;

                        case 'price-buttons':
                        echo '<div class="styler-price-buttons styler-inline-two-block">';
                            echo '<div class="styler-block-left">';
                                woocommerce_template_loop_price();
                            echo '</div>';
                            echo '<div class="styler-block-right styler-mini-icon">';
                                styler_loop_product_buttons_layouts();
                            echo '</div>';
                        echo '</div>';
                        break;

                        case 'price-cart':
                        echo '<div class="styler-price-cart styler-inline-two-block">';
                            echo '<div class="styler-block-left">';
                                woocommerce_template_loop_price();
                            echo '</div>';
                            echo '<div class="styler-block-right">';
                                styler_add_to_cart();
                            echo '</div>';
                        echo '</div>';
                        break;

                        case 'rating':
                            woocommerce_template_loop_rating();
                        break;

                        case 'rating-top':
                        echo '<div class="styler-rating styler-absolute-top">';
                            if ( $product->get_average_rating() ) {
                                woocommerce_template_loop_rating();
                            }
                        echo '</div>';
                        break;

                        case 'buttons-static':
                        echo '<div class="styler-loop-product-buttons-static">';
                            styler_loop_product_buttons_layouts();
                        echo '</div>';
                        break;

                        case 'cart':
                        echo '<div class="styler-cart-static">';
                            styler_add_to_cart();
                        echo '</div>';
                        break;

                        case 'cart-buttons':
                        echo '<div class="styler-cart-buttons styler-inline-two-block">';
                            echo '<div class="styler-block-left">';
                                styler_add_to_cart();
                            echo '</div>';
                            echo '<div class="styler-block-left styler-mini-icon">';
                                styler_loop_product_buttons_layouts();
                            echo '</div>';
                        echo '</div>';
                        break;

                        case 'swatches':
                        echo '<div class="styler-swatches-static">'.do_shortcode( '[styler_swatches]' ).'</div>';
                        break;

                        case 'sale':
                        echo '<div class="styler-product-labels">';
                            styler_product_badge();
                        echo '</div>';
                        break;

                        case 'discount':
                        echo '<div class="styler-product-labels">';
                            styler_product_discount();
                        echo '</div>';
                        break;

                        case 'desc':
                            styler_product_excerpt();
                        break;
                    }
                }
                if ( '1' == styler_get_shop_column() || '1' == $column ) {
                    echo '</div>';
                }
            echo '</div>';
            if ( '1' == styler_get_shop_column() || '1' == $column ) {
                echo '</div>';
            }
        }
    }
}


/**
* Single Bottom Popup Product Add To Cart
*/
if ( ! function_exists( 'styler_product_bottom_popup_cart' ) ) {
    add_action( 'styler_before_wp_footer', 'styler_product_bottom_popup_cart', 10 );
    function styler_product_bottom_popup_cart()
    {
        global $product;

        if ( !is_product() || $product->is_type( 'grouped' ) || '0' == styler_settings( 'styler_product_bottom_popup_cart', '0' ) ) {
            return;
        }
        ?>
        <div id="product-bottom-<?php the_ID(); ?>" <?php wc_product_class( 'styler-product-bottom-popup-cart', $product ); ?>>
            <div class="container-xl styler-container-xl">
                <div class="row">
                    <div class="col-12 col-md-6 d-none d-md-flex">
                        <div class="styler-product-bottom-details">
                            <?php echo get_the_post_thumbnail( $product->get_id(), array(60,60,true) ); ?>
                            <div class="styler-product-bottom-title">
                                <?php echo get_the_title( $product->get_id() ); ?>
                                <?php woocommerce_template_loop_price(); ?>
                            </div>
                        </div>
                    </div>
                    <div class="col-12 col-md-6">
                        <div class="styler-product-bottom-title mobile-title">
                            <?php echo get_the_title( $product->get_id() ); ?>
                        </div>
                        <?php
                        if ( $product->is_type( 'simple' ) ) {
                            woocommerce_template_single_add_to_cart();
                        } else {
                            $btn_title = esc_html__( 'Add to cart', 'styler' );
                            echo '<div class="styler-product-to-top"><a href="#product-'.$product->get_id().'" class="styler-btn styler-btn-medium styler-bg-black">'.$btn_title.'</a></div>';
                        }
                        ?>
                    </div>
                </div>
            </div>
        </div>
        <?php
    }
}

if ( ! function_exists( 'styler_get_swatches_colors' ) ) {
    function styler_get_swatches_colors()
    {
        $colors = array();
        $terms  = get_terms("pa_color");
        if ( empty( $terms ) ) {
            return;
        }
        foreach ( $terms as $term ) {
            if ( !empty( $term->term_id ) ) {
                $val = get_term_meta( $term->term_id, 'styler_swatches_color', true );
                $colors[$term->name] = $val;
            }
        }
        return !empty( $colors ) ? $colors : false;
    }
}

if ( !function_exists( 'shop_product_summary_layouts_manager' ) ) {
    function shop_product_summary_layouts_manager()
    {
        if ( 'default' == styler_settings( 'single_shop_summary_layout_type', 'default' ) ) {
            return;
        }
        $defaults = [
            'show'=> [
                'bread' => '',
                'title' => '',
                'rating' => '',
                'price' => '',
                'excerpt' => '',
                'cart' => '',
                'meta' => ''
            ]
        ];

        $layouts = styler_settings( 'single_shop_summary_layouts', $defaults );

        if ( $layouts ) {

            unset( $layouts['show']['placebo'] );

            foreach ( $layouts['show'] as $key => $value ) {
                switch ( $key ) {
                    case 'bread':
                        echo woocommerce_breadcrumb();
                    break;
                    case 'title':
                        woocommerce_template_single_title();
                    break;
                    case 'rating':
                        woocommerce_template_single_rating();
                    break;
                    case 'price':
                        woocommerce_template_single_price();
                    break;
                    case 'cart':
                        woocommerce_template_single_add_to_cart();
                    break;
                    case 'excerpt':
                         woocommerce_template_single_excerpt();
                    break;
                    case 'meta':
                         woocommerce_template_single_meta();
                    break;
                }
            }
        }
    }
}

if ( !function_exists( 'styler_fly_cart' ) ) {
    add_action( 'styler_before_wp_footer', 'styler_fly_cart' );
    function styler_fly_cart()
    {
        if ( '1' != styler_settings( 'shop_fly_cart_visibility', '0' ) ) {
            return;
        }
        ?>
        <div id="styler-sticky-cart-toggle" class="styler-sticky-cart-toggle" data-duration="<?php echo styler_settings( 'shop_fly_cart_duration', 1500 ); ?>">
            <span class="styler-cart-count styler-wc-count"></span>
            <?php echo styler_svg_lists( 'bag', 'styler-svg-icon' ); ?>
        </div>
        <?php
    }
}
