/*-----------------------------------------------------------------------------------

    Theme Name: Styler
    Description: WordPress Theme
    Author: Ninetheme
    Author URI: https://ninetheme.com/
    Version: 1.0

-----------------------------------------------------------------------------------*/

//var wishlist_vars = {};
"use strict";

(function(window, document, $) {

    function set_Cookie(cname, cvalue, exdays) {
        var d = new Date();

        d.setTime(d.getTime() + (
            exdays * 24 * 60 * 60 * 1000
        ));

        var expires = 'expires=' + d.toUTCString();

        document.cookie = cname + '=' + cvalue + '; ' + expires + '; path=/';
    }

    function get_Cookie(cname) {
        var name = cname + '=';
        var ca = document.cookie.split(';');

        for (var i = 0; i < ca.length; i++) {
            var c = ca[i];

            while (c.charAt(0) == ' ') {
                c = c.substring(1);
            }

            if (c.indexOf(name) == 0) {
                return decodeURIComponent(c.substring(name.length, c.length));
            }
        }

        return '';
    }

    function getProducts() {
        var cookie = 'styler_products',
            cookie = compare_vars.user_id != '' ? 'styler_products_' + compare_vars.user_id : '';

        return get_Cookie( cookie ) != '' ? get_Cookie( cookie ) : '';
    }

    function addProduct( id ) {
        var cookie = 'styler_products',
            count,
            limit  = false,
            notice = compare_vars.notice,
            btn    = $('.styler-compare-btn[data-id="' + id + '"]');

        if ( compare_vars.user_id != '' ) {
            cookie = 'styler_products_' + compare_vars.user_id;
        }

        if ( get_Cookie( cookie ) != '' ) {
            var products = get_Cookie( cookie ).split(',');

            if ( products.length < compare_vars.limit ) {
                products = $.grep( products, function( value ) {
                    return value != id;
                });
                products.unshift( id );

                var products = products.join();

                set_Cookie( cookie, products, 7 );
            } else {
                limit = true;
                notice = notice.replace( '{max_limit}', compare_vars.limit );
            }

            count = products.length;

        } else {
            set_Cookie( cookie, id, 7 );
            count = 1;
        }

        if ( limit ) {
            alert( notice );
        } else {
            btn.addClass('added');
        }
    }

    function removeProduct( id ) {
        var cookie = 'styler_products',
            count  = 0,
            btn    = $('.styler-compare-btn[data-id="' + id + '"]'),
            cookie = compare_vars.user_id != '' ? 'styler_products_' + compare_vars.user_id : '';

        if ( cookie != '' ) {
            var products = get_Cookie( cookie ).split(',');

            products = $.grep( products, function( value ) {
                return value != id;
            });

            var products_str = products.join();

            set_Cookie( cookie, products_str, 7 );
            count = products.length;
        }

        btn.removeClass('added');
    }

    function get_count() {
        var products = getProducts(),
            count = 0;

        if ( products != '' ) {
            var arr = products.split(',');
                count = arr.length;
        }
        return count;
    }

    function change_count() {
        var count = get_count();
        $('[data-compare-count]').attr('data-compare-count', count );
        $('.styler-compare-count').html( count );
        compare_vars.count = count;
    }

    // add product to compare list
    $(document).on('click touch', '.styler-compare-btn', function(e) {
        var $this = $( this ),
            id = $this.attr('data-id');

        if ( $this.hasClass('added') ) {
            addCompare( 'add', id );
        } else {
            $this.addClass('added');
            $this.parent().append('<span class="loading-wrapper"><span class="ajax-loading"></span></span>').addClass('loading');
            addProduct( id );
            addCompare( 'add', id );
        }

        if ( get_count() == '0' ) {
            $('.compare-area').removeClass('has-product');
        } else {
            $('.compare-area').addClass('has-product');
        }

        e.preventDefault();
    });

    // remove from compare list
    $(document).on('click touch', '.styler-compare-del-icon', function(e) {
        var id = $(this).parents('.styler-content-item').attr('data-id');

        $('.styler-compare-item[data-id="' + id + '"]').remove();
        $( '.styler-compare-btn[data-id="' + id + '"]').removeClass('added');
        //$( '.styler-product-summary .styler-summary-item .styler-compare-btn[data-id="' + id + '"]').removeClass('added');
        removeProduct( id );

        change_count();

        if ( get_count() == '0' ) {
            $('.compare-area').removeClass('has-product');
        } else {
            $('.compare-area').addClass('has-product');
        }

        e.preventDefault();
    });


    function addCompare( $action, id ) {
        var data = {
            action: 'styler_add_compare',
            products: getProducts(),
            nonce: compare_vars.nonce
        };

        $.post( compare_vars.ajaxurl, data, function( response ) {

            $('.styler-compare-content-items').html( response );
            $('body').addClass('styler-overlay-open');
            $('.styler-side-panel div:not([data-name="compare"])').removeClass('active');
            $('.styler-side-panel, .compare-area, .styler-side-panel div[data-name="compare"]').addClass('active');
            $( '.styler-compare-btn[data-id="' + id + '"]').parent().find('.loading-wrapper').remove();
            $( '.styler-compare-btn[data-id="' + id + '"]').parent().removeClass('loading');
            change_count();
            $('body').trigger('styler_lazy_load');

        });
    }

    $( document ).ready( function( $ ) {
        $('.styler-compare-count').html( compare_vars.count );
    });

    if ( ( typeof compare_vars != 'undefined' ) && compare_vars.products ) {
        var ids = compare_vars.products;
        for (let i = 0; i < ids.length; i++) {
          $('.styler-compare-btn[data-id="'+ids[i]+'"]').addClass('added');
        }
    }


})(window, document, jQuery);
