jQuery(document).ready(function ($) {


    $(document).on('stylerShopInit', function () {
        infinitescroll();
    });

    function infinitescroll() {

        $(window).data('ajaxready', true).scroll(function(e) {

            if ($(window).data('ajaxready') == false) return;
            var products_row = $('div.styler-products').offset().top + $('div.styler-products.row').outerHeight();
            var products_rowh = $('div.styler-products.row').outerHeight();
            if( $(window).scrollTop() >= ( products_row - window.innerHeight ) - products_rowh ) {

                $(window).data('ajaxready', false);

                styler_infinite_pagination();

            }
        });
    }

    infinitescroll();

    function styler_infinite_pagination() {
        var object = $('.shop-data-filters').data('shop-filters');
        var data = {
            cache      : false,
            action     : 'styler_shop_load_more',
            beforeSend : function() {
                if ( object.current_page == object.max_page ) {
                    $('.styler-load-more').addClass('no-more').text(object.no_more);
                    setTimeout(function(){
                        $('.row-infinite').slideUp('slow');
                    }, 3000);
                } else {
                    $('.styler-load-more').addClass('loading');
                }
            },
            'ajaxurl'      : object.ajaxurl,
            'current_page' : object.current_page,
            'per_page'     : object.per_page,
            'max_page'     : object.max_page,
            'cat_id'       : object.cat_id,
            'tag_id'       : object.tag_id,
            'brand_id'     : object.brand_id,
            'filter_cat'   : object.filter_cat,
            'layered_nav'  : object.layered_nav,
            'on_sale'      : object.on_sale,
            'orderby'      : object.orderby,
            'min_price'    : object.min_price,
            'max_price'    : object.max_price,
            'product_style': object.product_style,
            'column'       : object.column,
            'no_more'      : object.no_more
        };

        if ( object.current_page == object.max_page ) {
            $('.styler-load-more').addClass('no-more').text(object.no_more);
            setTimeout(function(){
                $('.row-infinite').slideUp('slow');
            }, 3000);
            return;
        }

        $.post(object.ajaxurl, data, function(response) {
            $('div.styler-products.row').append(response);

            $(document.body).trigger('styler_quick_shop');
            $('body').trigger('styler_quick_init');
            $(document.body).trigger('styler_variations_init');

            if ( $('.styler-loop-slider') ) {
				$('.styler-loop-slider:not(.swiper-initialized)').each(function () {
					const options  = $(this).data('swiper-options');
					const mySlider = new NTSwiper(this, options);
				});
			}

            if ( object.current_page == object.max_page ) {
                $('.styler-load-more').addClass('no-more').text(object.no_more);
                setTimeout(function(){
                    $('.row-infinite').slideUp('slow');
                }, 3000);
                return false;
            }

            $(document.body).trigger('styler_masonry_init');

            object.current_page++;

            if ( object.current_page == object.max_page ) {
                $('.styler-load-more').addClass('no-more').text(object.no_more);
                setTimeout(function(){
                    $('.row-infinite').slideUp('slow');
                }, 3000);
                return false;
            }

            $(window).data('ajaxready', true);
        });

        return false;
    }
});
