jQuery(document).ready(function($) {

    "use strict";

    var miniCartAjax = null;
    // Quantity buttons
    $('body').off('click.qtyBtn').on('click.qtyBtn','.plus, .minus', function() {

        var $qty    = $( this ).closest( '.quantity' ).find( '.qty' ),
            qty_val = parseFloat( $qty.val() ),
            max     = parseFloat( $qty.attr( 'max' ) ),
            min     = parseFloat( $qty.attr( 'min' ) ),
            step    = $qty.attr( 'step' ),
            new_val = 0;

        if ( ! qty_val || qty_val === '' || qty_val === 'NaN' ) {
            qty_val = 0;
        }
        if ( max === '' || max === 'NaN' ) {
            max = '';
        }
        if ( min === '' || min === 'NaN' ) {
            min = 0;
        }
        if ( step === 'any' || step === '' || step === undefined || parseFloat( step ) === 'NaN' ) {
            step = 1;
        } else {
            step = parseFloat(step);
        }

        // Update values
        if ( $( this ).is( '.plus' ) ) {
            if ( max && ( max === qty_val || qty_val > max ) ) {
                $qty.val( max );
                $( this ).addClass('disabled');
            } else {
                new_val = qty_val + parseFloat( step );
                $qty.val( new_val );
                if ( max && ( max === new_val || new_val > max ) ) {
                    $( this ).addClass('disabled');
                }
                $qty.trigger('change');
            }
        } else {
            if ( min && ( min === qty_val || qty_val < min ) ) {
                $qty.val( min );
                $( this ).addClass('disabled');
            } else if ( qty_val > 0 ) {
                new_val = qty_val - parseFloat( step );
                $qty.val( new_val );
                if ( min && ( min === new_val || new_val < min ) ) {
                    $( this ).addClass('disabled');
                }
                $qty.trigger('change');
            }
        }
        //return false;
    });


    $(document).on('wc_fragment_refresh', function(e) {
        setTimeout(function(){
            $('.styler-perfect-scrollbar').perfectScrollbar({
              wheelSpeed: 2,
              wheelPropagation: true,
              minScrollbarLength: 20
            });
        }, 1500);
    });

    $(document).on('click', '.plus, .minus', function() {
        event.preventDefault();

        if ( $('body').hasClass('woocommerce-cart') ) {
            return;
        }
        
        var clicked = $(this);
        var qty = clicked.parent().find('.qty');
        var pid = clicked.closest('.cart-quantity-wrapper').attr('data-product_id');

        var data = {
            type: 'POST',
            timeout: 3000,
            cache: false,
            action: 'styler_quantity_button',
            beforeSend: function () {
                clicked.parents('.woocommerce-mini-cart-item').append('<span class="loading-wrapper"><span class="ajax-loading"></span></span>').addClass('loading');
            },
            id: pid,
            quantity : qty.val(),
        };

        $.post(styler_vars.ajax_url, data, function(response) {
            $(document.body).trigger('wc_fragment_refresh').trigger('updated_cart_totals');
            $(document.body).trigger("update_checkout");
        });
    });

});
