(function($) {

    var $doc  = $(document),
        $win  = $(window),
        $body = $('body'),
        links = '.woocommerce .widget_rating_filter ul li a, .widget_product_categories a, .woocommerce-widget-layered-nav a, body.post-type-archive-product:not(.woocommerce-account) .styler-woocommerce-pagination a, body.tax-product_cat:not(.woocommerce-account) .styler-woocommerce-pagination a, .woocommerce-widget-layered-nav-list a, .top-action a, .styler-choosen-filters a, .widget_product_tag_cloud a, .styler-shop-filter-area a, .styler-woo-breadcrumb .breadcrumb li a, .shop-slider-categories .slick-slide a, .styler-remove-filter a, .styler-product-status a, .styler-widget-product-categories a,.styler-shop-hero .styler-wc-category-list li a, .styler-shop-hero .styler-category-slide-item a, .shop-cat-banner-template-wrapper .styler-banner-link',
        sidebar_links = '.nt-sidebar-inner .widget_rating_filter ul li a, .nt-sidebar-inner .widget_product_categories a, .nt-sidebar-inner .woocommerce-widget-layered-nav a, .nt-sidebar-inner .woocommerce-widget-layered-nav-list a, .nt-sidebar-inner .styler-choosen-filters a, .styler-choosen-filters-row a, .nt-sidebar-inner .widget_product_tag_cloud a, .nt-sidebar-inner .styler-remove-filter a, .nt-sidebar-inner .styler-product-status a, .nt-sidebar-inner .styler-widget-product-categories a';

    function scrollToTop($target) {
        if ( $($target).length ) {
            var adminBarHeight = $body.hasClass('admin-bar') ? 46 + 140 : 140;
            setTimeout(function(){
                $('html, body').stop().animate({
                    scrollTop: $($target).offset().top - adminBarHeight
                }, 800);
            }, 800 );

        }
    }

    function sortOrder() {
        var $order = $('.woocommerce-ordering');

        $order.on('change', 'select.orderby', function() {
            var $form = $(this).closest('form');
            $form.find('[name="_pjax"]').remove();

            $.pjax({
                container: '.styler-products-wrapper',
                timeout  : 5000,
                url      : '?' + $form.serialize(),
                scrollTo : false,
                renderCallback: function(context, html, afterRender) {
                    context.html(html);
                    afterRender();
                    $doc.trigger('stylerShopInit');
                }
            });
        });

        $order.on('submit', function(e) {
            return false;
        });
    }

    function perPage() {
        var $perPage = $('.products-per-page');

        $perPage.on('change', 'select.perpage', function() {
            var $form = $(this).closest('form');
            $form.find('[name="_pjax"]').remove();

            $.pjax({
                container: '.styler-products-wrapper',
                timeout  : 5000,
                url      : '?' + $form.serialize(),
                scrollTo : false,
                renderCallback: function(context, html, afterRender) {
                    context.html(html);
                    afterRender();
                    $doc.trigger('stylerShopInit');
                }
            });
        });

        $perPage.on('submit', function(e) {
            e.preventDefault(e);
        });
    }

    function priceSlider() {

        if ( $('body').hasClass('shop-layout-no-sidebar') || !$( '.price_slider' ).length ) {
            return;
        }

        $( document.body ).on( 'price_slider_create price_slider_slide', function( event, min, max ) {

            $( '.price_slider_amount span.from' ).html( accounting.formatMoney( min, {
                symbol:    woocommerce_price_slider_params.currency_format_symbol,
                decimal:   woocommerce_price_slider_params.currency_format_decimal_sep,
                thousand:  woocommerce_price_slider_params.currency_format_thousand_sep,
                precision: woocommerce_price_slider_params.currency_format_num_decimals,
                format:    woocommerce_price_slider_params.currency_format
            } ) );

            $( '.price_slider_amount span.to' ).html( accounting.formatMoney( max, {
                symbol:    woocommerce_price_slider_params.currency_format_symbol,
                decimal:   woocommerce_price_slider_params.currency_format_decimal_sep,
                thousand:  woocommerce_price_slider_params.currency_format_thousand_sep,
                precision: woocommerce_price_slider_params.currency_format_num_decimals,
                format:    woocommerce_price_slider_params.currency_format
            } ) );

            //if ( $( '.price_slider_amount span.from' ).length ) {
                $( document.body ).trigger( 'price_slider_updated', [ min, max ] );
            //}
        });

        function initPriceFilter() {
            $( 'input#min_price, input#max_price' ).hide();
            $( '.price_slider, .price_label' ).show();

            var min_price         = $( '.price_slider_amount #min_price' ).data( 'min' ),
                max_price         = $( '.price_slider_amount #max_price' ).data( 'max' ),
                step              = $( '.price_slider_amount' ).data( 'step' ) || 1,
                current_min_price = $( '.price_slider_amount #min_price' ).val(),
                current_max_price = $( '.price_slider_amount #max_price' ).val();

            $( '.price_slider:not(.ui-slider)' ).slider({
                range  : true,
                animate: true,
                min    : min_price,
                max    : max_price,
                step   : step,
                values : [ current_min_price, current_max_price ],
                create : function() {

                    $( '.price_slider_amount #min_price' ).val( current_min_price );
                    $( '.price_slider_amount #max_price' ).val( current_max_price );

                    $( document.body ).trigger( 'price_slider_create', [ current_min_price, current_max_price ] );
                },
                slide: function( event, ui ) {

                    $( 'input#min_price' ).val( ui.values[0] );
                    $( 'input#max_price' ).val( ui.values[1] );

                    $( document.body ).trigger( 'price_slider_slide', [ ui.values[0], ui.values[1] ] );
                },
                change: function( event, ui ) {

                    $( document.body ).trigger( 'price_slider_change', [ ui.values[0], ui.values[1] ] );
                }
            });
        }

        initPriceFilter();
        $( document.body ).on( 'init_price_filter', initPriceFilter );

        var hasSelectiveRefresh = (
            'undefined' !== typeof wp &&
            wp.customize &&
            wp.customize.selectiveRefresh &&
            wp.customize.widgetsPreview &&
            wp.customize.widgetsPreview.WidgetPartial
        );
        if ( hasSelectiveRefresh ) {
            wp.customize.selectiveRefresh.bind( 'partial-content-rendered', function() {
                initPriceFilter();
            } );
        }

        var $min_price = $('.price_slider_amount #min_price');
        var $max_price = $('.price_slider_amount #max_price');
        var $products  = $('.products');

        if (typeof woocommerce_price_slider_params === 'undefined' || $min_price.length < 1 || !$.fn.slider) {
            return false;
        }

        var $slider = $('.price_slider');

        if ($slider.slider('instance') !== undefined) {
            return;
        }

        $('input#min_price, input#max_price').hide();
        $('.price_slider, .price_label').show();

        var min_price         = $min_price.data('min'),
            max_price         = $max_price.data('max'),
            current_min_price = parseInt(min_price, 10),
            current_max_price = parseInt(max_price, 10);

        if ($products.attr('data-min_price') && $products.attr('data-min_price').length > 0) {
            current_min_price = parseInt($products.attr('data-min_price'), 10);
        }

        if ($products.attr('data-max_price') && $products.attr('data-max_price').length > 0) {
            current_max_price = parseInt($products.attr('data-max_price'), 10);
        }

        $slider.slider({
            range  : true,
            animate: true,
            min    : min_price,
            max    : max_price,
            values : [
                current_min_price,
                current_max_price
            ],
            create : function() {
                $min_price.val(current_min_price);
                $max_price.val(current_max_price);

                $body.trigger('price_slider_create', [
                    current_min_price,
                    current_max_price
                ]);
            },
            slide  : function(event, ui) {
                $('input#min_price').val(ui.values[0]);
                $('input#max_price').val(ui.values[1]);

                $body.trigger('price_slider_slide', [
                    ui.values[0],
                    ui.values[1]
                ]);
            },
            change : function(event, ui) {
                $body.trigger('price_slider_change', [
                    ui.values[0],
                    ui.values[1]
                ]);
            }
        });

        setTimeout(function() {
            $body.trigger('price_slider_create', [
                current_min_price,
                current_max_price
            ]);

            if ($slider.find('.ui-slider-range').length > 1) {
                $slider.find('.ui-slider-range').first().remove();
            }
        }, 10);
    }

    function ajaxHandler() {

        $doc.pjax(links, '.styler-products-wrapper', {
            timeout       : 5000,
            scrollTo      : false,
            renderCallback: function(context, html, afterRender) {
                context.html(html);
                afterRender();
            }
        });

        $doc.on('submit', '.widget_price_filter form', function(event) {
            $.pjax.submit(event, '.styler-products-wrapper');
        });

        $doc.on('pjax:error', function(xhr, textStatus, error) {
            console.log('pjax error ' + error);
        });

        $doc.on('pjax:start', function() {
            //$(window).scrollTop({ top: 0, behavior: 'smooth' });
            var $shopContent = $('.styler-products-wrapper');
            $shopContent.addClass('product-loading').append('<span class="loading-wrapper products-wrapper-loading"><span class="ajax-loading"></span></span>').css('min-height', 300);
            $(".styler-products, .styler-more, nav.styler-woocommerce-pagination").hide();
            $('.nt-shop-page .styler-shop-hero-wrapper .container-xl, .shop-cat-banner-template-wrapper').removeClass('animated fadeInUp');

            if ( ( typeof compare_vars != 'undefined' ) && compare_vars.products ) {
                var compare_ids = [];
                $('.styler-product .styler-compare-btn.added' ).each(function(){
                    compare_ids.push( $(this).data('id') );
                });
                compare_vars.products = compare_ids;
            }
            if ( ( typeof wishlist_vars != 'undefined' ) && wishlist_vars.products ) {
                var wishlist_ids = [];
                $('.styler-product .styler-wishlist-btn.added' ).each(function(){
                    wishlist_ids.push( $(this).data('id') );
                });
                wishlist_vars.products = wishlist_ids;
            }
        });

        $doc.on('pjax:complete', function() {

            var $filters = $('.styler-products-wrapper .shop-data-filters').data('shop-filters');
            if ( $filters.max_page == 1 ) {
                $(".row-more").hide();
            }

            $('.styler-products .product' ).each(function(e, index){
                var delay = e/10;
                var anim = $(this).data('product-animation');
                $(this).addClass( 'animated '+ anim ).css('animation-delay', delay+'s');
            });
            $doc.trigger('stylerShopInit');
        });

        $doc.on('pjax:end', function() {

            $('.styler-products-wrapper').removeClass('product-loading').addClass('ajax-loaded');
            $('.styler-products-wrapper .products-wrapper-loading').remove();
            scrollToTop('.shop-area .styler-products-wrapper');
        });
    }

    function stylerAfterRender() {

        var $afterAjaxShop         = $('.site-content');
        var $afterAjaxContent      = $('.styler-after-ajax-content');
        var $perPageContent        = $afterAjaxContent.find('.perpage-filter-ajax-content').html();
        var $columnSelectContent   = $afterAjaxContent.find('.column-select-ajax-content').html();
        var $heroContent           = $afterAjaxContent.find('.styler-shop-hero-wrapper').html();
        var $heroTitle             = $afterAjaxContent.find('.styler-shop-hero .nt-hero-title').html();
        var $resultCountContent    = $afterAjaxContent.find('.woocommerce-result-count').html();
        var $sidebarContent        = $afterAjaxContent.find('.nt-sidebar-ajax-content .nt-sidebar-inner-wrapper').html();
        var $choosenContent        = $afterAjaxContent.find('.nt-sidebar-ajax-content .styler-choosen-filters').html();

        $('.styler-header-bottom-bar .woocommerce-result-count').html($resultCountContent);
        $afterAjaxShop.find('.woocommerce-result-count').html($resultCountContent);
        $('.nt-shop-page .styler-shop-hero-wrapper:not(.page-hero-static)').html($heroContent);
        $('.nt-shop-page').addClass('ajax-active');
        $('.nt-shop-page .styler-shop-hero-wrapper .container-xl, .shop-cat-banner-template-wrapper').addClass('animated fadeInUp');
        $('.nt-shop-page .styler-shop-hero-wrapper.page-hero-static .nt-hero-title').html($heroTitle);
        $afterAjaxShop.find('.styler-filter-per-page-area').html($perPageContent);
        $afterAjaxShop.find('.styler-filter-column-select-area').html($columnSelectContent);
        $('.styler-header-bottom-bar .styler-filter-column-select-area').html($columnSelectContent);

        if ( typeof $choosenContent == undefined || typeof $choosenContent == 'undefined' ) {
            $('.styler-choosen-filters-row').removeClass('filters-active animated fadeInUp').find('.col-12').html('');
        } else {
            $('.styler-choosen-filters-row').addClass('filters-active animated fadeInUp').find('.col-12').html($choosenContent);
        }

        if ( $('body').hasClass('shop-layout-no-sidebar') ) {
            return;
        }
        $afterAjaxShop.find('.nt-sidebar-inner-wrapper').html($sidebarContent);
        if ( $(window).width() >= 1024 ) {
            var columnSize = $('.styler-shop-hidden-top-sidebar').data('column');
            $('.styler-shop-hidden-top-sidebar .nt-sidebar-inner').addClass(columnSize);
        }
        if ( $('.styler-loop-slider') ) {
            $('.styler-loop-slider').each(function () {
                const options = JSON.parse(this.dataset.swiperOptions);
                const mySlider = new NTSwiper(this, options);

                $(this).hover(function() {
                    if ( options.autoplay == true ) {
                        mySlider.autoplay.stop();
                    }
                }, function() {
                    if ( options.autoplay == true ) {
                        mySlider.autoplay.start();
                    }
                });

            });
        }
        if ( $('.styler-swiper-slider') ) {
            $('.styler-swiper-slider').each(function () {
                const options = JSON.parse(this.dataset.swiperOptions);
                const mySlider = new NTSwiper(this, options);

                $(this).hover(function() {
                    if ( options.autoplay == true ) {
                        mySlider.autoplay.stop();
                    }
                }, function() {
                    if ( options.autoplay == true ) {
                        mySlider.autoplay.start();
                    }
                });
            });
        }
        if ( typeof styler_vars !== 'undefined' && styler_vars ) {
            var colors = styler_vars.shop.swatches_color;

            $('.woocommerce-widget-layered-nav-list li a').each(function () {
                var $this = $(this);
                var title = $this.html();
                for (var i in colors) {
                    if ( title == i ) {
                        var is_white = colors[i] == '#fff' || colors[i] == '#ffffff' ? ' is_white' : '';
                        var color = '<span class="styler-swatches-widget-color-item'+is_white+'" style="background-color: '+colors[i]+';"></span>';
                        $this.prepend(color);
                    }
                }
            });
        }
    }

    function stylerPerfectScrollbar() {
        if ( $('.styler-perfect-scrollbar').length ) {
            var winH = $(window).height(),
                winH = winH - 200;

            $('.styler-perfect-scrollbar').perfectScrollbar({
                wheelSpeed: 2,
                wheelPropagation: true,
                minScrollbarLength: 20
            });
        }
    }
    function buttonsActions() {
        //Header cart Toggle
        $('.styler-cart-btn').on('click', function () {
            $('.styler-header-cart-details.minicart').toggleClass('active');
        });

        $('.nt-sidebar li.cat-parent> ul.children').each( function (e) {
            $(this).before('<span class="subDropdown"></span>');
            $(this).slideUp();
        });
        $('.nt-sidebar ul li.cat-parent .subDropdown').on('click', function (e) {
            if ( $(this).hasClass('active') ) {
                $(this).removeClass('active minus').addClass("plus");
                $(this).next('.children').slideUp('slow');
            } else {
                $(this).removeClass('plus').addClass("active minus");
                $(this).next('.children').slideDown('slow');
            }
        });
        $('.nt-sidebar-widget-toggle').on('click', function() {
            var $this = $(this);
            $this.toggleClass('active');
            $this.parents('.nt-sidebar-inner-widget').toggleClass('styler-widget-show styler-widget-hide');
            $this.parent().next().slideToggle('fast');
        });
    }

    function stylerDealsCountDown() {
        $('[data-countdown]').each(function () {
            var $this = $(this),
                data = $this.data('countdown'),
                finalDate = data.date,
                hr = data.hr,
                min = data.min,
                sec = data.sec;
            $this.countdown(finalDate, function (event) {
                $this.html(event.strftime('<div class="time-count day"><span>%D</span>Day</div><div class="time-count hour"><span>%H</span>'+hr+'</div><div class="time-count min"><span>%M</span>'+min+'</div><div class="time-count sec"><span>%S</span>'+sec+'</div>'));
            });
        });
    }

    function stylerSidebarAddRemoveFilter() {
        $('.nt-sidebar-inner .woocommerce-widget-layered-nav-list__item.chosen a').each(function() {
            $(this).prepend('<span class="remove-filter"></span>');
        });
    }

    $doc.on('stylerShopInit', function() {
        stylerAfterRender();
        sortOrder();
        perPage();
        stylerSidebarAddRemoveFilter();
        buttonsActions();
        priceSlider();
        stylerDealsCountDown();

        $('.styler-products-wrapper .variations_form').each(function () {
            $(this).wc_variation_form();
        });

        if ( ( typeof wishlist_vars != 'undefined' ) && wishlist_vars.products ) {
            var ids = wishlist_vars.products;
            for (let i = 0; i < ids.length; i++) {
              $('.styler-wishlist-btn[data-id="'+ids[i]+'"]').addClass('added');
            }
        }
        if ( ( typeof compare_vars != 'undefined' ) && compare_vars.products ) {
            var ids = compare_vars.products;
            for (let i = 0; i < ids.length; i++) {
              $('.styler-compare-btn[data-id="'+ids[i]+'"]').addClass('added');
            }
        }
    });

    $doc.ready(function() {
        stylerAfterRender();
        sortOrder();
        perPage();
        ajaxHandler();
        stylerSidebarAddRemoveFilter();

        var chosenFilters = $( '.nt-sidebar .styler-choosen-filters' ).html();

        if ( chosenFilters != undefined || typeof chosenFilters != 'undefined' ) {
            $('.styler-choosen-filters-row').addClass('filters-active animated fadeInUp').find('.col-12').html(chosenFilters);
        }
        if ( $('.styler-filter-columns').length ) {
            $('.styler-filter-columns li').on('click', function (e) {
                var col = $(this).data('column');
                $(this).addClass('active').siblings().removeClass('active');
                $('.styler-products').removeAttr('class').addClass('styler-products row '+col);
            });
        }
        if ( $('.styler-per-page-item').length ) {
            $('.styler-per-page-item').on('click', function (e) {
                $(this).addClass('active').siblings().removeClass('active');
            });
        }
    });

})(jQuery);
