(function(window, document, $) {

"use strict";

jQuery(document).ready(function($) {

    /*-- Strict mode enabled --*/
    'use strict';

    var scrollOffset = $('.styler-header-default').height();

    if ( $('body').hasClass('admin-bar') ) {
        scrollOffset = scrollOffset + 32;
    }

    var scrollToTopSidebar = function() {
        var shopP = 30;

        if ( $('body').hasClass('admin-bar') ) {
            shopP = 32;
        }

        $('html, body').stop().animate({
            scrollTop: $('.shop-area').offset().top - shopP
        }, 400);
    };

    $('.styler-open-fixed-sidebar,.styler-close-sidebar').on('click', function () {
        $('body').toggleClass('styler-overlay-open');
        $('.nt-sidebar').toggleClass('active');
    });


    $('.styler-toggle-hidden-sidebar').on('click', function (e) {

        $('.styler-toggle-hidden-sidebar').toggleClass('active');
        $('.nt-sidebar').toggleClass('active').slideToggle();

        setTimeout(function(){
            scrollToTopSidebar();
        }, 100 );
    });

    // cart shipping form show-hide
    $('.styler-shipping-calculator-button').on('click', function (e) {
        var cartTotals = $('.styler-cart-totals'),
            form = $('.shipping-calculator-form');

        if ( cartTotals.hasClass('active')) {
            cartTotals.removeClass('active');
            form.slideUp('slow');
        } else {
            cartTotals.addClass('active');
            form.slideDown('slow');
            setTimeout(function(){
                $('html, body').stop().animate({
                    scrollTop: cartTotals.offset().top - scrollOffset
                }, 400);
            }, 300 );
        }
    });

    $('.nt-sidebar ul.product-categories li.cat-parent> ul.children').each( function (e) {
        $(this).before('<span class="subDropdown"></span>');
        $(this).slideUp();
    });

    stylerWcProductCats();
    function stylerWcProductCats() {
        $('.widget_styler_product_categories ul.children input[checked]').closest('li.cat-parent').addClass("current-cat");

        $('body').off('click', '.subDropdown').on('click', '.subDropdown', function () {
            //$(this).toggleClass("plus"),
            //$(this).toggleClass("minus"),
            //$(this).parent().find("ul").slideToggle();
        });
    }

    $('.styler-loop-product-iframe-wrapper').each( function (e) {
        var iframe = $( this ).find('iframe');
    });

    $('.nt-sidebar ul li.cat-parent .subDropdown').on('click', function (e) {
        if ( $(this).hasClass('active') ) {
            $(this).removeClass('active minus').addClass("plus");
            $(this).next('.children').slideUp('slow');
        } else {
            $(this).removeClass('plus').addClass("active minus");
            $(this).next('.children').slideDown('slow');
        }
    });


    if ( $(window).width() < 992 ) {
        var columnSize = $('.styler-shop-hidden-top-sidebar').data('column');
        $('.styler-shop-hidden-top-sidebar').removeClass('d-none active').removeAttr('style');
        $('.styler-toggle-hidden-sidebar').removeClass('active');
        $('.styler-shop-hidden-top-sidebar:not(.d-none) .nt-sidebar-inner').removeClass(columnSize);
    }

    $(window).on('resize', function(){
        var columnSize = $('.styler-shop-hidden-top-sidebar').data('column');
        if ( $(window).width() >= 992 ) {
            if ( $('body').hasClass('styler-overlay-open') ) {
                $('body').removeClass('styler-overlay-open');
                $('.styler-shop-hidden-top-sidebar').removeClass('active');
            }
            $('.styler-shop-hidden-top-sidebar').addClass('d-none');
            $('.styler-shop-hidden-top-sidebar .nt-sidebar-inner').addClass(columnSize);
        }
        if ( $(window).width() < 992 ) {
            $('.styler-shop-hidden-top-sidebar').removeClass('d-none active').removeAttr('style');
            $('.styler-toggle-hidden-sidebar').removeClass('active');
            $('.styler-shop-hidden-top-sidebar:not(.d-none) .nt-sidebar-inner').removeClass(columnSize);
        }

    });


    if ( $(window).width() < 992 && $(".styler-bottom-mobile-nav").length ) {
        $("body").addClass('has-bottom-fixed-menu');
    }

    if ( $(".styler-product-video-button").length ) {
        $(".styler-product-video-button").magnificPopup({
            type: 'iframe'
        });
    }

    stylerProductPopup();
    function stylerProductPopup() {
        $('.styler-product-popup:not([data-fancybox="images"])').magnificPopup({
            type            : 'image',
            //overflowY     : 'scroll',
            fixedBgPos      : true,
            fixedContentPos : true,
            closeBtnInside  : false,
            preloader       : false,
            midClick        : true,
            removalDelay    : 0,
            mainClass       : 'styler-mfp-slide-bottom',
            tClose          : '',
            tLoading        : '<span class="loading-wrapper"><span class="ajax-loading"></span></span>',
            closeMarkup     : '<div title="%title%" class="mfp-close styler-mfp-close"></div>',
            gallery         : {
                enabled : true
            },
            callbacks: {
                open: function() {

                    if ( 'function' !== typeof $.fn.zoom && !wc_single_product_params.zoom_enabled ) {
                        return false;
                    }
                    $(".mfp-figure figure").css("cursor", "zoom-in");
                    $(".mfp-figure figure").zoom({
                        on: "click",
                        onZoomIn: function () {
                            $(this).css("cursor", "zoom-out");
                            $(".mfp-figure figure").addClass("zoom-in");
                        },
                        onZoomOut: function () {
                            $(this).css("cursor", "zoom-in");
                            $(".mfp-figure figure").removeClass("zoom-in");
                        }
                    });
                },
                change: function() {

                  if ( 'function' !== typeof $.fn.zoom && !wc_single_product_params.zoom_enabled ) {
                      return false;
                  }
                  setTimeout( function(){
                    $(".mfp-figure figure .zoomImg").remove();
                    $(".mfp-figure figure").zoom({
                        on: "click",
                        onZoomIn: function () {
                            $(this).css("cursor", "zoom-out");
                            $(".mfp-figure figure").addClass("zoom-in");
                        },
                        onZoomOut: function () {
                            $(this).css("cursor", "zoom-in");
                            $(".mfp-figure figure").removeClass("zoom-in");
                        }
                    });
                  },500);
                }
            }
        });

        if ( $('[data-fancybox="images"]').length > 0 ) {
            $('[data-fancybox="images"]').fancybox({
                animationEffect: "zoom",
                buttons : [
                    'zoom',
                    //'share',
                    'thumbs',
                    'slideShow',
                    'fullScreen',
                    'close'
                ]
            });
        }
    }


    if ( $(".styler-product-stock-progressbar").length ) {
        var percent = $(".styler-product-stock-progressbar").data('stock-percent');
        $(".styler-product-stock-progressbar").css('width',percent);
    }

    $(document).on('ready', function(e){
        if (typeof styler.Swatches !== 'undefined') {
            $('.products-wrapper .variations_form').each(function () {
                $(this).wc_variation_form();
            });
        }
    });

    $('.product:not(.product-type-external) form.cart').on('submit', function(e) {
        e.preventDefault();

        var form  = $(this),
            btn   = form.find('.styler-btn'),
            title = btn.text(),
            added = btn.data('added-title');
        btn.addClass('loading');


        var formData = new FormData(form[0]);
        formData.append('add-to-cart', form.find('[name=add-to-cart]').val() );

        if ( !$('.styler-side-panel').hasClass('disable-auto-open') ) {
            setTimeout(function() {
                $('html,body').addClass('styler-overlay-open');
                $('.panel-header-actions .active,.panel-content .active').removeClass('active');
            }, 200);
            setTimeout(function() {
                $('.styler-side-panel').addClass('active');
            }, 300);
            setTimeout(function() {
                $('.panel-content .cart-area').addClass('active cart-item-loading');
            }, 400);
        }

        // Ajax action.
        $.ajax({
            url: wc_add_to_cart_params.wc_ajax_url.toString().replace( '%%endpoint%%', 'styler_ajax_add_to_cart' ),
            data: formData,
            type: 'POST',
            processData: false,
            contentType: false,
            complete: function( response ) {
                response = response.responseJSON;

                // Redirect to cart option
                if ( typeof wc_add_to_cart_params == 'undefined' || typeof wc_add_to_cart_params == undefined || wc_add_to_cart_params.cart_redirect_after_add === 'yes' ) {
                    window.location = wc_add_to_cart_params.cart_url;
                    return;
                }

                if ( ! response ) {
                    return;
                }

                if ( response.error && response.product_url ) {
                    window.location = response.product_url;
                    return;
                }

                var $thisbutton = form.find('.single_add_to_cart_button'); //
                var $thisbutton = null; // uncomment this if you don't want the 'View cart' button

                // Trigger event so themes can refresh other areas.
                $( document.body ).trigger( 'added_to_cart', [ response.fragments, response.cart_hash, $thisbutton ] );

                btn.removeClass('loading');

                // Add new notices
                $('.styler-shop-popup-notices').addClass('active');
                $('.styler-shop-popup-notices-wrapper').html(response.fragments.notices_html);
                //
                if ( $('.styler-shop-popup-notices-wrapper .woocommerce-error').length ) {
                    $('.styler-shop-popup-notices').addClass('styler-notices-has-error');
                }

                setTimeout(function() {
                    if ( !$('.styler-shop-popup-notices-wrapper .woocommerce-error').length ) {
                        $('.styler-shop-popup-notices').removeClass('active');
                    }
                }, 2000);

                //form.unblock();
            }
        });
    });

    // AJax single add to cart notices
    $(document).on('click', 'a.ajax_add_to_cart', function(e){
        e.preventDefault();

        if ( styler_vars.shop.add_to_cart_notices == false ){
            return;
        }
        var $thisbutton = $(this);

        var formData = new FormData();
        formData.append('add-to-cart', $thisbutton.attr( 'data-product_id' ));

        // Trigger event.
        $( document.body ).trigger( 'adding_to_cart', [ $thisbutton, formData ] );

        // Ajax action.
        $.ajax({
            url: wc_add_to_cart_params.wc_ajax_url.toString().replace( '%%endpoint%%', 'styler_ajax_add_to_cart' ),
            data: formData,
            type: 'POST',
            processData: false,
            contentType: false,
            success: function( response ) {
                if ( ! response ) {
                    return;
                }

                if ( response.error && response.product_url ) {
                    window.location = response.product_url;
                    return;
                }

                // Redirect to cart option
                if ( typeof wc_add_to_cart_params == 'undefined' || typeof wc_add_to_cart_params == undefined || wc_add_to_cart_params.cart_redirect_after_add === 'yes' ) {
                    window.location = wc_add_to_cart_params.cart_url;
                    return;
                }

                $('.woocommerce-notices-wrapper').html(response.fragments.notices_html).parents('.styler-shop-popup-notices').addClass('active');
                setTimeout(function() {
                    $('.styler-shop-popup-notices').removeClass('active');
                }, styler_vars.shop.add_to_cart_notices_duration);
                //Close icon
                $('.styler-panel-close-button').on('click', function(){
                    $(this).closest('.styler-shop-popup-notices').removeClass('active');
                });

                if (response.fragments.notices_html.indexOf('woocommerce-error') > -1)
                {
                    window.stop();
                }
            },
            dataType: 'json'

        });
    });


    // quick shop start

    stylerQuickShopPopup();

    $(document.body).on('styler_quick_shop', function(){
        stylerQuickShopPopup();
    });

    function stylerQuickShopPopup(){

        if ( typeof styler_vars !== 'undefined' && styler_vars.shop.quick_shop != 'yes' ) {
            return;
        }

       $( 'body' ).on('click touch', '.styler-loop-product .ninetheme-quick-shop-btn,.cart-item-details .ninetheme-quick-shop-btn', function(event) {
            event.preventDefault();

            var $this = $(this),
                id    = $this.data('product_id');

            jQuery.magnificPopup.open({
                items           : {
                    src : styler_vars.ajax_url + '?product_id=' + id
                },
                mainClass       : 'mfp-styler-quickshop styler-mfp-slide-bottom',
                removalDelay    : 160,
                overflowY       : 'scroll',
                fixedContentPos : true,
                closeBtnInside  :true,
                tClose          : '',
                closeMarkup     : '<div class="mfp-close styler-panel-close-button"></div>',
                tLoading        : '<span class="loading-wrapper"><span class="ajax-loading"></span></span>',
                type            : 'ajax',
                ajax            : {
                    settings : {
                        type : 'GET',
                        data : {
                            action : 'styler_ajax_quick_shop'
                        }
                    }
                },
                callbacks       : {
                    beforeOpen  : function() {},
                    open        : function() {
                        $('.mfp-preloader').addClass('loading');
                    },
                    ajaxContentAdded: function() {
                        $('.mfp-preloader').removeClass('loading');

                        var variations_form = $('.styler-quickshop-form-wrapper').find('form.cart');

                        variations_form.each( function() {
                          $(this).wc_variation_form().find('.variations select:eq(0)').change();
                          variations_form.trigger('wc_variation_form');
                        });

                        $( 'form.cart' ).on('submit', function(e) {

                            e.preventDefault();

                            var form    = $(this),
                                btn     = form.find('.styler-btn.single_add_to_cart_button'),
                                title   = btn.find('.button-title').text(),
                                added   = btn.data('added-title'),
                                data    = form.serialize();

                                data   += '&action=styler_quick_shop_ajax_add_to_cart';

                            if ( btn.val() ) {
                                data += '&add-to-cart=' + btn.val();
                            }

                            btn.addClass('loading');
                            $('.styler-quickshop-notices-wrapper').removeClass('active');
                            $('.styler-quickshop-notices-wrapper').empty().removeAttr('style');
                            // Trigger event
                            //$( document.body ).trigger('adding_to_cart', [$thisbutton,data]);
                            $.ajax({
                                url     : styler_vars.ajax_url,
                                data    : data,
                                method  : 'POST',
                                success : function( response ) {

                                    if ( ! response ) {
                                        return;
                                    }

                                    // Redirect to cart option
                                    if ( typeof wc_add_to_cart_params == 'undefined' || typeof wc_add_to_cart_params == undefined || wc_add_to_cart_params.cart_redirect_after_add === 'yes' ) {
                                        window.location = wc_add_to_cart_params.cart_url;
                                        return;
                                    }

                                    if ( response.error && response.product_url ) {
                                        window.location = response.product_url;
                                        return;
                                    }

                                    var $thisButton = form.find('.single_add_to_cart_button');
                                    var $thisButton = null; // uncomment this if you don't want the 'View cart' button
                                    var notices = $('.styler-quickshop-notices-wrapper');
                                    var noticeshtml = response.fragments.notices_html;

                                    btn.removeClass('loading');
                                     $( document.body ).trigger( 'added_to_cart', [ response.fragments, response.cart_hash, $thisButton ] );
                                    // Add new notices
                                    $('.styler-quickshop-notices-wrapper').html(noticeshtml);

                                    if ( $('.styler-quickshop-notices-wrapper .woocommerce-error').length ) {
                                        setTimeout(function(){
                                            notices.slideDown();
                                        }, 100 );
                                        $('.styler-quickshop-notices-wrapper .close-error').on('click touch', function(event) {
                                            $(this).parents('.styler-quickshop-notices-wrapper').slideUp();
                                            setTimeout(function(){
                                                notices.empty().removeAttr('style');
                                            }, 500 );
                                        });
                                    }

                                    $('.styler-quickshop-wrapper .styler-btn-reset,.styler-quickshop-wrapper .plus,.styler-quickshop-wrapper .minus').on('click touch', function(event) {
                                        $('.styler-quickshop-notices-wrapper').slideUp();
                                        setTimeout(function(){
                                            notices.empty().removeAttr('style');
                                        }, 500 );
                                        btn.find('.button-title').html(title);
                                    });

                                    if ( $('.styler-quickshop-notices-wrapper .woocommerce-message').length ) {
                                        btn.find('.button-title').html(added);

                                        setTimeout(function(){
                                            if ( !$('.styler-quickshop-notices-wrapper').hasClass('active') ) {
                                                notices.slideDown().addClass('active');
                                            }
                                        }, 500 );

                                        setTimeout(function(){
                                            if ( !$('.styler-quickshop-buttons-wrapper').hasClass('active') ) {
                                                $('.styler-quickshop-buttons-wrapper').slideDown().addClass('active');
                                            }
                                        }, 500 );

                                        $('.styler-quickshop-buttons-wrapper .styler-btn').on('click touch', function(e) {
                                            if ( $(this).hasClass('open-cart-panel') ) {
                                                $('html,body').addClass('styler-overlay-open');
                                                $('.styler-side-panel .active').removeClass('active');
                                                $('.styler-side-panel').addClass('active');
                                                $('.cart-area').addClass('active');
                                            }
                                            if ( $(this).hasClass('open-checkout-panel') ) {
                                                $('html,body').addClass('styler-overlay-open');

                                                $('.styler-side-panel .active').removeClass('active');
                                                $('.styler-side-panel').addClass('active');
                                                $('.cart-area').addClass('active');
                                                $('.styler-side-panel .styler-header-cart-details div[data-name="checkout"]').trigger('click');
                                            }
                                            $.magnificPopup.close();
                                        });
                                    }
                                }
                            });
                        });
                    },
                    beforeClose : function() {},
                    close : function() {},
                    afterClose : function() {}
                }
            });
        });
    }
    // quick shop end

    shopCatsSlider();

    $(document).on('stylerShopInit', function() {
        shopCatsSlider();
        stylerWcProductCats();
    });

    $('.styler-shop-popup-notices .styler-panel-close-button').on('click', function() {
        $('.styler-shop-popup-notices').removeClass('active');
        setTimeout(function(){
            $('.styler-shop-popup-notices').removeClass('styler-notices-has-error');
        }, 1000 );

    });

    function shopCatsSlider() {

        var product_cats = $('.shop-area .slick-slide.product-category');

        if ( product_cats.length ) {
            product_cats.each(function (i, el) {
                $(this).appendTo('.shop-slider-categories .slick-slider');
            });
            var myContainer = $('.shop-slider-categories');
            var mySlick = $('.slick-slider', myContainer);
            mySlick.not('.slick-initialized').slick({
                autoplay: false,
                slidesToShow: 6,
                speed: 500,
                focusOnSelect: true,
                infinite: false,
                prevArrow: '.slide-prev-cats',
                nextArrow: '.slide-next-cats',
                responsive: [
                    {
                        breakpoint: 576,
                        settings: {
                            slidesToShow: 3
                        }
                    },
                    {
                        breakpoint: 768,
                        settings: {
                            slidesToShow: 4
                        }
                    },
                    {
                        breakpoint: 992,
                        settings: {
                            slidesToShow: 5
                        }
                    },
                    {
                        breakpoint: 1200,
                        settings: {
                            slidesToShow: 6
                        }
                    }
                ]
            });
        }
    }

    var viewingItem = $('.styler-product-view'),
        data        = viewingItem.data('product-view'),
        countView   = viewingItem.find('.styler-view-count'),
        current     = 0,
        change_counter;

    function singleProductFakeView() {

        if ( viewingItem.length ) {
            var min    = data.min,
                max    = data.max,
                delay  = data.delay,
                change = data.change,
                id     = data.id;

            if ( !viewingItem.hasClass( 'inited' ) ) {
                if ( typeof change !== 'undefined' && change ) {
                    clearInterval( change );
                }

                current = $.cookie( 'styler_cpv_' + id );

                if ( typeof current === 'undefined' || !current ) {
                    current = Math.floor(Math.random() * max) + min;
                }

                viewingItem.addClass('inited');

                $.cookie('styler_cpv_' + id, current, { expires: 1 / 24, path: '/'} );

                countView.html( current );

            }

            change_counter = setInterval( function() {
                current    = parseInt( countView.text() );

                if ( !current ) {
                    current = min;
                }

                var pm = Math.floor( Math.random() * 2 );
                var others = Math.floor( Math.random() * change + 1 );
                current = ( pm < 1 && current > others ) ? current - others : current + others;
                $.cookie('styler_cpv_' + id, current, { expires: 1 / 24, path: '/'} );

                countView.html( current );

            }, delay);
        }
    }

    singleProductFakeView();

    /**
    * scrollToTop
    */
    function scrollToTop(target,delay,timeout) {
        setTimeout(function(){
            $('html, body').stop().animate({
                scrollTop: target.offset().top - scrollOffset
            }, delay);
        }, timeout );
    }

    if ( $('.styler-product-gallery-main-slider-carousel').length ) {
        var galleryOptionsFull       = $('.styler-product-gallery-main-slider-carousel').data('swiper-options');
            galleryOptionsFull["on"] = {
            beforeInit: function(swiper){
            },
            afterInit: function(swiper){
                stylerProductPopup();
            },
            resize: function(swiper){
                swiper.update();
            }
        };
        var galleryMainFull     = new NTSwiper( '.styler-product-gallery-main-slider-carousel', galleryOptionsFull );

        var $oMainImgFull       = $('.styler-product-gallery-main-slider-carousel .styler-swiper-slide-first img'),
            $oZoomSrc           = $('.styler-product-gallery-main-slider-carousel .styler-swiper-slide-first').data('zoom-img'),
            $oMainSrcFull       = $oMainImgFull.data('src'),
            $oMainSrcSetFull    = $oMainImgFull.data('srcset'),
            $oMainSrcSizesFull  = $oMainImgFull.data('sizes');

        $( document ).on('change','.styler-product-summary .variations_form select', function( e ) {
            var $thisFull      = $(this),
                $formFull      = $thisFull.parents('.variations_form'),
                variationsFull = $formFull.data('product_variations'),
                $oZoomImgFull  = $('.styler-product-gallery-main-slider-carousel .styler-swiper-slide-first img.zoomImg'),
                galleryFull    = $('.styler-product-gallery-main-slider-carousel');

            setTimeout( function() {
                var current_id = $formFull.attr('current-image'),
                    full_src,
                    imageFull,
                    timageFull,
                    srcFull,
                    srcsetFull,
                    sizesFull;

                $.map(variationsFull, function(elementOfArray, indexInArray) {
                    if (elementOfArray.image_id == current_id) {
                        imageFull  = elementOfArray.image;
                        full_src   = imageFull.full_src;
                        srcFull    = imageFull.src;
                        srcsetFull = imageFull.srcset;
                        sizesFull  = imageFull.sizes;
                    }
                });

                if ( current_id ) {
                    $oMainImgFull.attr('src',srcFull);
                    $oMainImgFull.attr('data-src',srcFull);
                    $oZoomImgFull.attr('src',full_src);
                    if ( srcsetFull ) {
                        $oMainImgFull.attr('srcset',srcsetFull);
                    }
                    if ( sizesFull ) {
                        $oMainImgFull.attr('sizes',sizesFull);
                    }

                    setTimeout( function() {
                        if ( !$oMainImgFull.hasClass('swiper-slide-active') ) {
                            $('.styler-product-gallery-main-slider-carousel .swiper-pagination .swiper-pagination-bullet:first').trigger('click');
                        }
                        $('.styler-product-gallery-main-slider-carousel .swiper-slide-active .styler-product-popup').attr('href',srcFull);
                        initZoomFull('reinit',full_src);
                    }, 100, $oMainImgFull,galleryMainFull );

                    if ( styler_vars.shop_single.scrolltop == 'yes' ) {
                        scrollToTop(galleryFull,300,300);
                    }
                }
            }, 50 );

        });

        $( document ).on('click','.styler-product-summary .reset_variations', function( e ) {
            //e.preventDefault();
            var $formFull     = $(this).parents('.variations_form'),
                galleryFull   = $('.styler-product-gallery-main-slider-carousel'),
                $oZoomImgFull = $('.styler-product-gallery-main-slider-carousel .styler-swiper-slide-first img.zoomImg');

            $oMainImgFull.attr('src',$oMainSrcFull);
            $oMainImgFull.attr('data-src',$oMainSrcFull);
            $oZoomImgFull.attr('src',$oZoomSrc);
            if ( $oMainSrcSetFull ) {
                $oMainImgFull.attr('srcset',$oMainSrcSetFull);
            }
            if ( $oMainSrcSizesFull ) {
                $oMainImgFull.attr('sizes',$oMainSrcSizesFull);
            }

            setTimeout( function() {
                if ( !$oMainImgFull.hasClass('swiper-slide-active') ) {
                    $('.styler-product-gallery-main-slider-carousel .swiper-pagination .swiper-pagination-bullet:first').trigger('click');
                }
                $('.styler-product-gallery-main-slider-carousel .swiper-slide-active .styler-product-popup').attr('href',$oZoomSrc);
                initZoomFull('reinit',$oZoomSrc);
            }, 100, $oMainImgFull,galleryMainFull );

            if ( styler_vars.shop_single.scrolltop == 'yes' ) {
                scrollToTop(galleryFull,400,300);
            }
        });

        initZoomFull('load');

        /**
        * Init zoom.
        */
        function initZoomFull($action,$url) {
            if ( 'function' !== typeof $.fn.zoom && !wc_single_product_params.zoom_enabled ) {
                return false;
            }

            var galleryWidthFull = $('.styler-product-gallery-main-slider-carousel .swiper-slide').width(),
                zoomEnabled  = false,
                zoom_options = {
                    touch: false
                };

            if ( 'ontouchstart' in document.documentElement ) {
                zoom_options.on = 'click';
            }

            $('.styler-product-gallery-main-slider-carousel .swiper-slide img').each( function( index, target ) {
                var imageFull = $( target );
                var imageIndex = imageFull.parents('.swiper-slide').data('swiper-slide-index');

                if ( imageFull.attr( 'width' ) > galleryWidthFull ) {
                    if ( $action == 'load' ) {

                        zoom_options.url = imageFull.parent().data('zoom-img');
                        imageFull.wrap('<span class="styler-zoom-wrapper" style="display:inline-block"></span>')
                          .css('display', 'block')
                          .parent()
                          .zoom(zoom_options);
                    } else {
                        imageFull.trigger('zoom.destroy').unwrap();
                        zoom_options.url = imageIndex == 0 ? $url : imageFull.parent().data('zoom-img');
                        imageFull.wrap('<span class="styler-zoom-wrapper" style="display:inline-block"></span>')
                          .css('display', 'block')
                          .parent()
                          .zoom(zoom_options);
                    }
                }
            });
        }
    }

    stylerProductGalleryInit();

    function stylerProductGalleryInit() {
        if ( $('.styler-product-gallery-main-slider').length ) {
            var thumbsOptions  = $('.styler-product-thumbnails').data('swiper-options');
            var galleryThumbs  = new NTSwiper( '.styler-product-thumbnails', thumbsOptions );

            galleryThumbs.on('resize', function(swiper){
                swiper.update();
            });

            var galleryOptions        = $('.styler-product-gallery-main-slider').data('swiper-options');
            galleryOptions["thumbs"]  = {swiper: galleryThumbs};
            galleryOptions["on"]      = {
                transitionEnd : function ( swiper ) {
                    var  active = swiper.realIndex;

                    $( '.styler-product-gallery-main-slider .swiper-slide:not(.swiper-slide-active)' ).each(function () {

                        var iframe = $( this ).find('iframe');

                        if ( iframe.size() ) {
                            iframe[0].contentWindow.postMessage('{"event":"command","func":"' + 'pauseVideo' + '","args":""}', '*');
                        }

                    });

                    $( '.styler-product-gallery-main-slider .swiper-slide-active' ).each(function () {

                        var iframe2 = $( this ).find('iframe');
                        if ( iframe2.size() ) {
                            iframe2[0].contentWindow.postMessage('{"event":"command","func":"' + 'playVideo' + '","args":""}', '*');
                        }
                    });

                    var src = $('.styler-product-gallery-main-slider .swiper-slide-active').data('lightbox');
                    $( '.styler-product-gallery-main-slider .styler-product-popup:not([data-lightbox="'+src+'"])' ).removeClass('active');
                    $( '.styler-product-gallery-main-slider .styler-product-popup[data-lightbox="'+src+'"]' ).addClass('active');
                },
                beforeInit: function(swiper){},
                afterInit: function(swiper){
                    stylerProductPopup();
                },
                observerUpdate: function(swiper){
                },
                resize: function(swiper){}
            };
            var galleryMain = new NTSwiper( '.styler-product-gallery-main-slider', galleryOptions );

            var heightFirstImage = $('.styler-product-thumbnails .styler-swiper-slide-first img').height();
            $('.styler-slide-video-item-icon').css('height', $('.styler-slide-video-item-icon').data('height'));

            var $oMainImg       = $('.styler-product-gallery-main-slider .styler-swiper-slide-first img'),
                $oZoomSrc       = $('.styler-product-gallery-main-slider .styler-swiper-slide-first').data('zoom-img'),
                $oMainSrc       = $oMainImg.data('src'),
                $oMainSrcSet    = $oMainImg.data('srcset'),
                $oMainSrcSizes  = $oMainImg.data('sizes'),
                $oThumbImg      = $('.styler-product-thumbnails .styler-swiper-slide-first img'),
                $oThumbSrc      = $oThumbImg.data('src'),
                $oThumbSrcSet   = $oThumbImg.data('srcset'),
                $oThumbSrcSizes = $oThumbImg.data('sizes');

            $( document ).on('change','.styler-product-summary .variations_form select', function( e ) {
                var $this      = $(this),
                    $form      = $this.parents('.variations_form'),
                    variations = $form.data('product_variations'),
                    $oZoomImg  = $('.styler-product-gallery-main-slider .styler-swiper-slide-first img.zoomImg'),
                    gallery    = $('.styler-product-gallery-main-slider');

                setTimeout( function() {
                    var current_id = $form.attr('current-image'),
                        image,
                        timage,
                        full_src,
                        src,
                        srcset,
                        sizes,
                        tsrc,
                        tsrcset,
                        tsizes;

                    $.map(variations, function(elementOfArray, indexInArray) {
                        if (elementOfArray.image_id == current_id) {
                            image   = elementOfArray.image;
                            src     = image.src;
                            full_src= image.full_src;
                            srcset  = image.srcset;
                            sizes   = image.sizes;
                        }
                    });
                    $.map(variations, function(elementOfArray, indexInArray) {
                        if (elementOfArray.image_id == current_id) {
                            timage  = elementOfArray.image;
                            tsrc    = timage.src;
                            tsrcset = timage.srcset;
                            tsizes  = timage.sizes;
                        }
                    });
                    if ( current_id ) {
                        $oMainImg.attr('src',src);
                        $oMainImg.attr('data-src',src);
                        $oZoomImg.attr('src',full_src);
                        if ( srcset ) {
                            $oMainImg.attr('srcset',srcset);
                        }
                        if ( sizes ) {
                            $oMainImg.attr('sizes',sizes);
                        }
                        $oThumbImg.attr('src',tsrc);
                        if ( tsrcset ) {
                            $oThumbImg.attr('srcset',tsrcset);
                        }
                        if ( tsizes ) {
                            $oThumbImg.attr('sizes',tsizes);
                        }

                        setTimeout( function() {
                            if ( !$oMainImg.hasClass('swiper-slide-active') ) {
                                galleryMain.slideTo(0);
                                galleryThumbs.slideTo(0);
                            }
                            galleryMain.update();
                            galleryMain.updateAutoHeight(10);
                            galleryThumbs.update();
                            $('.styler-product-gallery-popups .styler-product-popup').removeClass('active');
                            $('.styler-product-gallery-popups .styler-product-popup:first-child').addClass('active').attr('href',full_src);
                            initZoom('reinit',full_src);
                        }, 100 );

                        if ( styler_vars.shop_single.scrolltop == 'yes' ) {
                            scrollToTop(gallery,300,300);
                        }
                    }
                }, 50 );
            });

            $( document ).on('click','.styler-product-summary .reset_variations', function( e ) {
                var $form     = $(this).parents('.variations_form'),
                    gallery   = $('.styler-product-gallery-main-slider'),
                    $oZoomImg = $('.styler-product-gallery-main-slider .styler-swiper-slide-first img.zoomImg');

                $oMainImg.attr('src',$oMainSrc);
                $oMainImg.attr('data-src',$oMainSrc);
                $oZoomImg.attr('src',$oZoomSrc);
                if ( $oMainSrcSet ) {
                    $oMainImg.attr('srcset',$oMainSrcSet);
                }
                if ( $oMainSrcSizes ) {
                    $oMainImg.attr('sizes',$oMainSrcSizes);
                }

                $oThumbImg.attr('src',$oThumbSrc);
                if ( $oThumbSrcSet ) {
                    $oThumbImg.attr('srcset',$oThumbSrcSet);
                }
                if ( $oThumbSrcSizes ) {
                    $oThumbImg.attr('sizes',$oThumbSrcSizes);
                }

                setTimeout( function() {
                    if ( !$oMainImg.hasClass('swiper-slide-active') ) {
                        galleryMain.slideTo(0);
                        galleryThumbs.slideTo(0);
                    }
                    galleryMain.update();
                    galleryMain.updateAutoHeight(10);
                    galleryThumbs.update();
                    $('.styler-product-gallery-popups .styler-product-popup').removeClass('active');
                    $('.styler-product-gallery-popups .styler-product-popup:first-child').attr('href',$oMainSrc).addClass('active');
                    initZoom('reinit',$oZoomSrc);
                }, 100 );

                if ( styler_vars.shop_single.scrolltop == 'yes' ) {
                    scrollToTop(gallery,400,300);
                }
            });

            initZoom('load');

            /**
            * Init zoom.
            */
            function initZoom($action,$url) {
                if ( 'function' !== typeof $.fn.zoom && !wc_single_product_params.zoom_enabled ) {
                    return false;
                }

                var galleryWidth = $('.styler-product-gallery-main-slider .swiper-slide').width(),
                    zoomEnabled  = false,
                    zoom_options = {
                        touch: false
                    };

                if ( 'ontouchstart' in document.documentElement ) {
                    zoom_options.on = 'click';
                }

                $('.styler-product-gallery-main-slider .swiper-slide img').each( function( index, target ) {
                    var image = $( target );
                    var imageIndex = image.parents('.swiper-slide');

                    if ( image.attr( 'width' ) > galleryWidth ) {
                        if ( $action == 'load' ) {
                            zoom_options.url = image.parent().data('zoom-img');
                            image.wrap('<span class="styler-zoom-wrapper" style="display:block"></span>')
                              .css('display', 'block')
                              .parent()
                              .zoom(zoom_options);
                        } else {
                            image.trigger('zoom.destroy').unwrap();
                            zoom_options.url = imageIndex.hasClass('styler-swiper-slide-first') ? $url : image.parent().data('zoom-img');
                            image.wrap('<span class="styler-zoom-wrapper" style="display:block"></span>')
                              .css('display', 'block')
                              .parent()
                              .zoom(zoom_options);
                        }
                    }
                });
            }
        }
    }

    /**
    * singleGalleryGridVariations
    */
    singleGalleryGridVariations();
    function singleGalleryGridVariations() {
        if ( !$('.styler-product-main-gallery-grid .styler-gallery-grid-item-first img').length ) {
            return;
        }
        var $oMainImg       = $('.styler-product-main-gallery-grid .styler-gallery-grid-item-first img'),
            $oMainSrc       = $oMainImg.data('src'),
            $oMainSrcSet    = $oMainImg.data('srcset'),
            $oMainSrcSizes  = $oMainImg.data('sizes'),
            gallery         = $('.styler-product-main-gallery-grid');

        $( document ).on('change','.styler-product-summary .variations_form select', function( e ) {
            var $this      = $(this),
                $form      = $this.parents('.variations_form'),
                variations = $form.data('product_variations');

            setTimeout( function() {
                var current_id = $form.attr('current-image'),
                    image,
                    src,
                    srcset,
                    sizes;

                $.map(variations, function(elementOfArray, indexInArray) {
                    if ( elementOfArray.image_id == current_id ) {
                        image  = elementOfArray.image;
                        src    = image.src;
                        srcset = image.srcset;
                        sizes  = image.sizes;
                    }
                });
                if ( current_id ) {
                    $oMainImg.attr('src',src);
                    $oMainImg.attr('data-src',src);
                    if ( srcset ) {
                        $oMainImg.attr('srcset',srcset);
                    }
                    if ( sizes ) {
                        $oMainImg.attr('sizes',sizes);
                    }
                    if ( styler_vars.shop_single.scrolltop == 'yes' ) {
                        scrollToTop(gallery,300,300);
                    }
                    $('.styler-gallery-grid-item-first .styler-product-popup').attr('href',src);
                }

            }, 50 );
        });

        $( document ).on('click','.styler-product-summary .reset_variations', function( e ) {
            //e.preventDefault();
            var $form     = $(this).parents('.variations_form'),
                gallery   = $('.styler-product-main-gallery-grid');

            $oMainImg.attr('src',$oMainSrc);
            $oMainImg.attr('data-src',$oMainSrc);

            if ( $oMainSrcSet ) {
                $oMainImg.attr('srcset',$oMainSrcSet);
            }
            if ( $oMainSrcSizes ) {
                $oMainImg.attr('sizes',$oMainSrcSizes);
            }
            if ( styler_vars.shop_single.scrolltop == 'yes' ) {
                scrollToTop(gallery,400,300);
            }
            $('.styler-gallery-grid-item-first .styler-product-popup').attr('href',$oMainSrc);
        });
    }

    $( '.styler-product-gallery-main-slider .swiper-slide img, .styler-zoom-wrapper' ).on('click', function( e ) {
        var videoPopup = $(this).parents('.styler-product-gallery-main-slider').find('.styler-product-video-button');
        var imgPopup = $(this).parents('.styler-product-gallery-main-slider').find('.styler-product-popup');
        if ( videoPopup.length > 0 ) {
            videoPopup.trigger('click');
        } else {
            imgPopup.trigger('click');
        }
    });

    /**
    * multiStepCheckout
    */
    multiStepCheckout();
    function multiStepCheckout() {
        var $body               = $('body'),
            login               = $('.styler-woocommerce-checkout-login'),
            billing             = $('.styler-customer-billing-details'),
            shipping            = $('.styler-customer-shipping-details'),
            order               = $('.styler-order-review'),
            payment             = $('.styler-payment'),
            form_actions        = $('.styler-form-actions'),
            coupon              = $('.styler-checkout-coupon'),
            timeline            = $(),
            steps               = new Array(login, billing, shipping, order, payment),
            is_user_logged_in   = $body.hasClass('logged-in');

        $body.on( 'updated_checkout styler_multistep_myaccount_order_pay', function(e) {
            steps[4] = $('#payment');
            if(e.type == 'updated_checkout' ) {
                steps[4] = $('#payment');
            }
            $('#payment').find( 'input[name=payment_method]' ).on( 'click', function() {
                if ($('.payment_methods input.input-radio').length > 1) {
                    var target_payment_box = $('div.payment_box.' + $(this).attr('ID'));
                    if ($(this).is(':checked') && !target_payment_box.is(':visible')) {
                        $('div.payment_box').filter(':visible').slideUp(250);

                        if ($(this).is(':checked')) {
                            $('div.payment_box.' + $(this).attr('ID')).slideDown(250);
                        }
                    }
                } else {
                    $('div.payment_box').show();
                }

                if ($(this).data('order_button_text')) {
                    $('#place_order').val($(this).data('order_button_text'));
                } else {
                    $('#place_order').val($('#place_order').data('value'));
                }
            });
        } );

        if ($body.hasClass('woocommerce-order-pay')) {
            $body.trigger('styler_multistep_myaccount_order_pay');
        }

        $body.on('styler_multistep_select2', function (event) {
            if ($().select2) {
                var wc_country_select_select2 = function () {
                    $('select.country_select, select.state_select').each(function () {
                        var select2_args = {
                            placeholder      : $(this).attr('placeholder'),
                            placeholderOption: 'first',
                            width            : '100%'
                        };

                        $(this).select2(select2_args);
                    });
                };

                wc_country_select_select2();

                $body.bind('country_to_state_changed', function () {
                    wc_country_select_select2();
                });
            }
        });

        $body.trigger('styler_multistep_select2');

        if ( $('.styler-checkout-content').length ) {

            var checkoutMultiSteps = new NTSwiper('.styler-checkout-content', {
                loop          : false,
                speed         : 500,
                spaceBetween  : 10,
                autoHeight    : true,
                nested        : true,
                simulateTouch : false,
                navigation    : {
                    nextEl: '.styler-checkout-content .styler-checkout-button-next',
                    prevEl: '.styler-checkout-content .styler-checkout-button-prev'
                },
                on: {
                    resize: function () {
                        var swiper = this;
                        swiper.update();
                    },
                    slideChange: function () {
                        var swiper = this;
                        var realIndex = swiper.realIndex;
                        $( '.styler-step-item:not(:eq('+realIndex+'))' ).addClass('active');
                        $( '.styler-step-item:eq('+realIndex+')' ).next().removeClass('active');
                        $( '.styler-step-item:eq('+realIndex+')' ).next().next().removeClass('active');
                    }
                },
                effect: 'slide',
                creativeEffect: {
                    prev: { translate: [0, 0, -400] },
                    next: { translate: ['100%', 0, 0] }
                },
                pagination: {
                    el: ".styler-page-multistep-checkout .styler-swiper-pagination",
                    type: 'bullets',
                    bulletClass: 'styler-bullets',
                    bulletClass: 'styler-current',
                    bulletActiveClass: 'active',
                    clickable: true,
                    renderBullet: function (index, className) {
                        var labels = $('.styler-page-multistep-checkout .styler-swiper-pagination').data('steps-labels');
                        return '<div class="styler-step-item styler-step-item-' + (index + 1) + ' ' + className + '"><span class="styler-step">' + (index + 1) + '</span><span class="styler-step-label styler-login">' + labels.labels[(index)] + '</span></div>';
                    }
                }
            });

            var checkoutLoginSteps = new NTSwiper('.styler-checkout-form-login', {
                loop          : false,
                speed         : 500,
                spaceBetween  : 5,
                autoHeight    : true,
                simulateTouch : false,
                navigation    : {
                    nextEl: '.styler-checkout-form-login .styler-checkout-form-button-register',
                    prevEl: '.styler-checkout-form-login .styler-checkout-form-button-login'
                },
                on: {
                    resize: function () {
                        var swiper = this;
                        swiper.update();
                    }
                },
                effect: 'slide',
                creativeEffect: {
                    prev: { translate: [0, 0, -400] },
                    next: { translate: ['100%', 0, 0] }
                }
            });

            $('body').on('input validate change', '.input-text, select, input:checkbox', function(e){
                var $this       = $( this ),
                    $parent     = $this.closest( '.form-row' ),
                    event_type  = e.type;

                if ( 'validate' === event_type && $parent.hasClass( 'woocommerce-invalid-required-field' ) ) {

                    $( '.woocommerce-billing-fields .woocommerce-invalid-required-field' ).parents('.swiper-slide').addClass( 'has-error' );

                    setTimeout(function(){
                        var getInvalidSection = $( '.swiper-slide.has-error' ).index();
                        checkoutMultiSteps.slideTo(getInvalidSection);
                        checkoutMultiSteps.updateAutoHeight(10);
                    }, 300 );

                    if ( $('.woocommerce-NoticeGroup').length ) {
                        var $targetFirst = $('.woocommerce-NoticeGroup .woocommerce-error li:first-child').data('id'),
                            $targetFirstEl = $('#'+$targetFirst+'_field');
                    }
                }
            });
        }
    }

    panelPopupCheckOut();
    function panelPopupCheckOut() {
        $('body').on('click', '.styler-side-panel .styler-btn[data-name="checkout"]', function () {
            $('.styler-side-panel .panel-content-item').removeClass('active');
            $('.styler-side-panel .panel-header-btn').removeClass('active');
            $('.styler-side-panel .panel-content-item[data-name="checkout"]').addClass('active');
        });
        $('.minicart-panel .styler-btn[data-name="checkout"]').on('click', function () {
            $('.styler-header-mobile, .styler-header-mobile .action-content').removeClass('active');
            $('.top-action-btn[data-name="cart"]').trigger('click');
            $('.styler-side-panel .styler-btn[data-name="checkout"]').off("click").trigger('click');
        });
        $('.styler-side-panel .styler-panel-close,.styler-side-panel .panel-header-btn,.styler-header-overlay').on('click', function () {
            if ( $('.checkout-area.panel-content-item').length ) {
                setTimeout(function(){
                    $( '.styler-panel-checkout-button-prev' ).trigger( 'click' );
                }, 500 );
            }
        });
    }

    $( document.body ).on('close_woocommerce_error checkout_error applied_coupon_in_checkout removed_coupon_in_checkout',function(){
        closeCheckoutNotices();
    });

    function closeCheckoutNotices() {
        $('ul.woocommerce-error .close-error').on('click',function(){
            $('ul.woocommerce-error').fadeOut();
            $('ul.woocommerce-error .close-error').remove();
        });
    }

    if ( $('.checkout-area.panel-content-item').length ) {

        if ( $('.checkout-area form.checkout.woocommerce-checkout').length ) {
            var sidePanelHeight = $('.styler-side-panel').height();
            var checkForm = $('.panel-content .checkout-area form.checkout.woocommerce-checkout').position();
            var checkFormTop = checkForm.top;
            var checkFormMaxHeight = (sidePanelHeight - checkFormTop) - 70;
            var orderHeight = $( '[data-target-name="order"]' ).height();

            var checkoutFormsWrapper     = $('.styler-panel-checkout-form-wrapper');
            var billingFormsWrapper      = $('.checkout-area .styler-customer-billing-details');
            var billingFormsValidateReq  = $('.checkout-area .styler-customer-billing-details .validate-required');
            var shippingFormsWrapper     = $('.checkout-area .styler-customer-shipping-details');
            var shippingFormsValidateReq = $('.checkout-area .styler-customer-shipping-details .validate-required');
            var shippingFormsIsCheck     = $( '#ship-to-different-address-checkbox' );
            var stepBilling              = $( '.checkout-area .styler-step-item-1' );
            var stepOrder                = $( '.checkout-area .styler-step-item-2' );
            var stepOrderButton          = $( '.checkout-area .styler-panel-checkout-button-next' );
            var stepBillingButton        = $( '.checkout-area .styler-panel-checkout-button-prev' );
            var billingFields            = $( '[data-target-name="billing"]' );
            var orderFields              = $( '[data-target-name="order"]' );

            function checkPanelShippingFields() {
                if ( shippingFormsIsCheck.is( ':checked' ) ) {
                    shippingFormsValidateReq.find('.input-text, select, input[type="checkbox"]').each(function () {
                        var $this = $( this );
                        if ( $this.val() == '' || $this.val() == null || $this.parents('.form-row.validate-required').hasClass( 'has-error' ) ) {
                            shippingFormsWrapper.addClass( 'has-error' );
                            return false;
                        } else {
                            shippingFormsWrapper.removeClass( 'has-error' );
                        }
                    });
                } else {
                    shippingFormsWrapper.removeClass( 'has-error' );
                }
            }
            function checkPanelBillingFields() {
                billingFormsValidateReq.find('.input-text, select, input:checkbox').each(function () {
                    var $this = $( this );
                    if ( $this.val() == '' || $this.val() == null || $this.parents('.validate-required').hasClass( 'has-error' ) ) {
                        $this.attr("placeholder", styler_vars.strings.form.required).blur();
                        billingFormsWrapper.addClass( 'has-error' );
                        return false;
                    } else {
                        billingFormsWrapper.removeClass( 'has-error' );
                    }
                });
            }

            $(document.body).on('country_to_state_changed',function(){
                billingFormsValidateReq.find('.input-text, select, input:checkbox').each(function () {
                    var $this = $( this );
                    if ( $this.val() == '' || $this.val() == null || $this.parents('.validate-required').hasClass( 'has-error' ) ) {
                        $this.parents('.validate-required').addClass( 'has-error' );
                        billingFormsWrapper.addClass( 'has-error' );
                        return false;
                    } else {
                        $this.parents('.validate-required').removeClass( 'has-error' );
                        billingFormsWrapper.removeClass( 'has-error' );
                    }
                });
                if ( shippingFormsIsCheck.is( ':checked' ) ) {
                    shippingFormsValidateReq.find('.input-text, select, input[type="checkbox"]').each(function () {
                        var $this = $( this );
                        if ( $this.val() == '' || $this.val() == null || $this.parents('.form-row.validate-required').hasClass( 'has-error' ) ) {
                            $this.parents('.validate-required').addClass( 'has-error' );
                            shippingFormsWrapper.addClass( 'has-error' );
                            return false;
                        } else {
                            $this.parents('.validate-required').removeClass( 'has-error' );
                            shippingFormsWrapper.removeClass( 'has-error' );
                        }
                    });
                } else {
                    shippingFormsWrapper.removeClass( 'has-error' );
                }
            });

            checkPanelShippingFields();
            checkPanelBillingFields();

            $('body').on('styler_panel_input_change',function(){
                checkPanelShippingFields();
                checkPanelBillingFields();
            });
            stepOrder.removeClass( 'active-step' );
            stepBillingButton.on('click',function(){
                orderFields.slideUp();
                billingFields.slideDown(1000);
                stepOrder.removeClass( 'active-step' );
                stepBilling.removeClass( 'active-step' ).addClass( 'active-step' );
            });

            stepOrderButton.on('click',function(){
                $('body').trigger('styler_panel_input_change');
                if (billingFormsWrapper.hasClass( 'has-error' ) || ( shippingFormsIsCheck.is( ':checked' ) && shippingFormsWrapper.hasClass( 'has-error' ) ) ) {
                    //stepOrder.removeClass( 'active-step' ).addClass( 'disabled' );
                    //stepOrderButton.addClass( 'disabled' );
                    //stepBilling.removeClass( 'active-step' ).addClass( 'active-step' );
                    return;
                } else {
                    billingFields.slideUp();
                    orderFields.slideDown(1000);
                    //stepOrder.addClass( 'active-step' ).removeClass( 'disabled' );
                    stepBilling.removeClass( 'active-step' );
                    $('.styler-panel-checkout-form-wrapper.styler-perfect-scrollbar').stop().animate({
                        scrollTop: $('.styler-panel-checkout-form-wrapper.styler-perfect-scrollbar').position().top
                    }, 800);
                }
            });
            $('.checkout-area form.woocommerce-checkout').on('submit',function(){

                setTimeout(function(){
                    if ( $('.checkout-area ul.woocommerce-error li[data-id]').length ) {

                        var errorItemId = $('.checkout-area ul.woocommerce-error li:first-child').data('id');

                        $('.checkout-area #'+errorItemId+'_field' ).parents('.styler-panel-checkout-content-inner').addClass('has-error');

                        if ( $('.checkout-area .styler-panel-checkout-content-inner[data-target-name="billing"]').hasClass('has-error') ) {
                            $('.styler-panel-checkout-button-prev').trigger('click');
                        }

                        setTimeout(function(){
                            var targetError = $('.checkout-area #'+errorItemId ).position();
                            $('.checkout-area #'+errorItemId+'_field' ).addClass('has-error');
                            $('.styler-panel-checkout-form-wrapper').stop().animate({
                                scrollTop: targetError.top
                            }, 800);
                        }, 500, errorItemId );
                    }
                    $('body').trigger('close_woocommerce_error');

                }, 1500 );
            });

            $('body').on('input validate change', '.checkout-area .styler-customer-billing-details .input-text,.checkout-area .styler-customer-billing-details select,.checkout-area .styler-customer-billing-details input:checkbox', function(e){
                var $this       = $( this ),
                $id         = $this.attr( 'id' ),
                $parent     = $this.closest( '.form-row.validate-required' ),
                event_type  = e.type;
                if ( 'change' === event_type ) {

                    $parent.each(function () {
                        var $this = $( this );
                        if ( $this.hasClass( 'woocommerce-invalid-required-field' ) || $this.val() == null ) {
                            $this.addClass( 'has-error' );
                        } else {
                            $this.removeClass( 'has-error' );
                            //stepOrder.removeClass( 'disabled' );
                            //stepOrderButton.removeClass( 'disabled' );
                            $('.checkout-area ul.woocommerce-error li[data-id="'+$id+'"]').remove();
                        }
                        $('body').trigger('styler_panel_input_change');
                        if ( billingFormsWrapper.hasClass( 'has-error' ) ) {
                            //stepOrder.removeClass( 'active-step' ).addClass( 'disabled' );
                            //stepOrderButton.addClass( 'disabled' );
                            var targetErrorAnother = $this.closest( '.styler-customer-billing-details' ).find('.has-error');
                            var targetError = $this.hasClass( 'has-error' ) ? $this.position() : $(targetErrorAnother).position();

                            if ( targetError ) {
                                setTimeout(function(){
                                    checkoutFormsWrapper.stop().animate({
                                        scrollTop: targetError.top
                                    }, 800);
                                }, 400 );
                                return false;
                            }

                        }
                    });
                }
            });

            $('body').on('input validate change', '.checkout-area .styler-customer-shipping-details .input-text,.checkout-area .styler-customer-shipping-details select,.checkout-area .styler-customer-shipping-details input:checkbox', function(e){
                var $this       = $( this ),
                $parent     = $this.closest( '.form-row.validate-required' ),
                event_type  = e.type;

                if ( 'change' === event_type ) {

                    $parent.each(function () {
                        var $this = $( this );
                        if ( $this.hasClass( 'woocommerce-invalid-required-field' ) || $this.val() == null ) {
                            $this.addClass( 'has-error' );
                        } else {
                            $this.removeClass( 'has-error' );
                            //stepOrder.removeClass( 'disabled' );
                            //stepOrderButton.removeClass( 'disabled' );
                        }
                    });

                    if ( shippingFormsWrapper.hasClass( 'has-error' ) ) {
                        //stepOrder.removeClass( 'active-step' ).addClass( 'disabled' );
                        //stepOrderButton.addClass( 'disabled' );
                        var targetError = shippingFormsWrapper.find('.has-error').position();
                        if ( targetError ) {
                            setTimeout(function(){
                                checkoutFormsWrapper.stop().animate({
                                    scrollTop: targetError.top
                                }, 800);
                            }, 400 );
                            return false;
                        }
                    } else {
                        if ( billingFormsWrapper.hasClass( 'has-error' ) ) {
                            //stepOrder.removeClass( 'active-step' ).addClass( 'disabled' );
                            //stepOrderButton.addClass( 'disabled' );
                            var targetError = billingFormsWrapper.find('.has-error').position();

                            if ( targetError ) {
                                setTimeout(function(){
                                    checkoutFormsWrapper.stop().animate({
                                        scrollTop: targetError.top
                                    }, 800);
                                }, 400 );
                                return false;
                            }

                        } else {
                            //stepOrderButton.removeClass( 'disabled' );
                        }
                    }
                }

            });

            setTimeout(function(){
                orderFields.slideUp();
            }, 400 );
        }
    }


    panelMinicartButtonsStatus();
    function panelMinicartButtonsStatus() {
        if ( styler_vars.shop_page == 'cart' || styler_vars.shop_page == 'checkout' ) {
            setTimeout(function(){
                //$('.header-cart-footer .cart-bottom-btn').html(styler_vars.minicart_buttons);
            }, 1500 );
        }
    }

    $(document.body).on('added_to_cart removed_from_cart updated_cart_totals', function(){
        $(document.body).trigger("update_checkout");
        $(".styler-product-bottom-popup-cart").removeClass('active');
        panelPopupCheckOut();
        panelMinicartButtonsStatus();
    });

    if ( $('.woocommerce-error').length ) {
        $('.styler-is-required').each(function () {
            if ( typeof styler_vars !== 'undefined' && styler_vars ) {
                var message = styler_vars.strings.form.required;
                $( this ).addClass('styler-invalid').find( '.styler-form-message' ).html(message);
            }
        });
    }

    var myAccountFormSteps = new NTSwiper('.styler-myaccount-steps-register', {
        loop          : false,
        speed         : 500,
        spaceBetween  : 0,
        autoHeight    : false,
        simulateTouch : false,
        observer      : true,
        observerChildren      : true,
        navigation    : {
            nextEl: '.styler-myaccount-steps-register .styler-myaccount-form-button-register',
            prevEl: '.styler-myaccount-steps-register .styler-myaccount-form-button-login'
        },
        on: {
            resize: function () {
                var swiper = this;
                swiper.update();
            }
        },
        effect: 'slide'
    });

    $('body').on('styler_myaccount_steps_register', function(){
        myAccountFormSteps.update();
    });


    var singleCartPos = $('.styler-product-summary .single_add_to_cart_button').offset();
    var singleCartTop = $('.styler-product-summary .single_add_to_cart_button').length && $(".styler-product-bottom-popup-cart").length ? singleCartPos.top : 0;
    var singleDocHeight = $(document).height() - 25;

    $(window).on("scroll", function () {

        if ( $(".styler-product-bottom-popup-cart").length && $(".styler-product-summary .single_add_to_cart_button").length ) {

            if ( $(window).scrollTop() > singleCartTop ) {
                $(".styler-product-bottom-popup-cart").addClass('active');
                $("body").addClass('bottom-popup-cart-active');
            } else {
                $(".styler-product-bottom-popup-cart").removeClass('active');
                $("body").removeClass('bottom-popup-cart-active');
            }
            if($(window).scrollTop() + $(window).height() > singleDocHeight ) {
                $(".styler-product-bottom-popup-cart").addClass('relative');
            } else {
                $(".styler-product-bottom-popup-cart").removeClass('relative');
            }
        }

    });

    if ( typeof styler_vars !== 'undefined' && styler_vars ) {
        var colors = styler_vars.shop.swatches_color;

        $('.woocommerce-widget-layered-nav-list li a').each(function () {
            var $this = $(this);
            var title = $this.html();
            for (var i in colors) {
                if ( title == i ) {
                    var is_white = colors[i] == '#fff' || colors[i] == '#ffffff' ? ' is_white' : '';
                    var color = '<span class="styler-swatches-widget-color-item'+is_white+'" style="background-color: '+colors[i]+';"></span>';
                    $this.prepend(color);
                }
            }
        });
    }

    if ($('body').hasClass('woocommerce-checkout') || $('body').hasClass('woocommerce-cart')) {
        $('.styler-woocommerce-cart-form .product-remove').on('click touch', function(event) {
            $(this).addClass('loading');
        });
    }

});

})(window, document, jQuery);
