<?php

if ( ! function_exists( 'styler_header_cart_totals_fragment' ) ) {
    add_filter('woocommerce_add_to_cart_fragments', 'styler_header_cart_totals_fragment');
    function styler_header_cart_totals_fragment( $fragments )
    {
        global $woocommerce;
        ob_start();

        echo'<span class="styler-cart-total">';
        if ( WC()->cart->cart_contents_total ) {
            echo WC()->cart->get_cart_subtotal();
        }
        echo'</span>';

        $fragments['span.styler-cart-total'] = ob_get_clean();
        return $fragments;
    }
}
if ( ! function_exists( 'styler_header_cart_count_fragment' ) ) {
    add_filter('woocommerce_add_to_cart_fragments', 'styler_header_cart_count_fragment');
    function styler_header_cart_count_fragment( $fragments )
    {
        global $woocommerce;
        ob_start();

        echo'<span class="styler-cart-count styler-wc-count">';
            echo esc_html( $woocommerce->cart->cart_contents_count );
        echo'</span>';

        $fragments['span.styler-cart-count'] = ob_get_clean();
        return $fragments;
    }
}

if ( ! function_exists( 'styler_header_add_to_cart_content' ) ) {
    add_filter( 'woocommerce_add_to_cart_fragments', 'styler_header_add_to_cart_content' );
    function styler_header_add_to_cart_content( $fragments )
    {
        ob_start();
        get_template_part('woocommerce/minicart/minicart');
        $fragments['div.minicart-panel'] = ob_get_clean();
        return $fragments;
    }
}


if ( ! function_exists( 'styler_side_panel_cart_content' ) ) {
    add_action( 'styler_before_wp_footer', 'styler_side_panel_cart_content' );
    function styler_side_panel_cart_content()
    {
        $autoopen = '1' == styler_settings('disable_right_panel_auto', '0' ) ? ' disable-auto-open' : '';
        ?>
        <div class="styler-side-panel<?php echo esc_attr( $autoopen ); ?>">
            <div class="panel-header">
                <div class="styler-panel-close styler-panel-close-button"></div>
                <div class="panel-header-actions">

                    <div class="panel-header-cart panel-header-btn" data-name="cart">
                        <span class="styler-cart-count styler-wc-count"></span>
                        <?php echo styler_svg_lists( 'bag', 'styler-svg-icon' ); ?>
                        <span class="styler-cart-total"></span>
                    </div>

                    <?php do_action( 'styler_side_panel_header_after_cart' ); ?>

                </div>
            </div>

            <div class="panel-content">

                <div class="cart-area panel-content-item active" data-name="cart">
                    <div class="cart-content">
                        <?php get_template_part('woocommerce/minicart/minicart'); ?>
                    </div>
                </div>

                <?php do_action( 'styler_side_panel_content_after_cart' ); ?>

                <?php if ( ! is_cart() && ! is_checkout()  ) {
                     if ( '1' == styler_settings('panel_checkout_visibility', '1' ) ) { ?>
                    <div class="checkout-area panel-content-item" data-name="checkout">
                        <div class="checkout-content">
                            <?php wc_get_template_part( 'checkout/multistep-form-checkout-sidepanel' ); ?>
                        </div>
                    </div>
                <?php } }  ?>

            </div>
            <div class="panel-footer"></div>
        </div>
        <?php
    }
}
